/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnnotationLayer } from "./AnnotationLayer";
import { Axis } from "./Axis";
import { DependencyProperty } from "igniteui-angular-core";
import { CategoryTooltipLayerPosition_$type } from "./CategoryTooltipLayerPosition";
import { CategoryToolTipLayerFrame } from "./CategoryToolTipLayerFrame";
import { Base, enumGetBox, typeCast, fromEnum, Point_$type, markType, markDep, String_$type } from "igniteui-angular-core";
import { Series } from "./Series";
import { CategoryTooltipSeriesInfo } from "./CategoryTooltipSeriesInfo";
import { XamDataChart } from "./XamDataChart";
import { List$1 } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { Size } from "igniteui-angular-core";
import { DeviceUtils } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { PointerTooltip } from "./PointerTooltip";
/**
 * @hidden
 */
export let CategoryToolTipLayer = /*@__PURE__*/ (() => {
    class CategoryToolTipLayer extends AnnotationLayer {
        constructor() {
            super();
            let a = new CategoryToolTipLayerFrame();
            let b = new CategoryToolTipLayerFrame();
            let c = new CategoryToolTipLayerFrame();
            this.p6 = a;
            this.p5 = b;
            this.p7 = c;
            this.ab = CategoryToolTipLayer.$;
        }
        get_db() {
            return true;
        }
        bx() {
            return new CategoryToolTipLayerView(this);
        }
        lz(a) {
            super.lz(a);
            this.ra = a;
        }
        get_dk() {
            return true;
        }
        l4(a, b, c, d) {
            super.l4(a, b, c, d);
            switch (b) {
                case CategoryToolTipLayer.$$p[0]:
                    this.mi(true);
                    break;
                case CategoryToolTipLayer.$$p[2]:
                    this.mi(true);
                    break;
                case CategoryToolTipLayer.$$p[1]:
                    this.mi(true);
                    break;
                case "SeriesViewer":
                    this.ra.cf();
                    break;
            }
        }
        qo(a, b) {
            if (this.q8 == a) {
                if (!this.as.c) {
                    this.mi(b);
                }
            }
        }
        qp(a, b) {
            if (!this.as.c) {
                this.mi(b);
            }
        }
        qr(a, b) {
            super.qr(a, b);
            let c = a;
            let d = this.rc;
            c.l = NaN;
            c.k = NaN;
            c.g = NaN;
            c.h = NaN;
            c.k = NaN;
            c.l = NaN;
            if (isNaN_(this.q5.x) && isNaN_(this.q5.y)) {
                this.ra.cd(this.ra.ca());
                return;
            }
            if (this.q8 != null) {
                let e = this.q8;
                if (e == null || !e.ca || e.b8) {
                    return;
                }
                if (!e.cn()) {
                    return;
                }
                let f = e;
                let g = this.rb(f.dd, d);
                this.rh(g, c, d);
            }
            else {
                if (typeCast(XamDataChart.$, this.cd) !== null) {
                    let h = this.cd;
                    let i = true;
                    let j = false;
                    let k = new List$1(Series.$, 0);
                    for (let l of fromEnum(h.axes)) {
                        if (l.ca && !l.b8) {
                            if (!l.cn()) {
                                continue;
                            }
                            if (i) {
                                i = false;
                                j = l.co;
                            }
                            else {
                                if (l.co != j) {
                                    continue;
                                }
                            }
                            for (let m of fromEnum(l.dd)) {
                                k.add(m);
                            }
                        }
                    }
                    let n = this.rb(k, d);
                    this.rh(n, c, d);
                }
            }
        }
        rb(a, b) {
            let c = 1.7976931348623157E+308;
            let d = -1.7976931348623157E+308;
            let e = new List$1(DataContext.$, 0);
            let f = new List$1(Base.$, 0);
            let g = false;
            let h = true;
            for (let i = 0; i < a.count; i++) {
                let j = a.item(i);
                if (!j.dp && !j.dg) {
                    continue;
                }
                if (j.isStacked) {
                    continue;
                }
                let k = j;
                if (!k.categoryAxis.cn()) {
                    continue;
                }
                if (h) {
                    g = j.isVertical;
                }
                else {
                    if (g != j.isVertical) {
                        continue;
                    }
                }
                let l = this.qk(j);
                if (!l.c) {
                    continue;
                }
                let m = j.pm(l.d, b, false);
                if (g) {
                    if (!isNaN_(m.y)) {
                        c = Math.min(c, m.y);
                        d = Math.max(d, m.y);
                    }
                }
                else {
                    if (!isNaN_(m.x)) {
                        c = Math.min(c, m.x);
                        d = Math.max(d, m.x);
                    }
                }
                let n = this.rd(j);
                if (n == null) {
                    continue;
                }
                let o = null;
                let p = j.ht(this.q5);
                if (j.dl && p != null) {
                    o = j.au(p);
                }
                else {
                    o = new DataContext();
                    o.item = p;
                    o.series = j;
                }
                e.add(o);
                f.add1(n);
            }
            let q = 0;
            let r = 0;
            if (g) {
                r = (c + d) / 2;
                q = this.pz.right;
                if (this.q9 == 2 || this.q9 == 1) {
                    q = this.pz.left;
                }
                if (r < 0 || r > this.pz.bottom) {
                    r = NaN;
                }
            }
            else {
                q = (c + d) / 2;
                r = this.pz.top;
                if (this.q9 == 2 || this.q9 == 1) {
                    r = this.pz.bottom;
                }
                if (q < 0 || q > this.pz.right) {
                    q = NaN;
                }
            }
            let s = new CategoryTooltipSeriesInfo();
            s.c = { $type: Point_$type, x: q, y: r };
            s.a = e;
            s.b = f;
            return s;
        }
        ld() {
            this.q5 = { $type: Point_$type, x: NaN, y: NaN };
            this.b0.ap();
        }
        rh(a, b, c) {
            let d = a.c;
            let e = a.a;
            let f = a.b;
            d = this.ra.cg(d);
            let g = 0;
            let h = this.b0.bu;
            let i = this.ra.ca();
            this.ra.cc();
            let j = false;
            if (e.count == 0) {
                this.b0.ap();
                return;
            }
            let k = false;
            for (let l = 0; l < e.count; l++) {
                let m = e._inner[l].series;
                j = m.isVertical;
                let n = e._inner[l];
                let o = f._inner[l];
                if (this.ra.b7(m, o, n)) {
                    k = true;
                }
                g++;
            }
            if (!k) {
                this.ra.cd(i);
                return;
            }
            let p = this.ra.ch(i);
            let q = 0;
            let r = 0;
            let s = 0;
            let t = 0;
            let u = false;
            let v = false;
            let w = this.q9;
            if (w == 2 || w == 3) {
                v = true;
            }
            if (w == 2 || w == 1) {
                u = true;
            }
            let x = this.ra.ci();
            if (j) {
                if (!u && !v && d.x + (p.width + DeviceUtils.g(10)) > x.width) {
                    v = true;
                }
                if (u && !v && d.x - (p.width + DeviceUtils.g(10)) < 0) {
                    v = true;
                }
            }
            else {
                if (!u && !v && d.y - (p.height + 10) < 0) {
                    v = true;
                }
                if (u && !v && d.y + (p.height + 10) > x.height) {
                    v = true;
                }
            }
            let y = DeviceUtils.g(10);
            let z = DeviceUtils.g(5);
            if (!u) {
                if (!j) {
                    z = p.height + y;
                }
                if (v) {
                    if (j) {
                        z = z + p.width + y;
                    }
                    else {
                        z = 0;
                    }
                }
            }
            else {
                if (j) {
                    z = p.width + y;
                    if (v) {
                        z = 0;
                    }
                }
                else {
                    z = DeviceUtils.g(5);
                    if (v) {
                        z = z + p.height + y;
                    }
                }
            }
            if (j) {
                r = 0 - (y + DeviceUtils.g(5));
                if (u) {
                    r = (r * -1) + p.width;
                }
                q = p.height / 2;
                t = d.y - p.height / 2;
                s = d.x - z;
            }
            else {
                q = p.height + DeviceUtils.g(10) + DeviceUtils.g(5);
                if (u) {
                    q = 0 - (y + DeviceUtils.g(5));
                }
                r = p.width / 2;
                s = d.x - p.width / 2;
                t = d.y - z;
            }
            if (j) {
                if (t < 0) {
                    q -= 0 - t;
                    t = 0;
                }
                if (t + p.height > x.height) {
                    q += (t + p.height) - x.height;
                    t = x.height - p.height;
                }
            }
            else {
                if (s < 0) {
                    r -= 0 - s;
                    s = 0;
                }
                if (s + p.width > x.width) {
                    r += (s + p.width) - x.width;
                    s = x.width - p.width;
                }
            }
            b.k = s;
            b.l = t;
            b.g = r;
            b.h = q;
            b.j = p.width;
            b.i = p.height;
        }
        rd(a) {
            return a.toolTip;
        }
        qu(a, b) {
            super.qu(a, b);
            let c = a;
            let d = b.bu.left;
            let e = b.bu.right;
            let f = b.bu.top;
            let g = b.bu.bottom;
            let h = this.ra.ca();
            if (isNaN_(c.k) || isNaN_(c.l) || isNaN_(c.g) || isNaN_(c.h)) {
                this.ra.cd(h);
                return;
            }
            let i = c.k;
            let j = c.l;
            let k = c.g;
            let l = c.h;
            this.ra.ce(h, i, j, k, l);
        }
        em() {
            return true;
        }
    }
    CategoryToolTipLayer.$t = markType(CategoryToolTipLayer, 'CategoryToolTipLayer', AnnotationLayer.$);
    CategoryToolTipLayer.$$p = markDep(DependencyProperty, PropertyMetadata, CategoryToolTipLayer, 'raisePropertyChanged', ['TargetAxis:q8:ri', [Axis.$, null], 'ToolTipPosition:q9:rj', [CategoryTooltipLayerPosition_$type, enumGetBox(CategoryTooltipLayerPosition_$type, 0)], 'UseInterpolation:rc:rk', [0, false]]);
    return CategoryToolTipLayer;
})();
/**
 * @hidden
 */
export let CategoryToolTipLayerView = /*@__PURE__*/ (() => {
    class CategoryToolTipLayerView extends AnnotationLayerView {
        constructor(a) {
            super(a);
            this.b4 = null;
            this.b5 = null;
            this._tooltips = null;
            this.b8 = null;
            this.b6 = false;
            this._htmlTest = null;
            this.b4 = a;
            this.htmlTest = /^[^<]*(<[\w\W]+>)[^>]*$/;
        }
        ca() {
            if (this.b5 == null) {
                this.b5 = new PointerTooltip();
                this.b5.bw(this.e.g9);
                this.b5.ap = this.e.cd.cq.k;
                this._tooltips = this.e.g9.createElement("div");
                this.b8 = this.e.g9.createElement("div");
                this.b5._visibility = 0;
            }
            return this.b5;
        }
        as() {
            super.as();
            if (this.b5 != null) {
                this.b5._visibility = 1;
            }
        }
        aj() {
            super.aj();
            if (this.b5 != null) {
                this.b5.br();
                this.b5 = null;
            }
        }
        get htmlTest() {
            return this._htmlTest;
        }
        set htmlTest(a) {
            this._htmlTest = a;
        }
        b7(a, b, c) {
            if (a.h2 == "default") {
                a.h2 = a.b0.getDefaultTooltipTemplate();
            }
            let template_ = a.h2;
            let context_ = c;
            if (a.toolTip == null) {
                return false;
            }
            let tooltip_ = a.toolTip;
            if ((tooltip_.updateToolTip)) {
                tooltip_._inPointer = true;
                tooltip_.updateToolTip(context_, true);
                tooltip_.setStyleProperty('position', 'relative');
                tooltip_.setStyleProperty('left', '');
                tooltip_.setStyleProperty('top', '');
                tooltip_.remove();
            }
            this._tooltips.append(a.toolTip);
            return true;
        }
        ch(a) {
            let b = a;
            b.content = this._tooltips;
            let c = new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY);
            b.cy = 1;
            let d = b.cx(new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
            b.cy = 0;
            return d;
        }
        cg(a) {
            let b = 0;
            let c = 0;
            if (this.e.cd != null) {
                let d = this.e.cd.r8();
                b += d.x;
                c += d.y;
            }
            return { $type: Point_$type, x: b + a.x, y: c + a.y };
        }
        ce(a, b, c, d, e) {
            let f = a;
            let g = f.content;
            f.cs = { $type: Point_$type, x: d, y: e };
            f._visibility = 0;
            f.n = b;
            f.o = c;
        }
        ci() {
            let a = (window.innerWidth);
            let b = (window.innerHeight);
            return new Size(1, a, b);
        }
        cd(a) {
            this._tooltips.removeChildren();
            this.b8.removeChildren();
            this.b5._visibility = 1;
        }
        cc() {
            if (this._tooltips != null) {
                this._tooltips.removeChildren();
            }
        }
        cf() {
        }
        a6(a, b) {
            super.a6(a, b);
            if (b) {
                return;
            }
            let c = null;
            if (this.e.cd != null) {
                c = this.e.cd.cq.j.i();
            }
            let d = 0;
            let e = 0;
            let f = this.e.cd;
            if (f != null) {
                let g = f.cq.j.b7();
                d += g.x;
                e += g.y;
            }
            if (this.b5 != null) {
                this.b5.aq = c;
                this.b5.by(this.b5.n, this.b5.o);
            }
        }
        al(a) {
            super.al(a);
            let b = this.b5;
            let c = 0;
            let d = 0;
            if (this.e.cd != null) {
                let e = this.e.cd.r8();
                c += e.x;
                d += e.y;
            }
            let f = b.a5();
            let g = b.n - c;
            let h = b.o - d;
            let i = new List$1(String_$type, 0);
            let j = this._tooltips.getChildCount();
            for (let k = 0; k < j; k++) {
                let indexliteral_ = k.toString();
                let l = this._tooltips.getChildAt(k).getText();
                let m = l.toString();
                i.add(m);
            }
            this.e.a8.addPointerTooltipData(a, f, g, h, i);
        }
    }
    CategoryToolTipLayerView.$t = markType(CategoryToolTipLayerView, 'CategoryToolTipLayerView', AnnotationLayerView.$);
    return CategoryToolTipLayerView;
})();
