/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FinancialIndicator } from "./FinancialIndicator";
import { String_$type, Number_$type, typeCast, fromEnum, markType } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { isNaN_ } from "igniteui-angular-core";
/**
 * @hidden
 */
export let StrategyBasedIndicator = /*@__PURE__*/ (() => {
    class StrategyBasedIndicator extends FinancialIndicator {
        constructor() {
            super();
            this.uv();
        }
        uv() {
            this.ug = this.uh;
            this.ab = this.uu;
        }
        un() {
            return -2147483648;
        }
        uw(a) {
        }
        up() {
            return -2147483648;
        }
        um() {
            return -2147483648;
        }
        static u0(a, b, c) {
            let d = DependencyProperty.i(c, Number_$type, b, new PropertyMetadata(2, a, (e, f) => (typeCast(StrategyBasedIndicator.$, e)).raisePropertyChanged(c, f.oldValue, f.newValue)));
            StrategyBasedIndicator.uk.add(c);
            return d;
        }
        static uz(a, b) {
            return StrategyBasedIndicator.u0(a, b, "Period");
        }
        static ux(a, b) {
            return StrategyBasedIndicator.u0(a, b, "LongPeriod");
        }
        static u1(a, b) {
            return StrategyBasedIndicator.u0(a, b, "ShortPeriod");
        }
        tt(a, b) {
            let c = this.qp(a, b);
            let d = this.qq(c);
            return this.ug.b(c, d);
        }
        tq(a, b) {
            let c = this.qp(a, b);
            if (b == 0) {
                return false;
            }
            if (!this.rl(this.tt(a, b))) {
                return false;
            }
            let d = this.qq(c);
            if (this.tm != null) {
                c.minimumValue = this.tm.c;
                c.maximumValue = this.tm.b;
            }
            let e = this.ug.a(c, d);
            for (let f = 0; f < this.tv && f < c.indicatorColumn.count; f++) {
                c.indicatorColumn.item(f, NaN);
            }
            if (this.qy != null && this.uj(c)) {
                this.qy.c0();
            }
            return e;
        }
        uj(a) {
            if (!isNaN_(a.minimumValue) && !isNaN_(a.maximumValue) && a.specifiesRange) {
                let b = this.tm;
                this.tm = new AxisRange(a.minimumValue, a.maximumValue);
                return this.ui(b, this.tm);
            }
            let c = 1.7976931348623157E+308;
            let d = -1.7976931348623157E+308;
            for (let e of fromEnum(a.indicatorColumn)) {
                if (!isNaN_(e)) {
                    c = Math.min(c, e);
                    d = Math.max(d, e);
                }
            }
            let f = this.tm;
            this.tm = new AxisRange(c, d);
            return this.ui(f, this.tm);
        }
        ui(a, b) {
            if (a == null || b == null) {
                return true;
            }
            if (a.c != b.c) {
                return true;
            }
            if (a.b != b.b) {
                return true;
            }
            return false;
        }
        uo(a) {
            if (a == -2147483648) {
                return 0;
            }
            if (a > this.indicatorColumn.count && this.indicatorColumn.count > 0) {
                a = this.indicatorColumn.count - 1;
            }
            if (a < 1) {
                return 1;
            }
            return a;
        }
        qp(a, b) {
            let c = super.qp(a, b);
            c.indicatorColumn = this.indicatorColumn;
            c.period = this.uo(this.un());
            c.shortPeriod = this.uo(this.up());
            c.longPeriod = this.uo(this.um());
            c.multiplier = this.ul();
            return c;
        }
        ul() {
            return 1;
        }
        static uy(a, b) {
            let c = DependencyProperty.i("Multiplier", Number_$type, b, new PropertyMetadata(2, a, (d, e) => (typeCast(StrategyBasedIndicator.$, d)).raisePropertyChanged("Multiplier", e.oldValue, e.newValue)));
            StrategyBasedIndicator.uk.add("Multiplier");
            return c;
        }
        l4(a, b, c, d) {
            super.l4(a, b, c, d);
            if (StrategyBasedIndicator.uk.contains(b)) {
                if (this.qy != null && !this.qy.c0()) {
                    this.qt.bx.e(this.ft);
                    this.tq(0, this.indicatorColumn.count);
                    if (this.tn.b7) {
                        this.tn.b5.g$i();
                    }
                    this.mi(false);
                }
            }
        }
    }
    StrategyBasedIndicator.$t = markType(StrategyBasedIndicator, 'StrategyBasedIndicator', FinancialIndicator.$);
    StrategyBasedIndicator.uk = new List$1(String_$type, 0);
    return StrategyBasedIndicator;
})();
