/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { IUnknownValuePlotting_$type } from "igniteui-angular-core";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { UnknownValuePlotting_$type } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { typeCast, runOn, enumGetBox, markType, markDep } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { PropertyMetadata } from "igniteui-angular-core";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { Defaults } from "./Defaults";
import { ISortingAxis_$type } from "./ISortingAxis";
import { Color } from "igniteui-angular-core";
/**
 * @hidden
 */
var AreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AreaSeries, _super);
    function AreaSeries() {
        var _this = _super.call(this) || this;
        _this.u8 = null;
        _this.u8 = new CategoryLineRasterizer();
        _this.ab = AreaSeries.$;
        _this.ur = 0;
        return _this;
    }
    AreaSeries.prototype.bx = function () {
        return new AreaSeriesView(this);
    };
    AreaSeries.prototype.rz = function () {
        return 1;
    };
    AreaSeries.prototype.b3 = function () {
        if (this.b4 == 0) {
            return 2;
        }
        return _super.prototype.b3.call(this);
    };
    AreaSeries.prototype.lz = function (a) {
        _super.prototype.lz.call(this, a);
        this.u7 = a;
    };
    AreaSeries.prototype.get_de = function () {
        return true;
    };
    AreaSeries.prototype.get_dd = function () {
        return true;
    };
    AreaSeries.prototype.preferredCategoryMode = function (a) {
        return this.ur;
    };
    AreaSeries.prototype.ev = function (a, b) {
        var c = this.pm(this.pp(a), true, false);
        if (this.uy(a, c, b)) {
            return true;
        }
        if (this.eu(a, b)) {
            return true;
        }
        if (this.qg(a, b)) {
            return true;
        }
        return false;
    };
    AreaSeries.prototype.kx = function (a, b) {
        _super.prototype.kx.call(this, a, b);
        var c = b;
        c.db();
    };
    AreaSeries.prototype.s7 = function (a, b) {
        var _this = this;
        _super.prototype.s7.call(this, a, b);
        var c = b.cr.d;
        var d = typeCast(AreaSeriesView.$, b);
        var e = a.f;
        var f = this.getEffectiveViewport1(d);
        this.rx.a0(this, this.sh(), runOn(this, this.ri), this.sp(b), this.sq(b));
        var g = false;
        var h = this.rx.b;
        if (h != null) {
            g = true;
        }
        if (g) {
            var i = new ScalerParams(0, b.bv, b.bu, this.uo.cg, f);
            this.s3(e, -1, this.valueColumn.count, this.uo, i, b.q);
        }
        var j = d.dm;
        var k = d.dn;
        var l = d.dp;
        var m = d.dq;
        this.rx.ad(j, true, false, true, true);
        this.rx.ad(k, true, false, true, true);
        this.rx.ad(l, false, true, false, false);
        this.rx.ad(m, false, true, false, false);
        if (b.cv(a)) {
            d.dd(e.count, e, true, c, this.ft, function (n, o, p, q, r) { return _this.t6(n, a.f.count, b); }, this.unknownValuePlotting, e.count == 1 ? null : this.tg(e, e.count - 1, b.bu, b.bv, true));
            b.cy(a);
        }
        var n = this.fetchYAxis();
        l._opacity = this.rx.j * this.fq;
        m._opacity = 0.5 * this.rx.j * this.fq;
    };
    AreaSeries.prototype.l4 = function (a, b, c, d) {
        _super.prototype.l4.call(this, a, b, c, d);
        switch (b) {
            case AreaSeries.$$p[0]:
                this.ru.m = this.unknownValuePlotting == 0;
                this.mi(false);
                this.lp();
                break;
        }
    };
    Object.defineProperty(AreaSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.sk;
        },
        enumerable: false,
        configurable: true
    });
    AreaSeries.$t = markType(AreaSeries, 'AreaSeries', HorizontalAnchoredCategorySeries.$, [IUnknownValuePlotting_$type]);
    AreaSeries.$$p = markDep(DependencyProperty, PropertyMetadata, AreaSeries, 'raisePropertyChanged', ['UnknownValuePlotting::va', [UnknownValuePlotting_$type, enumGetBox(UnknownValuePlotting_$type, 1)]]);
    return AreaSeries;
}(HorizontalAnchoredCategorySeries));
export { AreaSeries };
/**
 * @hidden
 */
var AreaSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AreaSeriesView, _super);
    function AreaSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.da = null;
        _this.di = new Path();
        _this.dk = new Path();
        _this.dj = new Path();
        _this.dl = new Path();
        _this.de = new Path();
        _this.dg = new Path();
        _this.df = new Path();
        _this.dh = new Path();
        _this.da = a;
        return _this;
    }
    AreaSeriesView.prototype.as = function () {
        _super.prototype.as.call(this);
        if (!this.q) {
            this.da.qd = Defaults.e;
        }
    };
    Object.defineProperty(AreaSeriesView.prototype, "dm", {
        get: function () {
            return this.dk;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AreaSeriesView.prototype, "dn", {
        get: function () {
            return this.dl;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AreaSeriesView.prototype, "dp", {
        get: function () {
            return this.di;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AreaSeriesView.prototype, "dq", {
        get: function () {
            return this.dj;
        },
        enumerable: false,
        configurable: true
    });
    AreaSeriesView.prototype.db = function () {
        this.di.ak = null;
        this.dj.ak = null;
        this.dk.ak = null;
        this.dl.ak = null;
        this.aq();
    };
    AreaSeriesView.prototype.dc = function (a, b, c, d, e, f, g) {
        this.dd(a, b, c, d, e, f, g, null);
    };
    AreaSeriesView.prototype.dd = function (a, b, c, d, e, f, g, h) {
        this.da.u8.a = typeCast(ISortingAxis_$type, this.ct.fetchXAxis()) !== null ? true : false;
        this.da.u8.j(this.di, this.dk, this.dj, this.dl, a, b, c, d, e, f, g, h);
        this.aq();
    };
    AreaSeriesView.prototype.bc = function () {
        _super.prototype.bc.call(this);
        this.de.ak = this.di.ak;
        this.dg.ak = this.dk.ak;
        this.df.ak = this.dj.ak;
        this.dh.ak = this.dl.ak;
        var a = this.bo();
        this.de._fill = a;
        this.de._opacity = 1;
        this.df._fill = a;
        this.df._opacity = 1;
        this.dg._stroke = a;
        this.dg.ac = this.e.fu + 3;
        this.dh._stroke = a;
        this.dh.ac = this.e.fu + 3;
    };
    AreaSeriesView.prototype.a6 = function (a, b) {
        _super.prototype.a6.call(this, a, b);
        if (b) {
            a.s(this.de);
            a.s(this.df);
            a.s(this.dg);
            a.s(this.dh);
        }
        else {
            a.s(this.di);
            a.s(this.dj);
            a.s(this.dk);
            a.s(this.dl);
        }
    };
    AreaSeriesView.prototype.al = function (a) {
        _super.prototype.al.call(this, a);
        this.e.a8.exportPathData(a, this.dk, "lowerShape", ["Lower"]);
        this.e.a8.exportPathData(a, this.dl, "upperShape", ["Upper", "Main"]);
        this.e.a8.exportPathData(a, this.dj, "translucentShape", ["Translucent"]);
        this.e.a8.exportPathData(a, this.di, "fillShape", ["Fill"]);
    };
    AreaSeriesView.prototype.af = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.pb = a;
        this.e.gw = 5;
        this.e.gx = 1;
        this.e.gy = -3;
    };
    AreaSeriesView.$t = markType(AreaSeriesView, 'AreaSeriesView', AnchoredCategorySeriesView.$);
    return AreaSeriesView;
}(AnchoredCategorySeriesView));
export { AreaSeriesView };
