/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, markType } from "igniteui-angular-core";
import { IFinancialPriceSeriesProxy_$type } from "./IFinancialPriceSeriesProxy";
/**
 * @hidden
 */
var FinancialPriceSeriesProxy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialPriceSeriesProxy, _super);
    function FinancialPriceSeriesProxy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FinancialPriceSeriesProxy.prototype.getCloseMemberPath = function (a) {
        return a.sg;
    };
    FinancialPriceSeriesProxy.prototype.getHighMemberPath = function (a) {
        return a.sj;
    };
    FinancialPriceSeriesProxy.prototype.getLowMemberPath = function (a) {
        return a.so;
    };
    FinancialPriceSeriesProxy.prototype.getOpenMemberPath = function (a) {
        return a.ss;
    };
    FinancialPriceSeriesProxy.prototype.getVolumeMemberPath = function (a) {
        return a.sw;
    };
    FinancialPriceSeriesProxy.prototype.matchesType = function (a) {
        if (!a.dp) {
            return false;
        }
        if (a.dq || a.dr) {
            return false;
        }
        return true;
    };
    FinancialPriceSeriesProxy.prototype.setCategoryMode = function (a, b) {
        a.qk = b;
    };
    FinancialPriceSeriesProxy.prototype.setCloseMemberPath = function (a, b) {
        a.sg = b;
    };
    FinancialPriceSeriesProxy.prototype.setDisplayType = function (a, b) {
        a.to = b;
    };
    FinancialPriceSeriesProxy.prototype.setHighMemberPath = function (a, b) {
        a.sj = b;
    };
    FinancialPriceSeriesProxy.prototype.setLowMemberPath = function (a, b) {
        a.so = b;
    };
    FinancialPriceSeriesProxy.prototype.setOpenMemberPath = function (a, b) {
        a.ss = b;
    };
    FinancialPriceSeriesProxy.prototype.setVolumeMemberPath = function (a, b) {
        a.sw = b;
    };
    FinancialPriceSeriesProxy.prototype.setXAxis = function (a, b) {
        a.qc = b;
    };
    FinancialPriceSeriesProxy.prototype.setYAxis = function (a, b) {
        a.qy = b;
    };
    FinancialPriceSeriesProxy.$t = markType(FinancialPriceSeriesProxy, 'FinancialPriceSeriesProxy', Base.$, [IFinancialPriceSeriesProxy_$type]);
    return FinancialPriceSeriesProxy;
}(Base));
export { FinancialPriceSeriesProxy };
