/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { PolarBase } from "./PolarBase";
import { PathRenderer } from "./PathRenderer";
import { DefaultFlattener } from "./DefaultFlattener";
import { PolarBaseView } from "./PolarBaseView";
import { Number_$type, Point_$type, markType } from "igniteui-angular-core";
import { PolarLinePlanner } from "./PolarLinePlanner";
import { List$1 } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
import { Color } from "igniteui-angular-core";
/**
 * @hidden
 */
var PolarLineSeriesBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolarLineSeriesBase, _super);
    function PolarLineSeriesBase() {
        var _this = _super.call(this) || this;
        _this.u2 = null;
        _this.u4 = null;
        _this.u3 = null;
        _this.u2 = new PathRenderer(1, new DefaultFlattener());
        _this.u4 = new PathRenderer(0);
        return _this;
    }
    PolarLineSeriesBase.prototype.get_sp = function () {
        return true;
    };
    PolarLineSeriesBase.prototype.bx = function () {
        return new PolarLineSeriesBaseView(this);
    };
    PolarLineSeriesBase.prototype.lz = function (a) {
        _super.prototype.lz.call(this, a);
        this.u5 = a;
    };
    PolarLineSeriesBase.prototype.u6 = function () {
        return 1;
    };
    PolarLineSeriesBase.prototype.get_u9 = function () {
        return false;
    };
    Object.defineProperty(PolarLineSeriesBase.prototype, "u9", {
        get: function () {
            return this.get_u9();
        },
        enumerable: false,
        configurable: true
    });
    PolarLineSeriesBase.prototype.get_vb = function () {
        return false;
    };
    Object.defineProperty(PolarLineSeriesBase.prototype, "vb", {
        get: function () {
            return this.get_vb();
        },
        enumerable: false,
        configurable: true
    });
    PolarLineSeriesBase.prototype.t2 = function (a, b) {
        var _this = this;
        _super.prototype.t2.call(this, a, b);
        a.m.clear();
        var c = b.bv;
        var d = b.bu;
        var e = this.sf != null ? this.sf.count : 0;
        var f = this.sg != null ? this.sg.count : 0;
        var g = Math.min(e, f);
        var h = ((function () {
            var $ret = new PolarLinePlanner();
            $ret.m = function (i) { return _this.rx.a.getScaledAngle1(_this.sf.item(i), _this.rx.e, _this.rx.d); };
            $ret.q = g;
            $ret.n = function (i) { return _this.rv.nt(_this.sg.item(i), _this.rx.g, _this.rx.f, _this.rx.i, _this.rx.h); };
            $ret.l = _this.ft;
            $ret.f = _this.su;
            $ret.b = _this.u6();
            $ret.o = function (i) { return _this.vc(a, i); };
            $ret.p = function (i) { return _this.vd(a, i); };
            $ret.ab = d;
            $ret.ac = c;
            $ret.d = _this.vb;
            $ret.c = _this.u9;
            return $ret;
        })());
        var i = new List$1(Number_$type, 0);
        for (var j = 0; j < g; j++) {
            if (this.va(j)) {
                i.add(j);
            }
        }
        if (this.vb && i.count > 0) {
            i.add(i._inner[0]);
        }
        h.x(a.m, i);
    };
    PolarLineSeriesBase.prototype.vc = function (a, b) {
        return a.w._inner[b].x;
    };
    PolarLineSeriesBase.prototype.vd = function (a, b) {
        return a.w._inner[b].y;
    };
    PolarLineSeriesBase.prototype.u8 = function () {
        return !this.u7();
    };
    PolarLineSeriesBase.prototype.u7 = function () {
        var a = this.cd.sf;
        return !a.containsPoint({ $type: Point_$type, x: 0.5, y: 0.5 });
    };
    PolarLineSeriesBase.prototype.va = function (a) {
        return (this.sf.item(a) >= this.rx.a.lv && this.sf.item(a) <= this.rx.a.lu && this.sg.item(a) >= this.rx.b.lv && this.sg.item(a) <= this.rx.b.lu) || (isNaN_(this.sf.item(a)) || isNaN_(this.sg.item(a)));
    };
    PolarLineSeriesBase.prototype.kx = function (a, b) {
        _super.prototype.kx.call(this, a, b);
        this.ve(b);
    };
    PolarLineSeriesBase.prototype.t6 = function (a, b) {
        _super.prototype.t6.call(this, a, b);
        if (this.su) {
            this.u3 = this.u2;
        }
        else {
            this.u3 = this.u4;
        }
        this.u3.b = this.u6();
        this.ve(b);
        this.vf(a, b);
    };
    PolarLineSeriesBase.$t = markType(PolarLineSeriesBase, 'PolarLineSeriesBase', PolarBase.$);
    return PolarLineSeriesBase;
}(PolarBase));
export { PolarLineSeriesBase };
/**
 * @hidden
 */
var PolarLineSeriesBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolarLineSeriesBaseView, _super);
    function PolarLineSeriesBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.c3 = null;
        _this.c3 = a;
        return _this;
    }
    PolarLineSeriesBaseView.prototype.af = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.pb = a;
        this.e.gw = 3;
        this.e.gx = 1;
        this.e.gy = 4;
        this.e.e7 = false;
    };
    PolarLineSeriesBaseView.$t = markType(PolarLineSeriesBaseView, 'PolarLineSeriesBaseView', PolarBaseView.$);
    return PolarLineSeriesBaseView;
}(PolarBaseView));
export { PolarLineSeriesBaseView };
