/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Series } from "./Series";
import { DependencyProperty } from "igniteui-angular-core";
import { IEnumerable_$type, runOn, delegateCombine, delegateRemove, typeCast, Point_$type, markType, markDep } from "igniteui-angular-core";
import { NumericXAxis } from "./NumericXAxis";
import { NumericYAxis } from "./NumericYAxis";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { Triangulator } from "igniteui-angular-core";
import { TriangulationStatusEventArgs } from "igniteui-angular-core";
import { FastItemsSource } from "igniteui-angular-core";
import { SeriesViewer } from "./SeriesViewer";
import { Axis } from "./Axis";
import { AxisRange } from "./AxisRange";
import { DataLegendSeriesValueInfo } from "igniteui-angular-core";
import { DataLegendSeriesContext } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
/**
 * @hidden
 */
var ScatterTriangulationSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterTriangulationSeries, _super);
    function ScatterTriangulationSeries() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.qb = null;
        _this.qc = null;
        _this.qk = false;
        _this.p7 = null;
        _this.triangulationStatusChanged = null;
        _this.qn = null;
        _this.p8 = null;
        _this.p9 = null;
        _this.qa = null;
        return _this;
    }
    ScatterTriangulationSeries.prototype.ku = function () {
        _super.prototype.ku.call(this);
        this.p4 = null;
        this.p5 = null;
    };
    ScatterTriangulationSeries.prototype.hw = function (a, b) {
        var c = this.jq(b);
        if (c == ScatterTriangulationSeries.$$p[8]) {
            return this.hx(a, b, this.q6);
        }
        if (c == ScatterTriangulationSeries.$$p[12]) {
            return this.hx(a, b, this.re);
        }
        return _super.prototype.hw.call(this, a, b);
    };
    Object.defineProperty(ScatterTriangulationSeries.prototype, "qh", {
        get: function () {
            return this.qb;
        },
        set: function (a) {
            var b = this.qh != a;
            if (b) {
                var c = this.qh;
                this.qb = a;
                this.raisePropertyChanged("XColumn", c, this.qh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ScatterTriangulationSeries.prototype, "qi", {
        get: function () {
            return this.qc;
        },
        set: function (a) {
            var b = this.qi != a;
            if (b) {
                var c = this.qi;
                this.qc = a;
                this.raisePropertyChanged("YColumn", c, this.qi);
            }
        },
        enumerable: false,
        configurable: true
    });
    ScatterTriangulationSeries.prototype.mj = function (a) {
        var b = this.ck != null && this.qj == null && this.qn == null && this.qh != null && this.qi != null && this.qh.count >= 3 && this.qi.count >= 3 && !this.qk;
        if (b) {
            this.ri();
            this.qk = true;
        }
    };
    ScatterTriangulationSeries.prototype.ri = function () {
        this.p7 = new Triangulator(this.ck.count, this.qh, this.qi);
        var a = this.p7;
        a.triangulationStatusChanged = delegateCombine(a.triangulationStatusChanged, runOn(this, this.rj));
        this.p7.y();
    };
    ScatterTriangulationSeries.prototype.rg = function () {
        if (this.p7 == null) {
            return;
        }
        this.p7.r();
        var a = this.p7;
        a.triangulationStatusChanged = delegateRemove(a.triangulationStatusChanged, runOn(this, this.rj));
        this.p7 = null;
    };
    ScatterTriangulationSeries.prototype.rj = function (a, b) {
        var _this = this;
        if (this.triangulationStatusChanged != null) {
            this.triangulationStatusChanged(this, new TriangulationStatusEventArgs(b.currentStatus));
        }
        if (b.currentStatus >= 100) {
            if (this.p7 == null) {
                return;
            }
            var c = this.p7;
            c.triangulationStatusChanged = delegateRemove(c.triangulationStatusChanged, runOn(this, this.rj));
            this.qn = this.p7.n();
            this.p7 = null;
            var d = ((function () {
                var $ret = new FastItemsSource();
                $ret.e = _this.qn;
                return $ret;
            })());
            this.qe = this.qd(d, "v1");
            this.qf = this.qd(d, "v2");
            this.qg = this.qd(d, "v3");
            this.mi(false);
        }
    };
    ScatterTriangulationSeries.prototype.qd = function (a, b) {
        if (b == null) {
            return a.registerColumnInt(null, null, false);
        }
        var c = null;
        var d = SeriesViewer.cc(b, this.coercionMethods);
        c = d.a;
        return a.registerColumnInt(b, c, this.expectFunctions);
    };
    ScatterTriangulationSeries.prototype.l4 = function (a, b, c, d) {
        var _this = this;
        _super.prototype.l4.call(this, a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                var e = typeCast(IFastItemsSource_$type, c);
                if (e != null) {
                    e.deregisterColumn(this.qh);
                    e.deregisterColumn(this.qi);
                    this.qh = null;
                    this.qi = null;
                }
                this.rh();
                var f = typeCast(IFastItemsSource_$type, d);
                if (f != null) {
                    this.qh = this.ch(this.q6);
                    this.qi = this.ch(this.re);
                }
                this.mi(false);
                break;
            case ScatterTriangulationSeries.$$p[8]:
                if (this.ck != null) {
                    this.ck.deregisterColumn(this.qh);
                    this.qh = this.ch(this.q6);
                }
                this.rh();
                this.mi(false);
                this.lp();
                break;
            case ScatterTriangulationSeries.$$p[12]:
                if (this.ck != null) {
                    this.ck.deregisterColumn(this.qi);
                    this.qi = this.ch(this.re);
                }
                this.rh();
                this.mi(false);
                this.lp();
                break;
            case ScatterTriangulationSeries.$$p[5]:
                if (c != null) {
                    (typeCast(Axis.$, c)).bz(this);
                }
                if (d != null) {
                    (typeCast(Axis.$, d)).cs(this);
                }
                if ((this.p4 != null && !this.p4.c0()) || (d == null && c != null)) {
                    this.mi(false);
                }
                this.lp();
                break;
            case ScatterTriangulationSeries.$$p[9]:
                if (c != null) {
                    (typeCast(Axis.$, c)).bz(this);
                }
                if (d != null) {
                    (typeCast(Axis.$, d)).cs(this);
                }
                if ((this.p5 != null && !this.p5.c0()) || (d == null && c != null)) {
                    this.mi(false);
                }
                this.lp();
                break;
            case ScatterTriangulationSeries.$$p[1]:
                if (this.trianglesSource != null) {
                    this.rg();
                    this.qj = ((function () {
                        var $ret = new FastItemsSource();
                        $ret.e = _this.trianglesSource;
                        return $ret;
                    })());
                }
                else {
                    this.qj = null;
                }
                break;
            case ScatterTriangulationSeries.$$p[0]:
                var g = typeCast(IFastItemsSource_$type, c);
                if (g != null) {
                    g.deregisterColumn(this.qe);
                    g.deregisterColumn(this.qf);
                    g.deregisterColumn(this.qg);
                    this.qe = null;
                    this.qf = null;
                    this.qg = null;
                }
                var h = typeCast(IFastItemsSource_$type, d);
                if (h != null) {
                    this.qe = this.qd(h, this.qu);
                    this.qf = this.qd(h, this.qw);
                    this.qg = this.qd(h, this.qy);
                }
                this.mi(false);
                this.lp();
                break;
            case ScatterTriangulationSeries.$$p[2]:
                if (this.qj != null) {
                    this.qj.deregisterColumn(this.qe);
                    this.qe = this.qd(this.qj, this.qu);
                }
                this.mi(false);
                this.lp();
                break;
            case ScatterTriangulationSeries.$$p[3]:
                if (this.qj != null) {
                    this.qj.deregisterColumn(this.qf);
                    this.qf = this.qd(this.qj, this.qw);
                }
                this.mi(false);
                this.lp();
                break;
            case ScatterTriangulationSeries.$$p[4]:
                if (this.qj != null) {
                    this.qj.deregisterColumn(this.qg);
                    this.qg = this.qd(this.qj, this.qy);
                }
                this.mi(false);
                this.lp();
                break;
            case "XColumn":
                if (this.p4 != null) {
                    this.p4.c0();
                }
                break;
            case "YColumn":
                if (this.p5 != null) {
                    this.p5.c0();
                }
                break;
        }
    };
    ScatterTriangulationSeries.prototype.qm = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    ScatterTriangulationSeries.prototype.ql = function (a) {
        if (typeCast(NumericXAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    ScatterTriangulationSeries.prototype.e9 = function (a, b, c) {
        return _super.prototype.e9.call(this, a, b, c) && this.ck != null && this.p4 != null && this.p5 != null && this.p4.bh != null && this.p5.bh != null && a.width > 0 && a.height > 0 && this.qe != null && this.qe.count > 0 && this.qf != null && this.qf.count > 0 && this.qg != null && this.qg.count > 0 && this.qh != null && this.qh.count > 0 && this.qi != null && this.qi.count > 0;
    };
    ScatterTriangulationSeries.prototype.rh = function () {
        if (this.trianglesSource == null) {
            this.qn = null;
            this.qe = null;
            this.qf = null;
            this.qg = null;
            this.qk = false;
        }
    };
    ScatterTriangulationSeries.prototype.lf = function () {
        _super.prototype.lf.call(this);
        if (this.p4 != null) {
            this.p4.h6();
        }
        if (this.p5 != null) {
            this.p5.h6();
        }
    };
    ScatterTriangulationSeries.prototype.k0 = function (a, b, c, d) {
        _super.prototype.k0.call(this, a, b, c, d);
        this.rh();
        this.mi(false);
    };
    ScatterTriangulationSeries.prototype.ap = function (a) {
        if (a != null && a == this.p4 && this.qh != null) {
            return new AxisRange(this.qh.minimum, this.qh.maximum);
        }
        if (a != null && a == this.p5 && this.qi != null) {
            return new AxisRange(this.qi.minimum, this.qi.maximum);
        }
        return null;
    };
    ScatterTriangulationSeries.prototype.m6 = function (a, b) {
        this.mi(false);
    };
    ScatterTriangulationSeries.prototype.m5 = function (a, b) {
        this.mi(false);
    };
    Object.defineProperty(ScatterTriangulationSeries.prototype, "qe", {
        get: function () {
            return this.p8;
        },
        set: function (a) {
            var b = this.qe != a;
            if (b) {
                var c = this.qe;
                this.p8 = a;
                this.raisePropertyChanged("TriangleVertexColumn1", c, this.qe);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ScatterTriangulationSeries.prototype, "qf", {
        get: function () {
            return this.p9;
        },
        set: function (a) {
            var b = this.qf != a;
            if (b) {
                var c = this.qf;
                this.p9 = a;
                this.raisePropertyChanged("TriangleVertexColumn2", c, this.qf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ScatterTriangulationSeries.prototype, "qg", {
        get: function () {
            return this.qa;
        },
        set: function (a) {
            var b = this.qg != a;
            if (b) {
                var c = this.qg;
                this.qa = a;
                this.raisePropertyChanged("TriangleVertexColumn3", c, this.qg);
            }
        },
        enumerable: false,
        configurable: true
    });
    ScatterTriangulationSeries.prototype.get_ed = function () {
        return true;
    };
    ScatterTriangulationSeries.prototype.get_d2 = function () {
        return true;
    };
    ScatterTriangulationSeries.prototype.getDataLegendSeriesContextAt = function (a, b) {
        var c = { $type: Point_$type, x: a, y: b };
        var d = this.ht(c);
        var e = d == null ? NaN : this.gb(d, "XMemberPath");
        var f = d == null ? NaN : this.gb(d, "YMemberPath");
        var g = new DataLegendSeriesValueInfo();
        g.l = e;
        g.a = 13;
        g.p = this.q6 != null ? this.q6 : "X";
        ;
        g.q = this.q2 != null ? this.q2 : "X:";
        g.r = this.q4 != null ? this.q4 : "";
        var h = new DataLegendSeriesValueInfo();
        h.l = f;
        h.a = 14;
        h.p = this.re != null ? this.re : "Y";
        ;
        h.q = this.ra != null ? this.ra : "Y:";
        h.r = this.rc != null ? this.rc : "";
        var i = new DataLegendSeriesContext();
        i.f = ((function () {
            var $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
            $ret.add(g);
            $ret.add(h);
            return $ret;
        })());
        i.b = this.av();
        return i;
    };
    ScatterTriangulationSeries.$t = markType(ScatterTriangulationSeries, 'ScatterTriangulationSeries', Series.$);
    ScatterTriangulationSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterTriangulationSeries, 'raisePropertyChanged', ['FastTrianglesSource:qj:rk', [IFastItemsSource_$type, null], 'TrianglesSource::rl', [IEnumerable_$type, null], 'TriangleVertexMemberPath1:qu:rm', [2, null], 'TriangleVertexMemberPath2:qw:rn', [2, null], 'TriangleVertexMemberPath3:qy:ro', [2, null], 'XAxis:p4:rp', [NumericXAxis.$, null], 'XMemberAsLegendLabel:q2:rq', [2, null], 'XMemberAsLegendUnit:q4:rr', [2, null], 'XMemberPath:q6:rs', [2, null], 'YAxis:p5:rt', [NumericYAxis.$, null], 'YMemberAsLegendLabel:ra:ru', [2, null], 'YMemberAsLegendUnit:rc:rv', [2, null], 'YMemberPath:re:rw', [2, null]]);
    return ScatterTriangulationSeries;
}(Series));
export { ScatterTriangulationSeries };
