/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { FinancialIndicator } from "./FinancialIndicator";
import { String_$type, Number_$type, typeCast, fromEnum, markType } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { isNaN_ } from "igniteui-angular-core";
/**
 * @hidden
 */
var StrategyBasedIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StrategyBasedIndicator, _super);
    function StrategyBasedIndicator() {
        var _this = _super.call(this) || this;
        _this.uv();
        return _this;
    }
    StrategyBasedIndicator.prototype.uv = function () {
        this.ug = this.uh;
        this.ab = this.uu;
    };
    StrategyBasedIndicator.prototype.un = function () {
        return -2147483648;
    };
    StrategyBasedIndicator.prototype.uw = function (a) {
    };
    StrategyBasedIndicator.prototype.up = function () {
        return -2147483648;
    };
    StrategyBasedIndicator.prototype.um = function () {
        return -2147483648;
    };
    StrategyBasedIndicator.u0 = function (a, b, c) {
        var d = DependencyProperty.i(c, Number_$type, b, new PropertyMetadata(2, a, function (e, f) { return (typeCast(StrategyBasedIndicator.$, e)).raisePropertyChanged(c, f.oldValue, f.newValue); }));
        StrategyBasedIndicator.uk.add(c);
        return d;
    };
    StrategyBasedIndicator.uz = function (a, b) {
        return StrategyBasedIndicator.u0(a, b, "Period");
    };
    StrategyBasedIndicator.ux = function (a, b) {
        return StrategyBasedIndicator.u0(a, b, "LongPeriod");
    };
    StrategyBasedIndicator.u1 = function (a, b) {
        return StrategyBasedIndicator.u0(a, b, "ShortPeriod");
    };
    StrategyBasedIndicator.prototype.tt = function (a, b) {
        var c = this.qp(a, b);
        var d = this.qq(c);
        return this.ug.b(c, d);
    };
    StrategyBasedIndicator.prototype.tq = function (a, b) {
        var c = this.qp(a, b);
        if (b == 0) {
            return false;
        }
        if (!this.rl(this.tt(a, b))) {
            return false;
        }
        var d = this.qq(c);
        if (this.tm != null) {
            c.minimumValue = this.tm.c;
            c.maximumValue = this.tm.b;
        }
        var e = this.ug.a(c, d);
        for (var f = 0; f < this.tv && f < c.indicatorColumn.count; f++) {
            c.indicatorColumn.item(f, NaN);
        }
        if (this.qy != null && this.uj(c)) {
            this.qy.c0();
        }
        return e;
    };
    StrategyBasedIndicator.prototype.uj = function (a) {
        var e_1, _a;
        if (!isNaN_(a.minimumValue) && !isNaN_(a.maximumValue) && a.specifiesRange) {
            var b = this.tm;
            this.tm = new AxisRange(a.minimumValue, a.maximumValue);
            return this.ui(b, this.tm);
        }
        var c = 1.7976931348623157E+308;
        var d = -1.7976931348623157E+308;
        try {
            for (var _b = __values(fromEnum(a.indicatorColumn)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                if (!isNaN_(e)) {
                    c = Math.min(c, e);
                    d = Math.max(d, e);
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        var f = this.tm;
        this.tm = new AxisRange(c, d);
        return this.ui(f, this.tm);
    };
    StrategyBasedIndicator.prototype.ui = function (a, b) {
        if (a == null || b == null) {
            return true;
        }
        if (a.c != b.c) {
            return true;
        }
        if (a.b != b.b) {
            return true;
        }
        return false;
    };
    StrategyBasedIndicator.prototype.uo = function (a) {
        if (a == -2147483648) {
            return 0;
        }
        if (a > this.indicatorColumn.count && this.indicatorColumn.count > 0) {
            a = this.indicatorColumn.count - 1;
        }
        if (a < 1) {
            return 1;
        }
        return a;
    };
    StrategyBasedIndicator.prototype.qp = function (a, b) {
        var c = _super.prototype.qp.call(this, a, b);
        c.indicatorColumn = this.indicatorColumn;
        c.period = this.uo(this.un());
        c.shortPeriod = this.uo(this.up());
        c.longPeriod = this.uo(this.um());
        c.multiplier = this.ul();
        return c;
    };
    StrategyBasedIndicator.prototype.ul = function () {
        return 1;
    };
    StrategyBasedIndicator.uy = function (a, b) {
        var c = DependencyProperty.i("Multiplier", Number_$type, b, new PropertyMetadata(2, a, function (d, e) { return (typeCast(StrategyBasedIndicator.$, d)).raisePropertyChanged("Multiplier", e.oldValue, e.newValue); }));
        StrategyBasedIndicator.uk.add("Multiplier");
        return c;
    };
    StrategyBasedIndicator.prototype.l4 = function (a, b, c, d) {
        _super.prototype.l4.call(this, a, b, c, d);
        if (StrategyBasedIndicator.uk.contains(b)) {
            if (this.qy != null && !this.qy.c0()) {
                this.qt.bx.e(this.ft);
                this.tq(0, this.indicatorColumn.count);
                if (this.tn.b7) {
                    this.tn.b5.g$i();
                }
                this.mi(false);
            }
        }
    };
    StrategyBasedIndicator.$t = markType(StrategyBasedIndicator, 'StrategyBasedIndicator', FinancialIndicator.$);
    StrategyBasedIndicator.uk = new List$1(String_$type, 0);
    return StrategyBasedIndicator;
}(FinancialIndicator));
export { StrategyBasedIndicator };
