/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Series } from "./Series";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { Axis } from "./Axis";
import { DependencyProperty } from "igniteui-angular-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { Point_$type, typeCast, Delegate_$type, markType, markDep } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { Thickness } from "igniteui-angular-core";
import { AxisAnnotationFrame } from "./AxisAnnotationFrame";
import { List$1 } from "igniteui-angular-core";
import { Dictionary$2 } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { AxisAnnotation } from "./AxisAnnotation";
import { SeriesView } from "./SeriesView";
import { NotImplementedException } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { NumericAxisBase } from "./NumericAxisBase";
import { ScalerParams } from "./ScalerParams";
import { CategoryXAxis } from "./CategoryXAxis";
import { AxisAnnotationFrameManager } from "./AxisAnnotationFrameManager";
import { PropertyMetadata } from "igniteui-angular-core";
import { DeviceUtils } from "igniteui-angular-core";
import { isNaN_, isInfinity } from "igniteui-angular-core";
import { stringFormat } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
/**
 * @hidden
 */
var ValueOverlay = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ValueOverlay, _super);
    function ValueOverlay() {
        var _this = _super.call(this) || this;
        _this.ql = 0;
        _this.qm = 0;
        _this.qi = 0;
        _this.p5 = null;
        _this.qb = null;
        _this.qa = null;
        _this.ab = ValueOverlay.$;
        return _this;
    }
    ValueOverlay.prototype.gj = function (a, b, c) {
        return this.qn;
    };
    ValueOverlay.prototype.qj = function (a, b) {
        var c = Math.sqrt(Math.pow(a.x - b.x, 2) + Math.pow(a.y - b.y, 2));
        var d = Math.acos((a.x - b.x) / c);
        if ((a.y - b.y) < 0) {
            d = (2 * Math.PI) - d;
        }
        return d;
    };
    ValueOverlay.prototype.pm = function (a, b, c) {
        if (this.p4 == null) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        var d = this.qk();
        var e = NaN;
        var f = NaN;
        var g = NaN;
        var h = { $type: Point_$type, x: 0.5, y: 0.5 };
        var i = NaN;
        switch (this.p4.a1) {
            case 2:
                i = Math.sqrt(Math.pow(a.x - h.x, 2) + Math.pow(a.y - h.y, 2));
                g = d;
                e = h.x + Math.cos(g) * i;
                f = h.y + Math.sin(g) * i;
                f = this.b0.bu.top + this.b0.bu.height * (f - this.b0.bv.top) / this.b0.bv.height;
                e = this.b0.bu.left + this.b0.bu.width * (e - this.b0.bv.left) / this.b0.bv.width;
                break;
            case 0:
                e = d;
                f = a.y;
                f = this.b0.bu.top + this.b0.bu.height * (f - this.b0.bv.top) / this.b0.bv.height;
                break;
            case 1:
                f = d;
                e = a.x;
                e = this.b0.bu.left + this.b0.bu.width * (e - this.b0.bv.left) / this.b0.bv.width;
                break;
            case 3:
                g = this.qj(a, h);
                i = d;
                e = h.x + Math.cos(g) * i;
                f = h.y + Math.sin(g) * i;
                f = this.b0.bu.top + this.b0.bu.height * (f - this.b0.bv.top) / this.b0.bv.height;
                e = this.b0.bu.left + this.b0.bu.width * (e - this.b0.bv.left) / this.b0.bv.width;
                break;
        }
        return { $type: Point_$type, x: e, y: f };
    };
    ValueOverlay.prototype.hd = function (a) {
        throw new NotImplementedException(0);
    };
    ValueOverlay.prototype.ht = function (a) {
        return this;
    };
    ValueOverlay.prototype.en = function (a) {
        return false;
    };
    ValueOverlay.prototype.ap = function (a) {
        var b = typeCast(NumericAxisBase.$, a);
        var c = this.qn;
        if (isNaN_(c) || isInfinity(c)) {
            return null;
        }
        return new AxisRange(c, c);
    };
    ValueOverlay.prototype.mj = function (a) {
        this.kx(true, this.b0);
        if (!this.p9()) {
            if (this.p5 != null) {
                this.q6(NaN, this.cv());
            }
            return;
        }
        if (this.eo(a)) {
            if (this.cv()) {
                if (this.ce.g) {
                    this.ce.t();
                }
                var b = this.ql;
                this.ql = this.qm;
                this.qm = b;
            }
            else {
                this.ql = this.qi;
            }
            this.qi = this.qk();
            this.mr();
        }
        else {
            this.qi = this.qk();
            this.q5(this.qi, this.p7);
        }
    };
    ValueOverlay.prototype.qk = function () {
        var a, b;
        var c = this.getViewInfo(b, a);
        b = c.p0;
        a = c.p1;
        var d = this.getEffectiveViewport1(this.b0);
        var e = new ScalerParams(0, a, b, this.p4.cg, d);
        return this.p4.ei(this.qn, e);
    };
    ValueOverlay.prototype.q5 = function (a, b) {
        if (this.p4 == null) {
            return;
        }
        var c = typeCast(CategoryAxisBase.$, this.p4);
        if (c != null && !c.cd) {
            if (this.qn > c.lf - 1) {
                return;
            }
            if (c.categoryMode != 0) {
                var d = this.getEffectiveViewport1(b);
                var e = 0.5 * c.getCategorySize(b.bv, b.bu, d);
                var f = false;
                if (c.co && !c.cg) {
                    f = true;
                }
                if (typeCast(CategoryXAxis.$, c) !== null && c.cg) {
                    f = true;
                }
                if (f) {
                    e = -e;
                }
                a += e;
            }
        }
        var g = typeCast(NumericAxisBase.$, this.p4);
        if (g != null) {
            if (this.qn < g.lv || this.qn > g.lu) {
                return;
            }
            if (g.lh && this.qn < 0) {
                return;
            }
        }
        var h;
        switch (this.p4.a1) {
            case 2:
            case 3:
                h = this.p4.j4(a, b.bv, b.bu, this.getEffectiveViewport1(b), this.pr(b));
                break;
            default:
                h = this.p4.j4(a, b.bv, b.bu);
                break;
        }
        if (h != null) {
            b.by(h);
        }
        if (!b.q) {
            this.q6(a, this.cv());
        }
    };
    ValueOverlay.prototype.e9 = function (a, b, c) {
        var d = true;
        d = _super.prototype.e9.call(this, a, b, c);
        if (!c.o() || b.isEmpty || a.isEmpty || this.p4 == null || this.p4.bh == null) {
            d = false;
        }
        return d;
    };
    ValueOverlay.prototype.m6 = function (a, b) {
        this.mi(false);
    };
    ValueOverlay.prototype.m5 = function (a, b) {
        this.mi(false);
    };
    ValueOverlay.prototype.k0 = function (a, b, c, d) {
        throw new NotImplementedException(0);
    };
    ValueOverlay.prototype.l4 = function (a, b, c, d) {
        _super.prototype.l4.call(this, a, b, c, d);
        switch (b) {
            case ValueOverlay.$$p[11]:
                if (c != null) {
                    c.bz(this);
                }
                if (d != null) {
                    d.cs(this);
                }
                this.mi(false);
                this.lp();
                break;
            case "TransitionProgress":
                this.qm = this.ql + this.g0 * (this.qi - this.ql);
                if (this.cx(this.b0)) {
                    return;
                }
                if (this.g0 == 1) {
                    this.q5(this.qi, this.p7);
                }
                else {
                    this.q5(this.qm, this.p7);
                }
                if (this.cd != null) {
                    this.cd.nn(this);
                }
                break;
            case ValueOverlay.$$p[13]:
                var e = typeCast(NumericAxisBase.$, this.p4);
                if (e != null) {
                    e.c0();
                }
                this.mi(true);
                this.lq();
                break;
            case ValueOverlay.$$p[12]:
            case ValueOverlay.$$p[10]:
            case ValueOverlay.$$p[1]:
            case ValueOverlay.$$p[0]:
            case ValueOverlay.$$p[3]:
            case ValueOverlay.$$p[4]:
            case ValueOverlay.$$p[9]:
            case ValueOverlay.$$p[5]:
            case ValueOverlay.$$p[6]:
            case ValueOverlay.$$p[7]:
            case ValueOverlay.$$p[8]:
                this.mi(true);
                break;
        }
    };
    ValueOverlay.prototype.lf = function () {
        _super.prototype.lf.call(this);
        if (this.p4 != null) {
            this.p4.h7(false);
        }
    };
    ValueOverlay.prototype.kx = function (a, b) {
        _super.prototype.kx.call(this, a, b);
        var c = b;
        c.bx();
    };
    ValueOverlay.prototype.p9 = function () {
        if (this.p4 == null || this.p4.bh == null || isNaN_(this.qn) || this._visibility != 0) {
            return false;
        }
        var a = typeCast(CategoryAxisBase.$, this.p4);
        if (a != null && a.lf == 0) {
            return false;
        }
        return true;
    };
    ValueOverlay.prototype.preferredCategoryMode = function (a) {
        return 0;
    };
    Object.defineProperty(ValueOverlay.prototype, "categoryAxis", {
        get: function () {
            return typeCast(CategoryAxisBase.$, this.p4);
        },
        enumerable: false,
        configurable: true
    });
    ValueOverlay.prototype.bx = function () {
        return new ValueOverlayView(this);
    };
    ValueOverlay.prototype.lz = function (a) {
        _super.prototype.lz.call(this, a);
        this.p7 = typeCast(ValueOverlayView.$, a);
    };
    ValueOverlay.prototype.mk = function (a, b) {
        _super.prototype.mk.call(this, a, b);
        if (!this.ez) {
            this.b0.a2(b);
            return;
        }
        this.b0.a2(b);
        if (this.cx(this.bz) || !this.p9()) {
            return;
        }
        var c = this.getEffectiveViewport1(this.b0);
        var d = this.p4.ei(this.qn, new ScalerParams(0, this.bz.bv, a, this.p4.cg, c));
        this.q5(d, typeCast(ValueOverlayView.$, this.bz));
        this.ez = false;
    };
    ValueOverlay.prototype.getOffsetValue = function () {
        return 0;
    };
    ValueOverlay.prototype.getCategoryWidth = function () {
        return 0;
    };
    Object.defineProperty(ValueOverlay.prototype, "ro", {
        get: function () {
            return new Thickness(1, this.qe, this.qg, this.qf, this.qd);
        },
        enumerable: false,
        configurable: true
    });
    ValueOverlay.prototype.ag = function () {
        return [this.p4];
    };
    ValueOverlay.prototype.q6 = function (a, b) {
        if (isNaN_(a)) {
            if (this.p5 != null) {
                AxisAnnotationFrameManager.b(this.p5);
                AxisAnnotationFrameManager.d(this, this.p5, true, this.qa, this.qb, b, this.qo, this.qo, this.p6, this.p6);
            }
            return;
        }
        var c = false;
        if (this.qa == null) {
            c = true;
            this.qb = new List$1(Axis.$, 0);
            this.qa = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
        }
        this.p5 = new AxisAnnotationFrame();
        var d = this.oz;
        if (d == null) {
            d = this.o3;
        }
        var e = this.p4.co;
        AxisAnnotationFrameManager.c(this.p5, { $type: Point_$type, x: a, y: a }, this, this.cd, this.getEffectiveViewport(), d, this.rl, this.qc, this.rn, this.rm, this.ro, this.qh, this.rl, this.qc, this.rn, this.rm, this.ro, this.qh, !e && this.p8, e && this.p8);
        AxisAnnotationFrameManager.d(this, this.p5, c, this.qa, this.qb, b, this.qo, this.qo, this.p6, this.p6);
    };
    ValueOverlay.prototype.get_isValueOverlay = function () {
        return true;
    };
    ValueOverlay.prototype.q1 = function (a) {
        if (this.p4 != null) {
            return this.p4.gc(a);
        }
        return null;
    };
    Object.defineProperty(ValueOverlay.prototype, "q3", {
        get: function () {
            var a = this.q1(this.qn);
            return a != null ? a : stringFormat("{0:0.##}", this.qn);
        },
        enumerable: false,
        configurable: true
    });
    ValueOverlay.$t = markType(ValueOverlay, 'ValueOverlay', Series.$, [IHasCategoryModePreference_$type]);
    ValueOverlay.$$p = markDep(DependencyProperty, PropertyMetadata, ValueOverlay, 'raisePropertyChanged', ['AxisAnnotationBackgroundCornerRadius:qc:q7', [1, DeviceUtils.g(3)], 'AxisAnnotationBackground:rl:q8', [Brush.$, null], 'AxisAnnotationFormatLabel:p6:q9', [Delegate_$type], 'AxisAnnotationInterpolatedValuePrecision:qo:ra', [1, -1], 'AxisAnnotationOutline:rm:rb', [Brush.$, null], 'AxisAnnotationPaddingBottom:qd:rc', [1, NaN], 'AxisAnnotationPaddingLeft:qe:rd', [1, NaN], 'AxisAnnotationPaddingRight:qf:re', [1, NaN], 'AxisAnnotationPaddingTop:qg:rf', [1, NaN], 'AxisAnnotationStrokeThickness:qh:rg', [1, NaN], 'AxisAnnotationTextColor:rn:rh', [Brush.$, null], 'Axis:p4:ri', [Axis.$, null], 'IsAxisAnnotationEnabled:p8:rj', [0, false], 'Value:qn:rk', [1, 0]]);
    return ValueOverlay;
}(Series));
export { ValueOverlay };
/**
 * @hidden
 */
var ValueOverlayView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ValueOverlayView, _super);
    function ValueOverlayView(a) {
        var _this = _super.call(this, a) || this;
        _this.bz = null;
        _this.bz = new Path();
        return _this;
    }
    ValueOverlayView.prototype.bb = function () {
        _super.prototype.bb.call(this);
        this.bz._stroke = this.e.oz;
        this.bz.ac = this.e.fu;
        this.bz.ai = this.e.pc;
        this.bz.ad = this.e.pd;
    };
    ValueOverlayView.prototype.bc = function () {
        _super.prototype.bc.call(this);
        var a = this.bo();
        this.bz._stroke = a;
        this.bz.ac = this.e.fu + 3;
        this.bz._stroke = a;
        this.bz.ac = this.e.fu + 3;
    };
    ValueOverlayView.prototype.by = function (a) {
        this.bz.ak = a;
        this.aq();
    };
    ValueOverlayView.prototype.bx = function () {
        this.bz.ak = null;
        this.aq();
    };
    ValueOverlayView.prototype.a6 = function (a, b) {
        _super.prototype.a6.call(this, a, b);
        if (a.d) {
            a.s(this.bz);
        }
    };
    ValueOverlayView.prototype.al = function (a) {
        _super.prototype.al.call(this, a);
        this.e.a8.exportPathData(a, this.bz, "ValueOverlayPath", []);
    };
    ValueOverlayView.$t = markType(ValueOverlayView, 'ValueOverlayView', SeriesView.$);
    return ValueOverlayView;
}(SeriesView));
export { ValueOverlayView };
