import { ScatterBase } from "./ScatterBase";
import { IScaleLegendSeries } from "igniteui-angular-core";
import { ISupportsSizeScale } from "./ISupportsSizeScale";
import { ISupportsFillScale } from "./ISupportsFillScale";
import { Rect } from "igniteui-angular-core";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { UIElement } from "igniteui-angular-core";
import { Type } from "igniteui-angular-core";
import { ActualRange } from "./ActualRange";
import { SizeScale } from "./SizeScale";
import { BrushScale } from "./BrushScale";
import { SeriesView } from "./SeriesView";
import { MarkerFillMode } from "./MarkerFillMode";
import { ScatterFrame } from "./ScatterFrame";
import { IChartLegend } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { ScatterBaseView } from "./ScatterBaseView";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { Marker } from "./Marker";
import { BrushSelectionMode } from "./BrushSelectionMode";
import { MarkerManagerBase } from "./MarkerManagerBase";
/**
 * @hidden
 */
export declare class BubbleSeries extends ScatterBase implements IScaleLegendSeries, ISupportsSizeScale, ISupportsFillScale {
    static $t: Type;
    protected get_c4(): boolean;
    protected bx(): SeriesView;
    lz(a: SeriesView): void;
    u5: BubbleSeriesView;
    protected gv(): number;
    p7(): MarkerFillMode;
    constructor();
    private wv;
    private wu;
    isAttachedTo(a: IChartLegend): boolean;
    protected c3(): boolean;
    protected k9(a: (arg1: any) => void): void;
    get vc(): IFastItemColumn$1<number>;
    vi: List$1<UIElement>;
    private wt;
    get legendReady(): boolean;
    get minScaleText(): string;
    get maxScaleText(): string;
    forScaleColors(a: (arg1: Brush, arg2: number) => void): boolean;
    v7: string;
    hw(a: any, b: string): any;
    get ve(): IFastItemColumn$1<number>;
    set ve(a: IFastItemColumn$1<number>);
    private va;
    u7: SizeScale;
    vx: string;
    private u9;
    get vd(): IFastItemColumn$1<any>;
    set vd(a: IFastItemColumn$1<any>);
    vs: string;
    u4: BrushScale;
    private u8;
    get vb(): IFastItemColumn$1<number>;
    set vb(a: IFastItemColumn$1<number>);
    vf: boolean;
    vg: boolean;
    vm: number;
    vl: number;
    vh: boolean;
    tp(a: ScatterBaseView, b: ScatterFrame, c: number, d: Rect, e: Rect): void;
    tx(a: ScatterFrame, b: ScatterBaseView): void;
    private wc;
    static vj(a: number, b: number, c: number, d: number, e: number): number;
    static vk(a: number, b: number, c: number, d: number, logBase_: number, e: number): number;
    e9(a: Rect, b: Rect, c: SeriesView): boolean;
    protected sm(a: string, b: FastItemsSourceEventAction): boolean;
    private wb;
    protected k0(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    li(): void;
    lo(): void;
    protected l4(a: any, b: string, c: any, d: any): void;
    updateSizeScaleGlobals(): void;
    updateFillScaleGlobals(): void;
    u3(a: SizeScale): ActualRange;
    u2(): ActualRange;
    u6: SizeScale;
    we(a: List$1<Marker>, b: List$1<number>, c: Rect, d: boolean): void;
    wd(a: List$1<Marker>): void;
    v3: string;
    vo: string;
    v5: string;
    vq: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    get actualMarkerBrush(): Brush;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CustomPaletteBrushScale extends BrushScale {
    static $t: Type;
    constructor();
    brushSelectionMode: BrushSelectionMode;
    getBrush1(a: number, b: number): Brush;
    protected get_isReady(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class BubbleSeriesView extends ScatterBaseView {
    static $t: Type;
    protected df: BubbleSeries;
    constructor(a: BubbleSeries);
    as(): void;
    protected cu(): MarkerManagerBase;
    dh(): void;
    di(): void;
    dg(): void;
    getDefaultTooltipTemplate(): string;
}
