import { AnnotationLayer } from "./AnnotationLayer";
import { DependencyProperty } from "igniteui-angular-core";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { Base, Type, Point } from "igniteui-angular-core";
import { Series } from "./Series";
import { CalloutPlacementPositionsCollection } from "./CalloutPlacementPositionsCollection";
import { LabelCollisionPlacementPositions } from "igniteui-angular-core";
import { AutoCalloutVisibilityMode } from "./AutoCalloutVisibilityMode";
import { Brush } from "igniteui-angular-core";
import { Thickness } from "igniteui-angular-core";
import { CalloutCollisionMode } from "./CalloutCollisionMode";
import { FontInfo } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { CalloutLayerFrame } from "./CalloutLayerFrame";
import { CalloutAnnotationWrapper } from "./CalloutAnnotationWrapper";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { CalloutLabelUpdatingEventArgs } from "./CalloutLabelUpdatingEventArgs";
import { CalloutSeriesSelectingEventArgs } from "./CalloutSeriesSelectingEventArgs";
import { CalloutStyleUpdatingEventArgs } from "./CalloutStyleUpdatingEventArgs";
import { CalloutRenderStyleUpdatingEventArgs } from "./CalloutRenderStyleUpdatingEventArgs";
import { SeriesView } from "./SeriesView";
import { Frame } from "./Frame";
import { Size } from "igniteui-angular-core";
import { CalloutContentUpdatingEventArgs } from "./CalloutContentUpdatingEventArgs";
import { DataContext } from "igniteui-angular-core";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { HashPool$2 } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { RenderingContext } from "igniteui-angular-core";
import { TextBlock } from "igniteui-angular-core";
import { Visibility } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class CalloutLayer extends AnnotationLayer {
    static $t: Type;
    protected get_c8(): boolean;
    constructor();
    private ue;
    private un;
    private uf;
    protected k0(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    eo(a: boolean): boolean;
    private sj;
    private us;
    private ut;
    calloutStyleUpdating: (sender: any, args: CalloutStyleUpdatingEventArgs) => void;
    calloutRenderStyleUpdating: (sender: any, args: CalloutRenderStyleUpdatingEventArgs) => void;
    ty: string;
    hw(a: any, b: string): any;
    get rx(): IFastItemColumn$1<any>;
    set rx(a: IFastItemColumn$1<any>);
    private rs;
    t9: string;
    get ry(): IFastItemColumn$1<any>;
    set ry(a: IFastItemColumn$1<any>);
    private rt;
    uc: string;
    get rz(): IFastItemColumn$1<any>;
    set rz(a: IFastItemColumn$1<any>);
    private ru;
    tv: string;
    get rw(): IFastItemColumn$1<any>;
    set rw(a: IFastItemColumn$1<any>);
    private rr;
    sc: boolean;
    to: string;
    get rv(): IFastItemColumn$1<any>;
    set rv(a: IFastItemColumn$1<any>);
    private rq;
    private sk;
    private sn;
    private uh;
    protected bx(): SeriesView;
    lz(a: SeriesView): void;
    protected rh: CalloutLayerView;
    private so;
    t0: string;
    rn: Series;
    tl: string;
    private ri;
    get rj(): CalloutPlacementPositionsCollection;
    set rj(a: CalloutPlacementPositionsCollection);
    q8: LabelCollisionPlacementPositions[];
    sb: boolean;
    sf: boolean;
    sg: boolean;
    sh: boolean;
    get rc(): AutoCalloutVisibilityMode;
    set rc(a: AutoCalloutVisibilityMode);
    get rb(): AutoCalloutVisibilityMode;
    set rb(a: AutoCalloutVisibilityMode);
    static readonly u8: DependencyProperty;
    sr: number;
    se: boolean;
    sd: boolean;
    s0: number;
    vs: Brush;
    vp: Brush;
    s1: number;
    vr: Brush;
    vq: Brush;
    get vw(): Thickness;
    st: number;
    sv: number;
    su: number;
    ss: number;
    re: CalloutCollisionMode;
    sw: number;
    sx: number;
    t3: string;
    private ro;
    get rp(): FontInfo;
    protected qp(a: Series, b: boolean): void;
    protected qr(a: Frame, b: SeriesView): void;
    private sl;
    private si;
    private r0;
    private vu;
    protected m6(a: Rect, b: Rect): void;
    protected m5(a: Rect, b: Rect): void;
    private r7;
    private sz;
    private vt;
    get vv(): Rect;
    set vv(a: Rect);
    private r5;
    private uo;
    private uj;
    private r1;
    private s2;
    private s3;
    private r2;
    private ug;
    private r3;
    private sy;
    private sp;
    private s4;
    protected qc(a: Series): boolean;
    ls(): void;
    private r6;
    um(): void;
    calloutContentUpdating: (sender: any, args: CalloutContentUpdatingEventArgs) => void;
    calloutLabelUpdating: (sender: any, args: CalloutLabelUpdatingEventArgs) => void;
    calloutSeriesSelecting: (sender: any, args: CalloutSeriesSelectingEventArgs) => void;
    private sm;
    private up;
    private r9;
    private sa;
    private sq;
    private r8;
    protected bp(): SeriesHitTestMode;
    at(a: Point, b: boolean): DataContext;
    ev(a: Point, b: boolean): boolean;
    protected ur(a: CalloutLayerFrame, b: boolean): void;
    protected qu(a: Frame, b: SeriesView): void;
    protected em(): boolean;
    protected l4(a: any, b: string, c: any, d: any): void;
    private rd;
    private q9;
    private uq;
    private r4;
    private ra;
    private uk;
    private ui;
    private ul;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CalloutLayerView extends AnnotationLayerView {
    static $t: Type;
    constructor(a: CalloutLayer);
    protected b4: CalloutLayer;
    private b9;
    as(): void;
    private b6;
    private cc;
    private ce;
    private cd;
    b8: HashPool$2<CalloutAnnotationWrapper, CalloutView>;
    cm(a: Brush): Brush;
    protected a6(a: RenderingContext, b: boolean): void;
    protected b7(): FontInfo;
    al(a: any): void;
    private ca;
    co(a: TextBlock): Size;
    private cb;
    private b5;
    cn(a: any, b: Thickness): Size;
    cg(a: CalloutView, b: number, c: number): void;
    ch(a: CalloutView, b: CalloutAnnotationWrapper, c: any): void;
    ci(a: Series): Brush;
    cl(): Brush;
    ck(a: Series): Brush;
    cj(a: Series): Brush;
    cf(): void;
}
/**
 * @hidden
 */
export declare class CalloutView extends Base {
    static $t: Type;
    constructor(a: CalloutLayerView);
    private a;
    y: Visibility;
    j(a: RenderingContext): void;
    private l;
    private t;
    private q;
    private s;
    get r(): Point;
    set r(a: Point);
    get p(): Brush;
    set p(a: Brush);
    get o(): Brush;
    set o(a: Brush);
    get n(): Brush;
    set n(a: Brush);
    get m(): Brush;
    set m(a: Brush);
    get e(): number;
    set e(a: number);
    private w;
    private v;
    get x(): Thickness;
    set x(a: Thickness);
    private c;
    get d(): number;
    set d(a: number);
    get h(): any;
    set h(a: any);
    f: number;
    g: number;
    u(): Size;
    private b;
    k(a: Series, b: CalloutAnnotationWrapper, c: any): void;
    i(a: CalloutLayer, b: FontInfo, c: any): void;
}
