import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IShortPeriodLongPeriod } from "./IShortPeriodLongPeriod";
import { IndicatorCalculationStrategy } from "./IndicatorCalculationStrategy";
import { Type } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class PercentagePriceOscillatorIndicator extends StrategyBasedIndicator implements IShortPeriodLongPeriod {
    static $t: Type;
    protected get_uh(): IndicatorCalculationStrategy;
    protected get uh(): IndicatorCalculationStrategy;
    protected get_uu(): Type;
    protected get uu(): Type;
    get shortPeriod(): number;
    set shortPeriod(a: number);
    static readonly u3: DependencyProperty;
    protected up(): number;
    get longPeriod(): number;
    set longPeriod(a: number);
    static readonly u2: DependencyProperty;
    protected um(): number;
}
