import { FinancialIndicator } from "./FinancialIndicator";
import { IndicatorCalculationStrategy } from "./IndicatorCalculationStrategy";
import { Type, IList$1 } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { FinancialCalculationDataSource } from "./FinancialCalculationDataSource";
/**
 * @hidden
 */
export declare abstract class StrategyBasedIndicator extends FinancialIndicator {
    static $t: Type;
    constructor();
    protected uv(): void;
    protected ug: IndicatorCalculationStrategy;
    protected abstract get uh(): IndicatorCalculationStrategy;
    protected abstract get uu(): Type;
    static uk: List$1<string>;
    protected un(): number;
    uw(a: number): void;
    protected up(): number;
    protected um(): number;
    static u0(a: number, b: Type, c: string): DependencyProperty;
    protected static uz(a: number, b: Type): DependencyProperty;
    protected static ux(a: number, b: Type): DependencyProperty;
    protected static u1(a: number, b: Type): DependencyProperty;
    protected tt(a: number, b: number): IList$1<string>;
    protected tq(a: number, b: number): boolean;
    protected uj(a: FinancialCalculationDataSource): boolean;
    private ui;
    protected uo(a: number): number;
    protected qp(a: number, b: number): FinancialCalculationDataSource;
    protected ul(): number;
    protected static uy(a: number, b: Type): DependencyProperty;
    protected l4(a: any, b: string, c: any, d: any): void;
}
