/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { BollingerBandWidthIndicatorStrategy } from "./BollingerBandWidthIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export let BollingerBandWidthIndicator = /*@__PURE__*/ (() => {
    class BollingerBandWidthIndicator extends StrategyBasedIndicator {
        get_uh() {
            return new BollingerBandWidthIndicatorStrategy();
        }
        get uh() {
            return this.get_uh();
        }
        get_uu() {
            return BollingerBandWidthIndicator.$;
        }
        get uu() {
            return this.get_uu();
        }
        get u3() {
            return typeGetValue(this.c(BollingerBandWidthIndicator.u6));
        }
        set u3(a) {
            this.h(BollingerBandWidthIndicator.u6, a);
        }
        un() {
            return this.u3;
        }
        get u2() {
            return this.c(BollingerBandWidthIndicator.u5);
        }
        set u2(a) {
            this.h(BollingerBandWidthIndicator.u5, a);
        }
        ul() {
            return this.u2;
        }
    }
    BollingerBandWidthIndicator.$t = markType(BollingerBandWidthIndicator, 'BollingerBandWidthIndicator', StrategyBasedIndicator.$);
    BollingerBandWidthIndicator.u6 = StrategyBasedIndicator.uz(20, BollingerBandWidthIndicator.$);
    BollingerBandWidthIndicator.u5 = StrategyBasedIndicator.uy(2, BollingerBandWidthIndicator.$);
    return BollingerBandWidthIndicator;
})();
