/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnnotationLayer } from "./AnnotationLayer";
import { Axis } from "./Axis";
import { DependencyProperty } from "igniteui-angular-core";
import { DataToolTipLayerGroupingMode_$type } from "igniteui-angular-core";
import { Series } from "./Series";
import { Rect } from "igniteui-angular-core";
import { Base, enumGetBox, EnumUtil, fromEnum, typeCast, String_$type, typeGetValue, Point_$type, Array_$type, markType, markDep, runOn, TypeRegistrar } from "igniteui-angular-core";
import { Size } from "igniteui-angular-core";
import { RectUtil } from "igniteui-angular-core";
import { DataTooltipGroupedPositionX_$type } from "igniteui-angular-core";
import { DataTooltipGroupedPositionY_$type } from "igniteui-angular-core";
import { DataAbbreviationMode_$type } from "igniteui-angular-core";
import { DataLegendValueMode_$type } from "igniteui-angular-core";
import { Thickness } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { DataLegendHeaderDateMode_$type } from "igniteui-angular-core";
import { DataLegendHeaderTimeMode_$type } from "igniteui-angular-core";
import { DataLegendSummaryType_$type } from "igniteui-angular-core";
import { LegendItemBadgeShape_$type } from "igniteui-angular-core";
import { DataLegendUnitsMode_$type } from "igniteui-angular-core";
import { DataLegendLabelMode_$type } from "igniteui-angular-core";
import { DataToolTipLayerFrame } from "./DataToolTipLayerFrame";
import { Dictionary$2 } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { DataToolTipSeriesInfo } from "./DataToolTipSeriesInfo";
import { DataContext } from "igniteui-angular-core";
import { DataTooltipCollisionInfo } from "./DataTooltipCollisionInfo";
import { DeviceUtils } from "igniteui-angular-core";
import { HashSet$1 } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
import { stringEmpty } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { PointerTooltip } from "./PointerTooltip";
import { IOnDemandRender_$type } from "igniteui-angular-core";
/**
 * @hidden
 */
export let DataToolTipLayer = /*@__PURE__*/ (() => {
    class DataToolTipLayer extends AnnotationLayer {
        constructor() {
            super();
            this.rx = 1;
            this.sz = new Dictionary$2(String_$type, Base.$, 0);
            this.s0 = new List$1(String_$type, 0);
            this.rp = 8;
            this.rt = 11;
            this.sc = null;
            this.r4 = null;
            this.r7 = null;
            this.r9 = null;
            this.r6 = null;
            this.r8 = null;
            this.sb = null;
            this.sa = null;
            this.r5 = null;
            let a = new DataToolTipLayerFrame();
            let b = new DataToolTipLayerFrame();
            let c = new DataToolTipLayerFrame();
            this.p6 = a;
            this.p5 = b;
            this.p7 = c;
            this.ab = DataToolTipLayer.$;
        }
        get_db() {
            return true;
        }
        bx() {
            return new DataToolTipLayerView(this);
        }
        lz(a) {
            super.lz(a);
            this.r1 = a;
        }
        get_dk() {
            return true;
        }
        get ry() {
            return this.rx;
        }
        set ry(a) {
            let b = this.rx;
            this.rx = a;
            if (b != this.rx) {
                this.raisePropertyChanged("ActualGroupingMode", enumGetBox(DataToolTipLayerGroupingMode_$type, b), enumGetBox(DataToolTipLayerGroupingMode_$type, this.rx));
            }
        }
        r0() {
            let a = true;
            let b = true;
            let c = true;
            let d = true;
            if (this.rz != 0) {
                return this.rz;
            }
            let e = this.rg();
            if (e != null) {
                for (let f of fromEnum(e.da())) {
                    if (!f.dc && !f.ec) {
                        a = false;
                    }
                    if (!f.dc && !f.d6) {
                        b = false;
                    }
                    if (!f.dc && !f.ed) {
                        c = false;
                    }
                    if (!f.dc && !f.ea) {
                        d = false;
                    }
                }
            }
            if (a || b || c || d) {
                return 2;
            }
            return 1;
        }
        l4(a, b, c, d) {
            super.l4(a, b, c, d);
            switch (b) {
                case DataToolTipLayer.$$p[37]:
                    this.mi(true);
                    break;
                case DataToolTipLayer.$$p[44]:
                    this.mi(true);
                    break;
                case DataToolTipLayer.$$p[8]:
                    this.ry = this.r0();
                    break;
                case "ActualGroupingMode":
                    this.mi(true);
                    break;
                case DataToolTipLayer.$$p[6]:
                    this.rq = this.rs();
                    break;
                case DataToolTipLayer.$$p[7]:
                    this.ru = this.rw();
                    break;
                case "SeriesViewer":
                    this.r1.ci();
                    break;
                case DataToolTipLayer.$$p[26]:
                case DataToolTipLayer.$$p[20]:
                case DataToolTipLayer.$$p[5]:
                case DataToolTipLayer.$$p[19]:
                case DataToolTipLayer.$$p[4]:
                case DataToolTipLayer.$$p[45]:
                case DataToolTipLayer.$$p[47]:
                case DataToolTipLayer.$$p[48]:
                case DataToolTipLayer.$$p[49]:
                case DataToolTipLayer.$$p[46]:
                case DataToolTipLayer.$$p[52]:
                case DataToolTipLayer.$$p[51]:
                case DataToolTipLayer.$$p[50]:
                case DataToolTipLayer.$$p[53]:
                case DataToolTipLayer.$$p[54]:
                case DataToolTipLayer.$$p[58]:
                case DataToolTipLayer.$$p[57]:
                case DataToolTipLayer.$$p[56]:
                case DataToolTipLayer.$$p[55]:
                case "ValueTextStyle":
                case DataToolTipLayer.$$p[12]:
                case DataToolTipLayer.$$p[11]:
                case DataToolTipLayer.$$p[9]:
                case DataToolTipLayer.$$p[10]:
                case DataToolTipLayer.$$p[13]:
                case DataToolTipLayer.$$p[18]:
                case DataToolTipLayer.$$p[16]:
                case DataToolTipLayer.$$p[17]:
                case DataToolTipLayer.$$p[14]:
                case DataToolTipLayer.$$p[15]:
                case "HeaderTextStyle":
                case DataToolTipLayer.$$p[30]:
                case "SummaryTitleTextStyle":
                case DataToolTipLayer.$$p[33]:
                case DataToolTipLayer.$$p[32]:
                case DataToolTipLayer.$$p[31]:
                case DataToolTipLayer.$$p[29]:
                case DataToolTipLayer.$$p[36]:
                case "SummaryValueTextStyle":
                case DataToolTipLayer.$$p[28]:
                case DataToolTipLayer.$$p[27]:
                case "SummaryLabelTextStyle":
                case DataToolTipLayer.$$p[35]:
                case DataToolTipLayer.$$p[34]:
                case "SummaryUnitsTextStyle":
                case DataToolTipLayer.$$p[0]:
                case DataToolTipLayer.$$p[1]:
                case DataToolTipLayer.$$p[40]:
                case DataToolTipLayer.$$p[43]:
                case DataToolTipLayer.$$p[41]:
                case DataToolTipLayer.$$p[42]:
                case "UnitsTextStyle":
                case DataToolTipLayer.$$p[39]:
                case DataToolTipLayer.$$p[38]:
                case "TitleTextStyle":
                case DataToolTipLayer.$$p[21]:
                case DataToolTipLayer.$$p[22]:
                case DataToolTipLayer.$$p[23]:
                case "LabelTextStyle":
                    this.wh(b, c, d);
                    break;
            }
        }
        wh(a, b, c) {
            if (!this.sz.containsKey(a)) {
                this.s0.add(a);
                this.sz.addItem(a, c);
            }
            else {
                this.sz.item(a, c);
            }
            this.mi(true);
        }
        wl(a, b) {
            switch (a) {
                case DataToolTipLayer.$$p[8]:
                    this.rz = EnumUtil.getEnumValue(DataToolTipLayerGroupingMode_$type, b);
                    break;
                case DataToolTipLayer.$$p[24]:
                    this.s4 = b;
                    break;
                case DataToolTipLayer.$$p[25]:
                    this.s5 = b;
                    break;
                case DataToolTipLayer.$$p[2]:
                    this.s2 = b;
                    break;
                case DataToolTipLayer.$$p[3]:
                    this.s3 = b;
                    break;
                case DataToolTipLayer.$$p[6]:
                    this.rr = EnumUtil.getEnumValue(DataTooltipGroupedPositionX_$type, b);
                    break;
                case DataToolTipLayer.$$p[7]:
                    this.rv = EnumUtil.getEnumValue(DataTooltipGroupedPositionY_$type, b);
                    break;
                case DataToolTipLayer.$$p[26]:
                    this.su = b;
                    break;
                case DataToolTipLayer.$$p[20]:
                    this.re = b;
                    break;
                case DataToolTipLayer.$$p[5]:
                    this.q9 = b;
                    break;
                case DataToolTipLayer.$$p[19]:
                    this.rd = b;
                    break;
                case DataToolTipLayer.$$p[4]:
                    this.q8 = b;
                    break;
                case DataToolTipLayer.$$p[45]:
                    this.ri = EnumUtil.getEnumValue(DataAbbreviationMode_$type, b);
                    break;
                case DataToolTipLayer.$$p[47]:
                    this.t4 = typeGetValue(b);
                    break;
                case DataToolTipLayer.$$p[48]:
                    this.t5 = typeGetValue(b);
                    break;
                case DataToolTipLayer.$$p[49]:
                    this.ro = EnumUtil.getEnumValue(DataLegendValueMode_$type, b);
                    break;
                case DataToolTipLayer.$$p[46]:
                    this.vz = b;
                    break;
                case DataToolTipLayer.$$p[52]:
                    this.sw = b;
                    break;
                case DataToolTipLayer.$$p[51]:
                    this.v5 = b;
                    break;
                case DataToolTipLayer.$$p[50]:
                    this.rf = b;
                    break;
                case DataToolTipLayer.$$p[53]:
                    this.yw = b;
                    break;
                case DataToolTipLayer.$$p[54]:
                    this.sx = b;
                    break;
                case DataToolTipLayer.$$p[58]:
                    this.we = b;
                    break;
                case DataToolTipLayer.$$p[57]:
                    this.sy = b;
                    break;
                case DataToolTipLayer.$$p[56]:
                    this.yx = b;
                    break;
                case DataToolTipLayer.$$p[55]:
                    this.yh = b;
                    break;
                case "ValueTextStyle":
                    this.sl = b;
                    break;
                case DataToolTipLayer.$$p[12]:
                    this.un = b;
                    break;
                case DataToolTipLayer.$$p[11]:
                    this.rc = b;
                    break;
                case DataToolTipLayer.$$p[9]:
                    this.uj = b;
                    break;
                case DataToolTipLayer.$$p[10]:
                    this.rj = EnumUtil.getEnumValue(DataLegendHeaderDateMode_$type, b);
                    break;
                case DataToolTipLayer.$$p[13]:
                    this.rk = EnumUtil.getEnumValue(DataLegendHeaderTimeMode_$type, b);
                    break;
                case DataToolTipLayer.$$p[18]:
                    this.us = b;
                    break;
                case DataToolTipLayer.$$p[16]:
                    this.x9 = b;
                    break;
                case DataToolTipLayer.$$p[17]:
                    this.yq = b;
                    break;
                case DataToolTipLayer.$$p[14]:
                    this.yp = b;
                    break;
                case DataToolTipLayer.$$p[15]:
                    this.sn = b;
                    break;
                case "HeaderTextStyle":
                    this.sd = b;
                    break;
                case DataToolTipLayer.$$p[30]:
                    this.yc = b;
                    break;
                case "SummaryTitleTextStyle":
                    this.sg = b;
                    break;
                case DataToolTipLayer.$$p[33]:
                    this.rm = EnumUtil.getEnumValue(DataLegendSummaryType_$type, b);
                    break;
                case DataToolTipLayer.$$p[32]:
                    this.vb = b;
                    break;
                case DataToolTipLayer.$$p[31]:
                    this.yt = b;
                    break;
                case DataToolTipLayer.$$p[29]:
                    this.ys = b;
                    break;
                case DataToolTipLayer.$$p[36]:
                    this.ye = b;
                    break;
                case "SummaryValueTextStyle":
                    this.si = b;
                    break;
                case DataToolTipLayer.$$p[28]:
                    this.u6 = b;
                    break;
                case DataToolTipLayer.$$p[27]:
                    this.yb = b;
                    break;
                case "SummaryLabelTextStyle":
                    this.sf = b;
                    break;
                case DataToolTipLayer.$$p[35]:
                    this.vh = b;
                    break;
                case DataToolTipLayer.$$p[34]:
                    this.yd = b;
                    break;
                case "SummaryUnitsTextStyle":
                    this.sh = b;
                    break;
                case DataToolTipLayer.$$p[0]:
                    this.yo = b;
                    break;
                case DataToolTipLayer.$$p[1]:
                    this.r3 = EnumUtil.getEnumValue(LegendItemBadgeShape_$type, b);
                    break;
                case DataToolTipLayer.$$p[40]:
                    this.rn = EnumUtil.getEnumValue(DataLegendUnitsMode_$type, b);
                    break;
                case DataToolTipLayer.$$p[43]:
                    this.vs = b;
                    break;
                case DataToolTipLayer.$$p[41]:
                    this.yg = b;
                    break;
                case DataToolTipLayer.$$p[42]:
                    this.yv = b;
                    break;
                case "UnitsTextStyle":
                    this.sk = b;
                    break;
                case DataToolTipLayer.$$p[39]:
                    this.yu = b;
                    break;
                case DataToolTipLayer.$$p[38]:
                    this.yf = b;
                    break;
                case "TitleTextStyle":
                    this.sj = b;
                    break;
                case DataToolTipLayer.$$p[21]:
                    this.rl = EnumUtil.getEnumValue(DataLegendLabelMode_$type, b);
                    break;
                case DataToolTipLayer.$$p[22]:
                    this.ya = b;
                    break;
                case DataToolTipLayer.$$p[23]:
                    this.yr = b;
                    break;
                case "LabelTextStyle":
                    this.se = b;
                    break;
            }
        }
        wi(a) {
            for (let b = 0; b < this.s0.count; b++) {
                let c = this.s0._inner[b];
                a.updatePropertyByName(c, this.sz.item(c));
            }
        }
        qo(a, b) {
            {
                if (!this.as.c) {
                    this.mi(b);
                }
            }
        }
        qp(a, b) {
            if (!this.as.c) {
                this.mi(b);
            }
        }
        qr(a, b) {
            super.qr(a, b);
            this.rx = this.r0();
            let c = a;
            let d = this.r1.b6;
            let e = this.sv;
            let f = false;
            c.m.clear();
            c.i.clear();
            c.l.clear();
            c.g.clear();
            c.f.clear();
            c.k.clear();
            c.j.clear();
            c.h.clear();
            if (isNaN_(this.q5.x) && isNaN_(this.q5.y)) {
                d.count = 0;
                return;
            }
            {
                if (this.ry == 2) {
                    let g = 0;
                    {
                        for (let h of fromEnum(this.cd.series)) {
                            if (this.qc(h)) {
                                this.wk(h, c, e, f, g);
                                g++;
                            }
                            if (h.isStacked) {
                                h.la((i) => {
                                    if (this.qc(i)) {
                                        this.wk(i, c, e, f, g);
                                        g++;
                                    }
                                    return true;
                                });
                            }
                        }
                        this.wg(c);
                    }
                    d.count = g;
                }
                else {
                    let i = this.rg();
                    let j = this.s1(i);
                    let k = this.r2(i, j, e);
                    this.wj(k, c, e);
                }
            }
        }
        s1(a) {
            let b = new List$1(Series.$, 0);
            if (a == null) {
                return b;
            }
            for (let c of fromEnum(a.dd)) {
                b.add(c);
            }
            return b;
        }
        rg() {
            if (this.rh != null) {
                return this.rh;
            }
            if (this.cd == null) {
                return null;
            }
            for (let a of fromEnum(this.cd.series)) {
                if (a.dg) {
                    let b = a.ar();
                    if (b != null && b.cn()) {
                        return b;
                    }
                }
            }
            for (let c of fromEnum(this.cd.series)) {
                if (!c.dg) {
                    let d = c.ag();
                    let e = d != null && d.length > 0 ? d[0] : null;
                    if (e != null && e.cn()) {
                        return e;
                    }
                }
            }
            return null;
        }
        r2(a, b, c) {
            let d = 1.7976931348623157E+308;
            let e = -1.7976931348623157E+308;
            let f = new List$1(DataContext.$, 0);
            let g = new List$1(Base.$, 0);
            let h = false;
            let i = true;
            let j = { $type: Point_$type, x: NaN, y: NaN };
            let k = 0;
            let l = 0;
            for (let m = 0; m < b.count; m++) {
                let n = b.item(m);
                k = n.cd.l;
                l = n.cd.m;
                if (n.dg) {
                    let o = n;
                    let p = new List$1(Series.$, 0);
                    if (o.isStacked) {
                        o.la((q) => {
                            p.add(q);
                            return true;
                        });
                    }
                    else {
                        p.add(o);
                    }
                    for (let q = 0; q < p.count; q++) {
                        let r = p._inner[q];
                        let s = p._inner[q];
                        if (!r.categoryAxis.cn()) {
                            continue;
                        }
                        if (i) {
                            h = s.isVertical;
                        }
                        else {
                            if (h != s.isVertical) {
                                continue;
                            }
                        }
                        let t = this.qk(s);
                        if (!t.c) {
                            continue;
                        }
                        j = s.ph(t.d);
                        let u = s.pm(t.d, c, false);
                        if (h) {
                            if (!isNaN_(u.y)) {
                                d = Math.min(d, u.y);
                                e = Math.max(e, u.y);
                            }
                        }
                        else {
                            if (!isNaN_(u.x)) {
                                d = Math.min(d, u.x);
                                e = Math.max(e, u.x);
                            }
                        }
                    }
                }
                else {
                    let v = n.ag();
                    for (let w = 0; w < v.length; w++) {
                        if (!v[w].cn()) {
                            continue;
                        }
                    }
                    let x = n.pm(this.q5, c, false);
                    j = n.ph(this.q5);
                    if (h) {
                        if (!isNaN_(x.y)) {
                            d = Math.min(d, x.y);
                            e = Math.max(e, x.y);
                        }
                    }
                    else {
                        if (!isNaN_(x.x)) {
                            d = Math.min(d, x.x);
                            e = Math.max(e, x.x);
                        }
                    }
                }
                let y = null;
                let z = n.ht(this.q5);
                if (n.dl && z != null) {
                    y = n.au(z);
                }
                else {
                    y = new DataContext();
                    y.item = z;
                    y.series = n;
                }
                f.add(y);
            }
            let aa = 0;
            let ab = 0;
            if (h) {
                ab = (d + e) / 2;
                aa = this.pz.right;
                if (!isNaN_(j.x)) {
                    aa = j.x;
                }
                if (ab < 0 || ab > this.pz.bottom) {
                    ab = NaN;
                }
            }
            else {
                aa = (d + e) / 2;
                if (!isNaN_(j.y)) {
                    ab = j.y;
                }
                if (aa < 0 || aa > this.pz.right) {
                    aa = NaN;
                }
            }
            let ac = new DataToolTipSeriesInfo();
            ac.f = { $type: Point_$type, x: aa, y: ab };
            ac.e = { $type: Point_$type, x: j.x, y: j.y };
            ac.b = f;
            ac.a = h;
            return ac;
        }
        ld() {
            this.q5 = { $type: Point_$type, x: NaN, y: NaN };
            this.mi(false);
            this.r1.cg(false);
        }
        le() {
            this.q5 = { $type: Point_$type, x: NaN, y: NaN };
            this.mi(false);
            this.r1.cg(true);
        }
        get yl() {
            let a = RectUtil.n(this.b0.bu);
            let b = new Size(1, this.b0.bu.width, this.b0.bu.height);
            return new Rect(3, a, b);
        }
        get yk() {
            let a = RectUtil.n(this.b0.bu);
            let b = new Size(1, this.b0.bu.width, this.b0.bu.height);
            return new Rect(3, this.r1.cj(a), b);
        }
        get yj() {
            let a = new Rect(0, 0, 0, this.cd.m, this.cd.l);
            let b = RectUtil.n(a);
            let c = new Size(1, a.width, a.height);
            return new Rect(3, this.r1.cj(b), c);
        }
        get yn() {
            let a = { $type: Point_$type, x: 0, y: 0 };
            return new Rect(3, a, this.r1.co());
        }
        ym() {
            return this.yl;
        }
        sr(a, b, c) {
            if (Rect.l_op_Equality(a, Rect.empty)) {
                return false;
            }
            let d = a.top;
            return c < d;
        }
        so(a, b, c, d) {
            if (Rect.l_op_Equality(a, Rect.empty)) {
                return false;
            }
            let e = a.bottom;
            return c + d.height >= e;
        }
        sp(a, b, c) {
            if (Rect.l_op_Equality(a, Rect.empty)) {
                return false;
            }
            let d = a.left;
            return c < d;
        }
        sq(a, b, c, d) {
            if (Rect.l_op_Equality(a, Rect.empty)) {
                return false;
            }
            let e = a.right;
            return c + d.width > e;
        }
        tu(a, b) {
            return a.top + b;
        }
        ts(a, b, c) {
            return a.bottom - c.height - b;
        }
        tt(a, b) {
            return ((a.bottom + a.top) / 2) - (b.height / 2);
        }
        t3(a, b, c, d, e) {
            let f = c.y - d.height - b;
            return f;
        }
        t1(a, b, c, d, e) {
            let f = c.y + b;
            return f;
        }
        t2(a, b, c, d, e) {
            let f = c.y - (d.height / 2);
            return f;
        }
        tx(a, b, c, d, e) {
            let f = c.y - d.height;
            f = f - b;
            return f;
        }
        tv(a, b, c, d, e) {
            let f = c.y;
            f = f + b;
            return f;
        }
        tw(a, b, c, d, e) {
            let f = c.y - (d.height / 2);
            return f;
        }
        td(a, b) {
            return a.left + b;
        }
        tf(a, b, c) {
            return (a.right - (c.width)) - b;
        }
        te(a, b, c) {
            return ((a.right + a.left) / 2) - (c.width / 2) + b;
        }
        tm(a, b, c, d, e) {
            let f = (c.x - d.width) - b;
            return f;
        }
        to(a, b, c, d, e) {
            let f = c.x + b;
            return f;
        }
        tn(a, b, c, d, e) {
            let f = (c.x - (d.width / 2));
            f = f + b;
            return f;
        }
        tj(a, b, c, d, e) {
            let f = c.x - d.width;
            f = f - b;
            return f;
        }
        tl(a, b, c, d, e) {
            let f = c.x;
            f = f + b;
            return f;
        }
        tk(a, b, c, d, e) {
            let f = c.x - (d.width / 2);
            f = f + b;
            return f;
        }
        s9(a, b, c, d, e, f, g, h) {
            switch (a) {
                case 1:
                    {
                        return this.tx(e, b, h, f, true);
                    }
                case 2:
                    {
                        return this.tv(e, b, h, f, true);
                    }
                case 3:
                    {
                        return this.tw(e, b, h, f, true);
                    }
                case 5: return this.ty(e, c, b, h, f);
                case 6: return this.tz(e, c, b, h, f);
                case 4: return this.t0(e, c, b, h, f);
                case 8: return this.tp(e, c, b, h, f);
                case 9: return this.tq(e, c, b, h, f);
                case 7: return this.tr(e, c, b, h, f);
                case 13: return this.tu(d, b);
                case 14: return this.ts(d, b, f);
                case 15: return this.tt(d, f);
                case 10: return this.t3(e, b, g, f, true);
                case 12: return this.t2(e, b, g, f, true);
                case 11:
                default: return this.t1(e, b, g, f, true);
            }
        }
        tg(a, b, c, d, e) {
            let f = d.x;
            f = f + b / 2;
            f = f - e.width;
            f = f - c;
            return f;
        }
        th(a, b, c, d, e) {
            let f = d.x;
            f = f + b / 2;
            f = f - e.width / 2;
            f = f + c;
            return f;
        }
        ti(a, b, c, d, e) {
            let f = d.x;
            f = f + b / 2;
            f = f + c;
            return f;
        }
        ta(a, b, c, d, e) {
            let f = d.x;
            f = f - b / 2;
            f = f - e.width;
            f = f - c;
            return f;
        }
        tb(a, b, c, d, e) {
            let f = d.x;
            f = f - b / 2;
            f = f - e.width / 2;
            f = f + c;
            return f;
        }
        tc(a, b, c, d, e) {
            let f = d.x;
            f = f - b / 2;
            f = f + c;
            return f;
        }
        tr(a, b, c, d, e) {
            let f = d.y;
            f = f + b / 2;
            f = f - e.height;
            f = f - c;
            return f;
        }
        tq(a, b, c, d, e) {
            let f = d.y;
            f = f + b / 2;
            f = f - e.height / 2;
            f = f + c;
            return f;
        }
        tp(a, b, c, d, e) {
            let f = d.y;
            f = f + b / 2;
            f = f + c;
            return f;
        }
        t0(a, b, c, d, e) {
            let f = d.y;
            f = f - b / 2;
            f = f - e.height;
            f = f - c;
            return f;
        }
        tz(a, b, c, d, e) {
            let f = d.y;
            f = f - b / 2;
            f = f - e.height / 2;
            f = f + c;
            return f;
        }
        ty(a, b, c, d, e) {
            let f = d.y;
            f = f - b / 2;
            f = f + c;
            return f;
        }
        s8(a, b, c, d, e, f, g, h) {
            switch (a) {
                case 10: return this.tm(e, b, g, f, true);
                case 11: return this.to(e, b, g, f, true);
                case 12: return this.tn(e, b, g, f, true);
                case 13: return this.td(d, b);
                case 14: return this.tf(e, b, f);
                case 15: return this.te(e, b, f);
                case 5: return this.tc(e, c, b, h, f);
                case 6: return this.tb(e, c, b, h, f);
                case 4: return this.ta(e, c, b, h, f);
                case 8: return this.ti(e, c, b, h, f);
                case 9: return this.th(e, c, b, h, f);
                case 7: return this.tg(e, c, b, h, f);
                case 1:
                    {
                        return this.tj(e, b, h, f, true);
                    }
                case 3:
                    {
                        return this.tk(e, b, h, f, true);
                    }
                case 2:
                default:
                    {
                        return this.tl(e, b, h, f, true);
                    }
            }
        }
        yi(a, b, c, d) {
            let e = this.rq;
            let f = this.ru;
            let g = this.rg();
            let h = 0;
            if (g != null && g.ca && this.cd != null) {
                h = g.getCategorySize(this.cd.sf, this.pz, this.getEffectiveViewport());
                if (g.categoryMode == 0) {
                    h = 0;
                }
            }
            let i = this.s6(e);
            let j = this.s7(f);
            let k = this.s8(e, i, h, this.yl, a, b, c, d);
            let l = this.s9(f, j, h, this.yl, a, b, c, d);
            let m = this.ss(a, i, k, b);
            let n = this.st(a, j, l, b);
            if (!m) {
                let o = this.ra(e);
                let p = 0;
                while (!m && p < o.length) {
                    e = o[p];
                    i = this.s6(e);
                    k = this.s8(e, i, h, this.yl, a, b, c, d);
                    m = this.ss(a, i, k, b);
                    p++;
                }
            }
            if (!n) {
                let q = this.rb(f);
                let r = 0;
                while (!n && r < q.length) {
                    f = q[r];
                    j = this.s7(f);
                    l = this.s9(f, j, h, this.yl, a, b, c, d);
                    n = this.st(a, j, l, b);
                    r++;
                }
            }
            return { $type: Point_$type, x: k, y: l };
        }
        s7(a) {
            if (!isNaN_(this.s5)) {
                return this.s5;
            }
            switch (a) {
                case 1: return this.s3;
                case 2: return this.s3;
                case 3: return 0;
                case 4: return this.s3;
                case 5: return this.s3;
                case 6: return this.s3;
                case 7: return this.s3;
                case 8: return this.s3;
                case 9: return 0;
                case 10: return this.s3;
                case 11: return this.s3;
                case 12: return 0;
                case 13: return this.s3;
                case 14: return this.s3;
                case 15: return 0;
            }
            return this.s3;
        }
        s6(a) {
            if (!isNaN_(this.s4)) {
                return this.s4;
            }
            switch (a) {
                case 4: return this.s2;
                case 6: return 0;
                case 5: return this.s2;
                case 13: return this.s2;
                case 15: return 0;
                case 14: return this.s2;
                case 7: return this.s2;
                case 9: return 0;
                case 8: return this.s2;
                case 1: return this.s2;
                case 3: return 0;
                case 2: return this.s2;
                case 10: return this.s2;
                case 12: return 0;
                case 11: return this.s2;
            }
            return this.s2;
        }
        rb(a) {
            let b = [a];
            switch (a) {
                case 1:
                    b = [2, 3];
                    break;
                case 2:
                    b = [1, 3];
                    break;
                case 3:
                    b = [1, 2];
                    break;
                case 4:
                    b = [8, 7, 3];
                    break;
                case 5:
                    b = [7, 8, 3];
                    break;
                case 6:
                    b = [9, 8, 4, 3];
                    break;
                case 7:
                    b = [5, 4, 2];
                    break;
                case 8:
                    b = [4, 5, 3];
                    break;
                case 9:
                    b = [6, 4, 8, 3];
                    break;
                case 10:
                    b = [11, 12];
                    break;
                case 11:
                    b = [10, 12];
                    break;
                case 12:
                    b = [10, 11];
                    break;
                case 13: break;
                case 14: break;
                case 15: break;
            }
            return b;
        }
        ra(a) {
            let b = [a];
            switch (a) {
                case 1:
                    b = [2, 3];
                    break;
                case 2:
                    b = [1, 3];
                    break;
                case 3:
                    b = [1, 2];
                    break;
                case 4:
                    b = [8, 7, 3];
                    break;
                case 5:
                    b = [7, 8, 1];
                    break;
                case 6:
                    b = [9, 8, 4, 3];
                    break;
                case 7:
                    b = [5, 4, 2];
                    break;
                case 8:
                    b = [4, 5, 3];
                    break;
                case 9:
                    b = [6, 4, 8, 3];
                    break;
                case 10:
                    b = [11, 12];
                    break;
                case 11:
                    b = [10, 12];
                    break;
                case 12:
                    b = [10, 11];
                    break;
                case 13: break;
                case 14: break;
                case 15: break;
            }
            return b;
        }
        ss(a, b, c, d) {
            return !(this.sp(a, b, c) || this.sq(a, b, c, d));
        }
        st(a, b, c, d) {
            return !(this.sr(a, b, c) || this.so(a, b, c, d));
        }
        wg(a) {
            let b = new List$1(DataTooltipCollisionInfo.$, 0);
            for (let c = 0; c < a.f.count; c++) {
                let d = new DataTooltipCollisionInfo();
                d.d = c;
                d.e = { $type: Point_$type, x: a.f._inner[c], y: a.g._inner[c] };
                d.c = a.k._inner[c];
                d.a = a.j._inner[c];
                d.b = a.m._inner[c];
                if (isNaN_(d.e.x) || isNaN_(d.e.y)) {
                    continue;
                }
                b.add(d);
            }
            b.aa((e, f) => {
                if (e.e.y < f.e.y) {
                    return -1;
                }
                if (e.e.y > f.e.y) {
                    return 1;
                }
                if (e.b < f.b) {
                    return -1;
                }
                if (e.b > f.b) {
                    return 1;
                }
                return 0;
            });
            let e = this.sm(b);
            if (!e) {
                return;
            }
            for (let f = 0; f < b.count - 1; f++) {
                let g = b._inner[f];
                let h = b._inner[f + 1];
                let i = new Rect(0, g.e.x, g.e.y, g.c, g.a);
                let j = new Rect(0, h.e.x, h.e.y, h.c, h.a);
                if (i.intersectsWith(j) || i.top > j.bottom) {
                    h.e = { $type: Point_$type, x: h.e.x, y: i.bottom + 1 };
                }
            }
            if (b._inner[b.count - 1].e.y + b._inner[b.count - 1].a > this.b0.bu.height) {
                b._inner[b.count - 1].e = { $type: Point_$type, x: b._inner[b.count - 1].e.x, y: b._inner[b.count - 1].e.y - ((b._inner[b.count - 1].e.y + b._inner[b.count - 1].a) - this.b0.bu.height) };
            }
            for (let k = b.count - 1; k >= 1; k--) {
                let l = b._inner[k];
                let m = b._inner[k - 1];
                let n = new Rect(0, l.e.x, l.e.y, l.c, l.a);
                let o = new Rect(0, m.e.x, m.e.y, m.c, m.a);
                if (n.intersectsWith(o) || n.top < o.bottom) {
                    m.e = { $type: Point_$type, x: m.e.x, y: n.top - (o.height + 1) };
                }
            }
            for (let p = 0; p < b.count; p++) {
                let q = b._inner[p].d;
                let r = b._inner[p];
                a.f._inner[q] = r.e.x;
                a.g._inner[q] = r.e.y;
            }
        }
        sm(a) {
            if (a.count <= 1) {
                return false;
            }
            let b = this.b0.bu;
            for (let c = 0; c < a.count - 1; c++) {
                let d = a._inner[c];
                let e = a._inner[c + 1];
                let f = new Rect(0, d.e.x, d.e.y, d.c, d.a);
                let g = new Rect(0, e.e.x, e.e.y, e.c, e.a);
                if (f.intersectsWith(g)) {
                    return true;
                }
            }
            return false;
        }
        wk(a, b, c, d, e) {
            let f = this.qk(a);
            if (!f.c) {
                return;
            }
            let g = a.pm(f.d, c, d);
            let h = this.r1.b6;
            let i = this.q5;
            if (!c) {
                i = this.pp(g);
            }
            let j = a.ht(i);
            let k = h.item(e);
            let l = this.b0.bu;
            let m = this.r1.b5(k);
            if (!Base.equalsStatic(m.target, this.cd)) {
                m.target = this.cd;
            }
            m.includedSeries = [a.dataLegendKey];
            this.wi(m);
            if (!this.r1.b8(k, a)) {
                return;
            }
            let n = this.r1.cn(k);
            b.i.add1(k);
            let o = g.x;
            let p = g.x;
            p = Math.max(p, l.left);
            p = Math.min(p, l.right);
            b.l.add(p);
            let q = g.y;
            q = Math.max(q, l.top);
            q = Math.min(q, l.bottom);
            b.m.add(q);
            let r = DeviceUtils.g(10);
            let s = g.x + r;
            if (s + n.width > l.right) {
                s = (o - n.width) - r;
            }
            if (s < l.left) {
                s = l.left;
            }
            b.f.add(s);
            let t = (g.y - n.height) - r;
            if (t + n.height > l.bottom) {
                t = (l.bottom - n.height) - r;
            }
            if (t < l.top) {
                t = l.top;
            }
            b.g.add(t);
            b.k.add(n.width);
            b.j.add(n.height);
            let u = this.oz;
            if (u == null) {
                u = this.o3;
            }
            if (u == null) {
                u = a.oz;
            }
            b.h.add(u);
        }
        wj(a, b, c) {
            this.rp = this.rs();
            this.rt = this.rw();
            let d = a.f;
            let e = a.e;
            let f = 0;
            let g = this.r1.b6.item(0);
            this.r1.b8(g, null);
            let h = this.r1.b5(g);
            if (!Base.equalsStatic(h.target, this.cd)) {
                h.target = this.cd;
            }
            let i = new List$1(String_$type, 0);
            let j = this.rg();
            if (j != null) {
                for (let k of fromEnum(j.da())) {
                    if (k.isStacked) {
                        k.la((l) => {
                            i.add(l.dataLegendKey);
                            return true;
                        });
                    }
                    else {
                        i.add(k.dataLegendKey);
                    }
                }
                h.includedSeries = i.toArray();
            }
            else {
                h.includedSeries = null;
            }
            this.wi(h);
            h.targetCursorPositionX = this.q5.x;
            h.targetCursorPositionY = this.q5.y;
            let l = this.r1.cn(g);
            let m = 0;
            let n = 0;
            let o = 0;
            let p = 0;
            let q = false;
            let r = false;
            o = d.x;
            p = d.y;
            let s = this.b0.bu;
            let t = this.r1.co();
            let u = this.ym();
            let v = this.yi(u, l, e, d);
            let w = v.x;
            let x = v.y;
            {
            }
            b.l.add(w);
            b.m.add(x);
            b.f.add(w);
            b.g.add(x);
            b.k.add(l.width);
            b.j.add(l.height);
            b.i.add1(g);
            let y = null;
            b.h.add(y);
            this.r1.b6.count = 1;
        }
        t6(a) {
            return a.toolTip;
        }
        qu(a, b) {
            super.qu(a, b);
            let c = a;
            let d = c.m.count;
            let e = b.bu.left;
            let f = b.bu.right;
            let g = b.bu.top;
            let h = b.bu.bottom;
            for (let i = 0; i < d; i++) {
                if (isNaN_(c.l._inner[i]) || isNaN_(c.m._inner[i]) || isNaN_(c.f._inner[i]) || isNaN_(c.g._inner[i])) {
                    this.r1.cf(c.i._inner[i]);
                    continue;
                }
                let j = c.f._inner[i];
                let k = c.g._inner[i];
                let l = c.k._inner[i];
                let m = c.j._inner[i];
                let n = false;
                if (n) {
                    this.r1.cf(c.i._inner[i]);
                    continue;
                }
                let o = c.i._inner[i];
                let p = Math.min(c.f._inner[i], c.l._inner[i]);
                let q = Math.min(c.g._inner[i], c.m._inner[i]);
                let r = c.l._inner[i] - c.f._inner[i];
                let s = c.m._inner[i] - c.g._inner[i];
                this.r1.ch(o, p, q, r, s);
            }
        }
        em() {
            return true;
        }
        get rq() {
            return this.rp;
        }
        set rq(a) {
            let b = this.rp;
            this.rp = a;
            if (b != this.rp) {
                this.raisePropertyChanged("ActualGroupedPositionModeX", enumGetBox(DataTooltipGroupedPositionX_$type, b), enumGetBox(DataTooltipGroupedPositionX_$type, this.rp));
            }
        }
        rs() {
            if (this.cd == null) {
                return 2;
            }
            let a = false;
            let b = false;
            let c = false;
            let d = false;
            let e = this.rg();
            if (e == null) {
                return 2;
            }
            for (let f of fromEnum(e.dd)) {
                if (f.dh) {
                    a = true;
                }
                if (f.isVertical) {
                    b = true;
                }
                if (f.d6) {
                    c = true;
                }
                if (f.ec) {
                    d = true;
                }
            }
            let g = ((() => {
                let $ret = new HashSet$1(DataTooltipGroupedPositionX_$type, 0);
                $ret.add_1(1);
                $ret.add_1(2);
                $ret.add_1(3);
                $ret.add_1(4);
                $ret.add_1(5);
                $ret.add_1(6);
                $ret.add_1(7);
                $ret.add_1(8);
                $ret.add_1(9);
                return $ret;
            })());
            let h = g.contains(this.rr);
            if (this.rr != 0) {
                if (h && b) {
                    return 11;
                }
                return this.rr;
            }
            if (c || d) {
                return 11;
            }
            if (b) {
                return 11;
            }
            if (a) {
                return 8;
            }
            return 8;
        }
        get ru() {
            return this.rt;
        }
        set ru(a) {
            let b = this.rt;
            this.rt = a;
            if (b != this.rt) {
                this.raisePropertyChanged("ActualPositionModeY", enumGetBox(DataTooltipGroupedPositionY_$type, b), enumGetBox(DataTooltipGroupedPositionY_$type, this.rt));
            }
        }
        rw() {
            if (this.cd == null) {
                return 11;
            }
            let a = false;
            let b = false;
            let c = false;
            let d = this.rg();
            if (d == null) {
                return 11;
            }
            for (let e of fromEnum(d.da())) {
                if (e.isVertical) {
                    a = true;
                }
                if (e.d6) {
                    b = true;
                }
                if (e.ec) {
                    c = true;
                }
            }
            let f = ((() => {
                let $ret = new HashSet$1(DataTooltipGroupedPositionY_$type, 0);
                $ret.add_1(1);
                $ret.add_1(2);
                $ret.add_1(3);
                $ret.add_1(4);
                $ret.add_1(5);
                $ret.add_1(6);
                $ret.add_1(7);
                $ret.add_1(8);
                $ret.add_1(9);
                return $ret;
            })());
            let g = f.contains(this.rv);
            if (this.rv != 0) {
                if (g && !a) {
                    return 11;
                }
                return this.rv;
            }
            if (b || c) {
                return 11;
            }
            if (a) {
                return 8;
            }
            if (!a) {
                return 11;
            }
            return 11;
        }
        get sl() {
            return this.sc;
        }
        set sl(a) {
            let b = this.sc;
            this.sc = a;
            if (b != this.sc) {
                this.raisePropertyChanged("ValueTextStyle", b, this.sc);
            }
        }
        get sd() {
            return this.r4;
        }
        set sd(a) {
            let b = this.r4;
            this.r4 = a;
            if (b != this.r4) {
                this.raisePropertyChanged("HeaderTextStyle", b, this.r4);
            }
        }
        get sg() {
            return this.r7;
        }
        set sg(a) {
            let b = this.r7;
            this.r7 = a;
            if (b != this.r7) {
                this.raisePropertyChanged("SummaryTitleTextStyle", b, this.r7);
            }
        }
        get si() {
            return this.r9;
        }
        set si(a) {
            let b = this.r9;
            this.r9 = a;
            if (b != this.r9) {
                this.raisePropertyChanged("SummaryValueTextStyle", b, this.r9);
            }
        }
        get sf() {
            return this.r6;
        }
        set sf(a) {
            let b = this.r6;
            this.r6 = a;
            if (b != this.r6) {
                this.raisePropertyChanged("SummaryLabelTextStyle", b, this.r6);
            }
        }
        get sh() {
            return this.r8;
        }
        set sh(a) {
            let b = this.r8;
            this.r8 = a;
            if (b != this.r8) {
                this.raisePropertyChanged("SummaryUnitsTextStyle", b, this.r8);
            }
        }
        get sk() {
            return this.sb;
        }
        set sk(a) {
            let b = this.sb;
            this.sb = a;
            if (b != this.sb) {
                this.raisePropertyChanged("UnitsTextStyle", b, this.sb);
            }
        }
        get sj() {
            return this.sa;
        }
        set sj(a) {
            let b = this.sa;
            this.sa = a;
            if (b != this.sa) {
                this.raisePropertyChanged("TitleTextStyle", b, this.sa);
            }
        }
        get se() {
            return this.r5;
        }
        set se(a) {
            let b = this.r5;
            this.r5 = a;
            if (b != this.r5) {
                this.raisePropertyChanged("LabelTextStyle", b, this.r5);
            }
        }
    }
    DataToolTipLayer.$t = markType(DataToolTipLayer, 'DataToolTipLayer', AnnotationLayer.$);
    DataToolTipLayer.$$p = markDep(DependencyProperty, PropertyMetadata, DataToolTipLayer, 'raisePropertyChanged', ['BadgeMargin:yo:wm', [Thickness.$, new Thickness(1, 0, 0, 0, 0)], 'BadgeShape:r3:wn', [LegendItemBadgeShape_$type, enumGetBox(LegendItemBadgeShape_$type, 0)], 'DefaultPositionOffsetX:s2:wo', [1, DeviceUtils.g(10)], 'DefaultPositionOffsetY:s3:wp', [1, DeviceUtils.g(10)], 'ExcludedColumns:q8:wq', [Array_$type, null], 'ExcludedSeries:q9:wr', [Array_$type, null], 'GroupedPositionModeX:rr:ws', [DataTooltipGroupedPositionX_$type, enumGetBox(DataTooltipGroupedPositionX_$type, 0)], 'GroupedPositionModeY:rv:wt', [DataTooltipGroupedPositionY_$type, enumGetBox(DataTooltipGroupedPositionY_$type, 0)], 'GroupingMode:rz:wu', [DataToolTipLayerGroupingMode_$type, enumGetBox(DataToolTipLayerGroupingMode_$type, 0)], 'HeaderFormatCulture:uj:wv', [2, stringEmpty()], 'HeaderFormatDate:rj:ww', [DataLegendHeaderDateMode_$type, enumGetBox(DataLegendHeaderDateMode_$type, 0)], 'HeaderFormatSpecifiers:rc:wx', [Array_$type, null], 'HeaderFormatString:un:wy', [2, null], 'HeaderFormatTime:rk:wz', [DataLegendHeaderTimeMode_$type, enumGetBox(DataLegendHeaderTimeMode_$type, 0)], 'HeaderRowMargin:yp:w0', [Thickness.$, new Thickness(0, 5)], 'HeaderRowVisible:sn:w1', [0, true], 'HeaderTextColor:x9:w2', [Brush.$, null], 'HeaderTextMargin:yq:w3', [Thickness.$, new Thickness(1, 2, 0, 0, 0)], 'HeaderText:us:w4', [2, null], 'IncludedColumns:rd:w5', [Array_$type, null], 'IncludedSeries:re:w6', [Array_$type, null], 'LabelDisplayMode:rl:w7', [DataLegendLabelMode_$type, enumGetBox(DataLegendLabelMode_$type, 0)], 'LabelTextColor:ya:w8', [Brush.$, null], 'LabelTextMargin:yr:w9', [Thickness.$, new Thickness(1, 8, 0, 0, 0)], 'PositionOffsetX:s4:xa', [1, NaN], 'PositionOffsetY:s5:xb', [1, NaN], 'ShouldUpdateWhenSeriesDataChanges:su:xc', [0, true], 'SummaryLabelTextColor:yb:xd', [Brush.$, null], 'SummaryLabelText:u6:xe', [2, null], 'SummaryRowMargin:ys:xf', [Thickness.$, new Thickness(0, 5)], 'SummaryTitleTextColor:yc:xg', [Brush.$, null], 'SummaryTitleTextMargin:yt:xh', [Thickness.$, new Thickness(1, 2, 0, 0, 0)], 'SummaryTitleText:vb:xi', [2, null], 'SummaryType:rm:xj', [DataLegendSummaryType_$type, enumGetBox(DataLegendSummaryType_$type, 0)], 'SummaryUnitsTextColor:yd:xk', [Brush.$, null], 'SummaryUnitsText:vh:xl', [2, null], 'SummaryValueTextColor:ye:xm', [Brush.$, null], 'TargetAxis:rh:xn', [Axis.$, null], 'TitleTextColor:yf:xo', [Brush.$, null], 'TitleTextMargin:yu:xp', [Thickness.$, new Thickness(1, 0, 0, 0, 0)], 'UnitsDisplayMode:rn:xq', [DataLegendUnitsMode_$type, enumGetBox(DataLegendUnitsMode_$type, 0)], 'UnitsTextColor:yg:xr', [Brush.$, null], 'UnitsTextMargin:yv:xs', [Thickness.$, new Thickness(1, 0, 0, 0, 0)], 'UnitsText:vs:xt', [2, null], 'UseInterpolation:sv:xu', [0, false], 'ValueFormatAbbreviation:ri:xv', [DataAbbreviationMode_$type, enumGetBox(DataAbbreviationMode_$type, 0)], 'ValueFormatCulture:vz:xw', [2, stringEmpty()], 'ValueFormatMaxFractions:t4:xx', [1, -1], 'ValueFormatMinFractions:t5:xy', [1, -1], 'ValueFormatMode:ro:xz', [DataLegendValueMode_$type, enumGetBox(DataLegendValueMode_$type, 0)], 'ValueFormatSpecifiers:rf:x0', [Array_$type, null], 'ValueFormatString:v5:x1', [2, null], 'ValueFormatUseGrouping:sw:x2', [0, true], 'ValueRowMargin:yw:x3', [Thickness.$, new Thickness(0, 5)], 'ValueRowVisible:sx:x4', [0, true], 'ValueTextColor:yh:x5', [Brush.$, null], 'ValueTextMargin:yx:x6', [Thickness.$, new Thickness(1, 2, 0, 2, 0)], 'ValueTextUseSeriesColors:sy:x7', [0, false], 'ValueTextWhenMissingData:we:x8', [2, "N/A"]]);
    return DataToolTipLayer;
})();
/**
 * @hidden
 */
export let DataToolTipLayerView = /*@__PURE__*/ (() => {
    class DataToolTipLayerView extends AnnotationLayerView {
        constructor(a) {
            super(a);
            this.b6 = null;
            this.b9 = null;
            this.b4 = null;
            this.b7 = false;
            this._htmlTest = null;
            this.b4 = a;
            this.htmlTest = /^[^<]*(<[\w\W]+>)[^>]*$/;
            this.b9 = new List$1(PointerTooltip.$, 0);
        }
        aj() {
            super.aj();
            for (let a = 0; a < this.b6.a.count; a++) {
                this.b6.a._inner[a].br();
            }
            for (let b = 0; b < this.b6.b.count; b++) {
                this.b6.b._inner[b].br();
            }
            this.b6.clear();
        }
        ca() {
            let a = new PointerTooltip();
            a.bw(this.e.g9);
            a._visibility = 1;
            a.ap = this.e.cd.cq.k;
            let b = null;
            if (TypeRegistrar.isRegistered("XamDataLegend")) {
                b = TypeRegistrar.create("XamDataLegend");
            }
            b.pixelScalingRatio = 1;
            if (this.e.cd != null) {
                let c = this.e.cd.cq.j.ae.createElement("div");
                let ren_ = this.e.cd.cq.j.ae.getSubRenderer(c);
                let len_ = b;
                len_.provideContainer(ren_);
            }
            a.ai = typeCast(IOnDemandRender_$type, b);
            a.ai.shouldOnDemandRender = true;
            this.b9.add(a);
            return a;
        }
        cc(a) {
            let b = a;
        }
        ce(a) {
            let b = a;
            b._visibility = 1;
        }
        cd(a) {
            let b = a;
            b.bz();
            b.content = null;
            this.b9.remove1(a);
        }
        as() {
            super.as();
            this.b6 = ((() => {
                let $ret = new Pool$1(Base.$);
                $ret.create = runOn(this, this.ca);
                $ret.activate = runOn(this, this.cc);
                $ret.disactivate = runOn(this, this.ce);
                $ret.destroy = runOn(this, this.cd);
                return $ret;
            })());
        }
        get htmlTest() {
            return this._htmlTest;
        }
        set htmlTest(a) {
            this._htmlTest = a;
        }
        b8(a, b) {
            let c = a;
            let d = c.ai;
            return true;
        }
        cn(a) {
            let b = a;
            let c = new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY);
            b.cy = 1;
            let d = b.cx(new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
            b.cy = 0;
            return d;
        }
        cm() {
            if (this.e.cd != null) {
                let a = this.e.cd.r8();
                let b = this.e.cd.cq.a8;
                let c = this.e.cd.cq.a7;
                return new Rect(0, 0, 0, b, c);
            }
            return Rect.empty;
        }
        cl() {
            if (this.e.cd != null) {
                let a = this.e.cd.r8();
                let b = this.e.cd.cq.a8;
                let c = this.e.cd.cq.a7;
                return new Rect(0, 0, 0, b, c);
            }
            return Rect.empty;
        }
        ck() {
            let a = 0;
            let b = 0;
            if (this.e.cd != null) {
                let c = this.e.cd.r8();
                a += c.x;
                b += c.y;
                let d = this.e.cd.cq.a8;
                let e = this.e.cd.cq.a7;
                return new Rect(0, a, b, d, e);
            }
            return Rect.empty;
        }
        cj(a) {
            let b = 0;
            let c = 0;
            if (this.e.cd != null) {
                let d = this.e.cd.r8();
                b += d.x;
                c += d.y;
            }
            return { $type: Point_$type, x: b + a.x, y: c + a.y };
        }
        ch(a, b, c, d, e) {
            let f = null;
            if (this.e.cd != null) {
                f = this.e.cd.cq.j.i();
            }
            let g = a;
            if (g == null) {
                return;
            }
            if (d == 0 && e == 0) {
                g.cy = 1;
            }
            else {
                g.cy = 0;
            }
            g.aq = f;
            g.cs = { $type: Point_$type, x: d, y: e };
            g._visibility = 0;
            g.n = b;
            g.o = c;
        }
        co() {
            let a = (window.innerWidth);
            let b = (window.innerHeight);
            return new Size(1, a, b);
        }
        cf(a) {
            if (a != null) {
                let b = a;
                b._visibility = 1;
            }
        }
        ci() {
            if (this.e.cd == null) {
                this.cg(true);
            }
        }
        a6(a, b) {
            super.a6(a, b);
            if (b) {
                return;
            }
            let c = 0;
            let d = 0;
            let e = this.e.cd;
            if (e != null) {
                let f = e.cq.j.b7();
                c += f.x;
                d += f.y;
            }
            for (let g = 0; g < this.b9.count; g++) {
                this.b9._inner[g].by(this.b9._inner[g].n + c, this.b9._inner[g].o + d);
            }
        }
        al(a) {
            super.al(a);
            for (let b = 0; b < this.b9.count; b++) {
                let c = this.b9._inner[b];
                let d = 0;
                let e = 0;
                if (this.e.cd != null) {
                    let f = this.e.cd.r8();
                    d += f.x;
                    e += f.y;
                }
                let g = c.a5();
                let h = c.n - d;
                let i = c.o - e;
                let j = c.ai;
                let k = null;
                if (j != null) {
                    k = j.exportVisualData();
                }
                this.e.a8.addPointerTooltipWithDataLegend(a, g, h, i, k);
            }
        }
        b5(a) {
            let b = a;
            return b.ai;
        }
        cg(a) {
            this.aq();
            for (let b = 0; b < this.b9.count; b++) {
                this.cf(this.b9._inner[b]);
                if (a) {
                    this.b9._inner[b].bs();
                }
            }
        }
    }
    DataToolTipLayerView.$t = markType(DataToolTipLayerView, 'DataToolTipLayerView', AnnotationLayerView.$);
    return DataToolTipLayerView;
})();
