/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType } from "igniteui-angular-core";
import { IFinancialPriceSeriesProxy_$type } from "./IFinancialPriceSeriesProxy";
/**
 * @hidden
 */
export let FinancialPriceSeriesProxy = /*@__PURE__*/ (() => {
    class FinancialPriceSeriesProxy extends Base {
        getCloseMemberPath(a) {
            return a.sg;
        }
        getHighMemberPath(a) {
            return a.sj;
        }
        getLowMemberPath(a) {
            return a.so;
        }
        getOpenMemberPath(a) {
            return a.ss;
        }
        getVolumeMemberPath(a) {
            return a.sw;
        }
        matchesType(a) {
            if (!a.dp) {
                return false;
            }
            if (a.dq || a.dr) {
                return false;
            }
            return true;
        }
        setCategoryMode(a, b) {
            a.qk = b;
        }
        setCloseMemberPath(a, b) {
            a.sg = b;
        }
        setDisplayType(a, b) {
            a.to = b;
        }
        setHighMemberPath(a, b) {
            a.sj = b;
        }
        setLowMemberPath(a, b) {
            a.so = b;
        }
        setOpenMemberPath(a, b) {
            a.ss = b;
        }
        setVolumeMemberPath(a, b) {
            a.sw = b;
        }
        setXAxis(a, b) {
            a.qc = b;
        }
        setYAxis(a, b) {
            a.qy = b;
        }
    }
    FinancialPriceSeriesProxy.$t = markType(FinancialPriceSeriesProxy, 'FinancialPriceSeriesProxy', Base.$, [IFinancialPriceSeriesProxy_$type]);
    return FinancialPriceSeriesProxy;
})();
