/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ScatterTriangulationSeries } from "./ScatterTriangulationSeries";
import { ColorScale } from "./ColorScale";
import { runOn, delegateRemove, delegateCombine, typeCast, Point_$type, markType, markDep } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { FastItemIntColumn } from "igniteui-angular-core";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { TriangleRasterizer } from "./TriangleRasterizer";
import { ScalerParams } from "./ScalerParams";
import { ObservableColorCollection } from "igniteui-angular-core";
import { Color } from "igniteui-angular-core";
import { ColorUtil } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { CustomPaletteColorScale } from "./CustomPaletteColorScale";
import { DataLegendSeriesValueInfo } from "igniteui-angular-core";
import { DataLegendSeriesContext } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { truncate, intDivide } from "igniteui-angular-core";
import { boxArray$1 } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
import { CanvasViewRenderer } from "igniteui-angular-core";
import { Rectangle } from "igniteui-angular-core";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
/**
 * @hidden
 */
export let ScatterAreaSeries = /*@__PURE__*/ (() => {
    class ScatterAreaSeries extends ScatterTriangulationSeries {
        constructor() {
            super();
            this.rz = null;
            this.r4 = null;
            this.rx = null;
            this.ry = null;
            FastItemIntColumn.m();
            this.ab = ScatterAreaSeries.$;
        }
        get_dd() {
            return true;
        }
        get r1() {
            return this.rz;
        }
        set r1(a) {
            let b = this.rz != a;
            if (b) {
                let c = this.rz;
                if (this.rz != null) {
                    let d = this.rz;
                    d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.si));
                }
                this.rz = a;
                if (this.rz != null) {
                    let e = this.rz;
                    e.propertyChanged = delegateCombine(e.propertyChanged, runOn(this, this.si));
                }
                this.raisePropertyChanged("ColorScale", c, this.rz);
            }
        }
        si(a, b) {
            this.sk();
            this.mi(false);
        }
        hw(a, b) {
            let c = this.jq(b);
            if (c == ScatterAreaSeries.$$p[3]) {
                return this.hx(a, b, this.sd);
            }
            return super.hw(a, b);
        }
        get r5() {
            return this.r4;
        }
        set r5(a) {
            let b = this.r5 != a;
            if (b) {
                let c = this.r5;
                this.r4 = a;
                this.raisePropertyChanged("ColorColumn", c, this.r5);
            }
        }
        get_e3() {
            return true;
        }
        set_e3(a) {
            super.set_e3(a);
        }
        l4(a, b, c, d) {
            super.l4(a, b, c, d);
            switch (b) {
                case "FastItemsSource":
                    let e = typeCast(IFastItemsSource_$type, c);
                    if (e != null) {
                        e.deregisterColumn(this.r5);
                        this.r5 = null;
                    }
                    let f = typeCast(IFastItemsSource_$type, d);
                    if (f != null) {
                        this.r5 = this.ch(this.sd);
                    }
                    this.mi(false);
                    break;
                case ScatterAreaSeries.$$p[3]:
                    if (this.ck != null) {
                        this.ck.deregisterColumn(this.r5);
                        this.r5 = this.ch(this.sd);
                    }
                    this.mi(false);
                    this.lp();
                    break;
                case "ColorScale":
                    this.sk();
                    this.mi(false);
                    this.lp();
                    break;
            }
        }
        mj(a) {
            super.mj(a);
            this.sj(this.b0);
        }
        mh(a, b, c, d, e) {
            super.mh(a, b, c, d, e);
            let f = this.a6.a$h.item(d);
            f.a1(c);
            if (this.cx(f)) {
                return;
            }
            this.sj(f);
        }
        sj(a) {
            if (this.cx(a)) {
                return;
            }
            let b;
            let c;
            let d = a.getViewInfo(c, b);
            c = d.p0;
            b = d.p1;
            let e = a;
            let f = null;
            let g = null;
            let h = this.p4;
            let i = this.p5;
            let j = this.getEffectiveViewport1(a);
            let k = new ScalerParams(1, b, c, h.cg);
            k.c = j;
            let l = new ScalerParams(1, b, c, i.cg);
            l.c = j;
            g = this.r3(a, k, l);
            if (g != null) {
                e.b8(g);
            }
            else {
                e.cb(f);
            }
        }
        sg(a) {
            let b;
            let c;
            let d = a.getViewInfo(b, c);
            b = d.p0;
            c = d.p1;
            let e = truncate(Math.round(b.width)) * truncate(Math.round(b.height));
            let f = a.b0;
            if (f == null || f.length != e) {
                f = new Array(e);
                for (let g = 0; g < e; g++) {
                    f[g] = 0;
                }
            }
            else {
                for (let h = 0; h < e; h++) {
                    f[h] = 0;
                }
            }
            a.b0 = f;
        }
        ht(a) {
            let b = truncate(Math.round(this.pz.width));
            let c = truncate(Math.round(this.pz.height));
            let d = this.b0.b0;
            if (d == null || d.length != (b * c) || this.qe == null || this.qe.count < 1 || this.qf == null || this.qf.count < 1 || this.qg == null || this.qg.count < 1) {
                return null;
            }
            let e = this.cd.sv;
            let f = (a.x - e.left) / e.width;
            let g = (a.y - e.top) / e.height;
            let h = truncate(Math.round(b * f));
            let i = truncate(Math.round(c * g));
            let j = (b * i) + h;
            if (j < 0 || j > d.length - 1) {
                return null;
            }
            let k = d[j] - 1;
            if (k < 0 || k > this.qe.count) {
                return null;
            }
            let l = this.rx.length;
            let m = this.qe.item(k);
            let n = this.qf.item(k);
            let o = this.qg.item(k);
            if ((m >= l) || (n >= l) || (o >= l)) {
                return null;
            }
            let p = (this.rx[m] - this.pz.left) / this.pz.width;
            let q = (this.ry[m] - this.pz.top) / this.pz.height;
            let r = (this.rx[n] - this.pz.left) / this.pz.width;
            let s = (this.ry[n] - this.pz.top) / this.pz.height;
            let t = (this.rx[o] - this.pz.left) / this.pz.width;
            let u = (this.ry[o] - this.pz.top) / this.pz.height;
            let v = Math.pow(p - f, 2) + Math.pow(q - g, 2);
            let w = Math.pow(r - f, 2) + Math.pow(s - g, 2);
            let x = Math.pow(t - f, 2) + Math.pow(u - g, 2);
            if (v < w && v < x) {
                return this.ck.item(m);
            }
            if (w < v && w < x) {
                return this.ck.item(n);
            }
            if (x < v && x < w) {
                return this.ck.item(o);
            }
            return this.ck.item(m);
        }
        r3(a, b, c) {
            let d;
            let e;
            let f = a.getViewInfo(e, d);
            e = f.p0;
            d = f.p1;
            e = new Rect(0, 0, 0, e.width, e.height);
            b = new ScalerParams(0, b.e, e, b.a, b.c);
            c = new ScalerParams(0, c.e, e, c.a, c.c);
            c.b = this.gc();
            let g = a;
            let h = this.p4;
            let i = this.p5;
            let j = this.qe.count;
            let k;
            let xArr_ = this.qh.asArray();
            k = (xArr_.slice(0));
            let l;
            let yArr_ = this.qi.asArray();
            l = (yArr_.slice(0));
            let m = this.r5.asArray();
            let n = this.qe.asArray();
            let o = this.qf.asArray();
            let p = this.qg.asArray();
            this.rx = k;
            this.ry = l;
            h.hm(boxArray$1(k), 0, k.length, b);
            i.hm(boxArray$1(l), 0, l.length, c);
            let q = this.r0;
            let r = g.b2(b.d, q, this.r5);
            let s = e.top;
            let t = e.left;
            let u = e.right;
            let v = e.bottom;
            let w;
            let x;
            let y;
            let z;
            this.sg(g);
            let aa = g.b0;
            let ab = k.length;
            for (let ac = 0; ac < j; ac++) {
                let ad = n[ac];
                let ae = o[ac];
                let af = p[ac];
                if ((ad >= ab) || (ae >= ab) || (af >= ab) || (ad < 0) || (ae < 0) || (af < 0)) {
                    continue;
                }
                let ag = k[ad];
                let ah = l[ad];
                let ai = { $type: Point_$type, x: ag, y: ah };
                let aj = k[ae];
                let ak = l[ae];
                let al = { $type: Point_$type, x: aj, y: ak };
                let am = k[af];
                let an = l[af];
                let ao = { $type: Point_$type, x: am, y: an };
                w = al.y < ao.y ? al.y : ao.y;
                w = ai.y < w ? ai.y : w;
                x = al.y > ao.y ? al.y : ao.y;
                x = ai.y > x ? ai.y : x;
                y = al.x < ao.x ? al.x : ao.x;
                y = ai.x < y ? ai.x : y;
                z = al.x > ao.x ? al.x : ao.x;
                z = ai.x > z ? ai.x : z;
                if (w < v && x > s && y < u && z > t) {
                    let ap = m[ad];
                    let aq = m[ae];
                    let ar = m[af];
                    r.p(ac, aa, ai, al, ao, ap, aq, ar);
                }
            }
            return r;
        }
        r6() {
            let a = new Color();
            let b = this.oz;
            if (b == null) {
                a = ColorUtil.r("#000000");
            }
            else {
                a = ColorUtil.q(b);
            }
            let c = new ObservableColorCollection();
            c.add(ColorUtil.v(a, -0.5));
            c.add(a);
            return c;
        }
        sk() {
            let a = this.r1;
            if (a == null) {
                a = ((() => {
                    let $ret = new CustomPaletteColorScale();
                    $ret.palette = this.r6();
                    $ret.interpolationMode = 2;
                    return $ret;
                })());
            }
            else if (typeCast(CustomPaletteColorScale.$, a) !== null) {
                let b = a;
                if (b.palette == null || b.palette.count == 0) {
                    b.palette = this.r6();
                }
                a = b;
            }
            let c = new ObservableColorCollection();
            if (typeCast(CustomPaletteColorScale.$, a) !== null) {
                c = a.palette;
            }
            else {
                c = this.r6();
            }
            this.r0 = a;
        }
        mw() {
            super.mw();
            this.sk();
        }
        kx(a, b) {
            super.kx(a, b);
            let c = b;
            c.b7();
        }
        bx() {
            return new ScatterAreaSeriesView(this);
        }
        lz(a) {
            super.lz(a);
            this.r2 = typeCast(ScatterAreaSeriesView.$, a);
        }
        sh(a) {
            if (this.r2 != null) {
                this.r2.b6(a);
            }
        }
        getDataLegendSeriesContextAt(a, b) {
            let c = { $type: Point_$type, x: a, y: b };
            let d = this.ht(c);
            let e = d == null ? NaN : this.gb(d, "XMemberPath");
            let f = d == null ? NaN : this.gb(d, "YMemberPath");
            let g = d == null ? NaN : this.gb(d, "ColorMemberPath");
            let h = new DataLegendSeriesValueInfo();
            h.l = e;
            h.a = 13;
            h.p = this.q6 != null ? this.q6 : "X";
            h.q = this.q2 != null ? this.q2 : "X:";
            h.r = this.q4 != null ? this.q4 : "";
            let i = new DataLegendSeriesValueInfo();
            i.l = f;
            i.a = 14;
            i.p = this.re != null ? this.re : "Y";
            i.q = this.ra != null ? this.ra : "Y:";
            i.r = this.rc != null ? this.rc : "";
            let j = new DataLegendSeriesValueInfo();
            j.l = g;
            j.a = 0;
            j.p = this.sd != null ? this.sd : "Value";
            j.q = this.r9 != null ? this.r9 : "V:";
            j.r = this.sb != null ? this.sb : "";
            let k = new DataLegendSeriesContext();
            k.f = ((() => {
                let $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
                $ret.add(h);
                $ret.add(i);
                $ret.add(j);
                return $ret;
            })());
            k.b = this.av();
            return k;
        }
    }
    ScatterAreaSeries.$t = markType(ScatterAreaSeries, 'ScatterAreaSeries', ScatterTriangulationSeries.$);
    ScatterAreaSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterAreaSeries, 'raisePropertyChanged', ['ActualColorScale:r0:sl', [ColorScale.$, null], 'ColorMemberAsLegendLabel:r9:sm', [2, null], 'ColorMemberAsLegendUnit:sb:sn', [2, null], 'ColorMemberPath:sd:so', [2, null]]);
    return ScatterAreaSeries;
})();
/**
 * @hidden
 */
export let ScatterAreaSeriesView = /*@__PURE__*/ (() => {
    class ScatterAreaSeriesView extends SeriesView {
        constructor(a) {
            super(a);
            this.b1 = null;
            this.bx = null;
            this.b5 = null;
            this.b4 = null;
            this.b3 = null;
            this.b1 = a;
        }
        get b0() {
            return this.bx;
        }
        set b0(a) {
            this.bx = a;
        }
        ca(a, b) {
        }
        b6(a) {
        }
        by() {
            return this.bz(true);
        }
        bz(a) {
            this.b9();
            let b = truncate(Math.round(this.bu.left));
            let c = truncate(Math.round(this.bu.left));
            let d = truncate(Math.round(this.bu.width));
            let e = truncate(Math.round(this.bu.height));
            let f = d.toString();
            let g = e.toString();
            if (this.b4.getAttribute("width") != f) {
                this.b4.setAttribute("width", d.toString());
            }
            if (this.b4.getAttribute("height") != g) {
                this.b4.setAttribute("height", e.toString());
            }
            let h = this.b3.g();
            if (a) {
                h.clearRect(0, 0, d, e);
            }
            this.b5 = h.getImageData(0, 0, d, e);
            let imageDataArray_ = this.b5.data;
            return imageDataArray_;
        }
        b9() {
            if (this.b4 == null) {
                this.b4 = this.e.g9.createElement("canvas");
                let a = this.e.g9.get2DCanvasContext(this.b4);
                this.b3 = new RenderingContext(new CanvasViewRenderer(), a);
            }
        }
        b2(a, b, c) {
            let d = truncate(Math.round(this.bu.left));
            let e = truncate(Math.round(this.bu.left));
            let f = truncate(Math.round(this.bu.width));
            let g = truncate(Math.round(this.bu.height));
            return new TriangleRasterizer(this.by(), b, c.minimum, c.maximum, c, f, g);
        }
        b8(a) {
            this.cb(null);
        }
        b7() {
            if (this.b3 != null) {
                this.b3.k(this.bu.left, this.bu.top, this.bu.width, this.bu.height);
            }
            this.aq();
        }
        a6(a, b) {
            super.a6(a, b);
            if (this.b4 == null) {
                return;
            }
            if (b) {
                let c = new Rectangle();
                c.n = this.bu.left;
                c.o = this.bu.top;
                c.width = this.bu.width;
                c.height = this.bu.height;
                c._fill = this.bo();
                a.v(c);
            }
            else {
                let d = truncate(Math.round(this.bu.left));
                let e = truncate(Math.round(this.bu.top));
                let f = truncate(Math.round(this.bu.width));
                let g = truncate(Math.round(this.bu.height));
                a.m(this.b4.getNativeElement(), 1, d, e, f, g);
            }
        }
        cb(a) {
            let b = truncate(Math.round(this.bu.left));
            let c = truncate(Math.round(this.bu.left));
            let d = truncate(Math.round(this.bu.width));
            let e = truncate(Math.round(this.bu.height));
            this.b9();
            this.b3.g().putImageData(this.b5, 0, 0);
            this.aq();
        }
        al(a) {
            super.al(a);
            let b = truncate(Math.round(this.bu.width));
            let c = truncate(Math.round(this.bu.height));
            let d = this.bz(false);
            if (d == null || d.length == 0) {
                this.e.a8.exportSeriesPixelsData(a, null, b, c);
                return;
            }
            let e = new Array(intDivide(d.length, 4));
            let f;
            for (let g = 0; g < intDivide(d.length, 4); g++) {
                f = g * 4;
                e[g] = d[f + 3] << 24 | d[f] << 16 | d[f + 1] << 8 | d[f + 2];
            }
            this.e.a8.exportSeriesPixelsData(a, e, b, c);
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'><span";
            let b = this.e.a6.a$r(this.e);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.b1.title + "</span><br/><span>" + "(${item." + this.b1.q6 + "}, ${item." + this.b1.re + "})</span>";
            if (!stringIsNullOrEmpty(this.b1.sd)) {
                a += "<span>, Value: ${item." + this.b1.sd + "}</span>";
            }
            a += "</div>";
            return a;
        }
    }
    ScatterAreaSeriesView.$t = markType(ScatterAreaSeriesView, 'ScatterAreaSeriesView', SeriesView.$);
    return ScatterAreaSeriesView;
})();
