/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Series } from "./Series";
import { DependencyProperty } from "igniteui-angular-core";
import { HighlightingInfo } from "./HighlightingInfo";
import { ShapeItemSearchMode_$type } from "./ShapeItemSearchMode";
import { IEnumerable$1_$type, enumGetBox, Number_$type, Point_$type, typeCast, fromEnum, runOn, Array_$type, markType, markDep } from "igniteui-angular-core";
import { NumericXAxis } from "./NumericXAxis";
import { NumericYAxis } from "./NumericYAxis";
import { List$1 } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { StyleShapeEventArgs } from "./StyleShapeEventArgs";
import { FrameworkElement } from "igniteui-angular-core";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { Tuple$2 } from "igniteui-angular-core";
import { ShapeHitRegion } from "./ShapeHitRegion";
import { RectUtil } from "igniteui-angular-core";
import { Tuple$3 } from "igniteui-angular-core";
import { GeometryUtil } from "igniteui-angular-core";
import { AssigningShapeStyleEventArgs } from "./AssigningShapeStyleEventArgs";
import { AssigningShapeMarkerStyleEventArgs } from "./AssigningShapeMarkerStyleEventArgs";
import { PointCollectionUtil } from "igniteui-angular-core";
import { FlattenedShape } from "./FlattenedShape";
import { SeriesView } from "./SeriesView";
import { Clipper } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { Dictionary$2 } from "igniteui-angular-core";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { PolySimplification } from "igniteui-angular-core";
import { DefaultFlattener } from "./DefaultFlattener";
import { AxisRange } from "./AxisRange";
import { Style } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { boxArray$1 } from "igniteui-angular-core";
import { InvalidOperationException } from "igniteui-angular-core";
import { isNaN_, truncate } from "igniteui-angular-core";
import { FastItemObjectColumn } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { PointCollection } from "igniteui-angular-core";
import { PathGeometry } from "igniteui-angular-core";
import { PolyLineSegment } from "igniteui-angular-core";
import { PathFigure } from "igniteui-angular-core";
import { PolygonUtil } from "igniteui-angular-core";
/**
 * @hidden
 */
export let ShapeSeriesBase = /*@__PURE__*/ (() => {
    class ShapeSeriesBase extends Series {
        constructor() {
            super();
            this.qx = false;
            this.qw = false;
            this.qi = null;
            this.qj = null;
            this.qo = 1;
            this.p8 = null;
            this.p9 = null;
            this.assigningShapeStyle = null;
            this.assigningShapeMarkerStyle = null;
            this.qs = null;
            this.qu = null;
            this.qk = null;
            this.qm = null;
            this.rh = 0;
            this.rd = null;
            this.p5 = null;
            this.p7 = null;
            this.p6 = null;
            this.p4 = null;
            this.so = null;
            this.rk = 0;
            this.styleShape = null;
            this.qs = new ShapeSeriesRenderManager();
            FastItemObjectColumn.m();
            this.rk = this.rj;
            this.so = Rect.empty;
        }
        ku() {
            super.ku();
            this.ql = null;
            this.qn = null;
        }
        ag() {
            return [this.ql, this.qn];
        }
        hw(a, b) {
            let c = this.jq(b);
            if (c == ShapeSeriesBase.$$p[6]) {
                return this.hx(a, b, this.rx);
            }
            return null;
        }
        get_dx() {
            return true;
        }
        get_c2() {
            return true;
        }
        qg(a, b, c) {
            let d = this.ph(b);
            let e = this.qt.cz(d, false);
            let f = -1;
            if (e == null) {
                if (a != null) {
                    f = this.ck.indexOf(a);
                }
                else {
                    return null;
                }
            }
            else if (e.dataContext != null) {
                f = e.dataContext.c;
            }
            if (f == -1) {
                return null;
            }
            let g = new HighlightingInfo();
            g.b = this;
            g.h = f;
            g.g = f;
            g.d = false;
            if (c != null && c.h == g.h && c.g == g.g) {
                return c;
            }
            return g;
        }
        qh(a, b, c) {
            let d = this.qt.b1(this.ph(b));
            let e = -1;
            if (d == null) {
                if (a != null) {
                    e = this.ck.indexOf(a);
                }
                else {
                    return null;
                }
            }
            else {
                e = d.ak;
            }
            if (e == -1) {
                return null;
            }
            let f = new HighlightingInfo();
            f.b = this;
            f.h = e;
            f.g = e;
            f.d = false;
            f.e = true;
            if (c != null && c.h == f.h && c.g == f.g) {
                return c;
            }
            return f;
        }
        get qp() {
            return this.qo;
        }
        set qp(a) {
            let b = this.qo;
            this.qo = a;
            if (b != this.qo) {
                this.raisePropertyChanged("ActualItemSearchMode", enumGetBox(ShapeItemSearchMode_$type, b), enumGetBox(ShapeItemSearchMode_$type, this.qo));
            }
        }
        qq() {
            if (this.qr != 0) {
                return this.qr;
            }
            return 1;
        }
        f5(a) {
            switch (this.qp) {
                case 1: return this.r3(a).c;
                case 2: return this.ri(a);
                case 3: return this.ri(a);
            }
            return -1;
        }
        r3(a) {
            let b = this.ph(a);
            let c = { $type: Point_$type, x: NaN, y: NaN };
            let d = this.qt.cb;
            if (d == null) {
                return new Tuple$2(Number_$type, Point_$type, -1, c);
            }
            let e = this.qt.b2(b, false, !this.qy);
            if (e != null) {
                c = RectUtil.l(e.d);
                return new Tuple$2(Number_$type, Point_$type, e.b, c);
            }
            let f = b.x;
            let g = b.y;
            if (this.ck == null || this.ql == null || this.qn == null || this.rd == null) {
                return new Tuple$2(Number_$type, Point_$type, -1, c);
            }
            if (this.ck.count > this.rn) {
                return new Tuple$2(Number_$type, Point_$type, -1, c);
            }
            let h = 1.7976931348623157E+308;
            let i = -1;
            for (let j = 0; j < d.count; j++) {
                let k = d._inner[j].d;
                let l = RectUtil.g(k, b);
                if (l < h) {
                    h = l;
                    i = d._inner[j].b;
                    c = RectUtil.l(d._inner[j].d);
                }
            }
            return new Tuple$2(Number_$type, Point_$type, i, c);
        }
        r2(a) {
            let b = this.ph(a);
            let c = b.x;
            let d = b.y;
            let e = { $type: Point_$type, x: NaN, y: NaN };
            if (this.ck == null || this.ql == null || this.qn == null || this.rd == null) {
                return new Tuple$3(Number_$type, Point_$type, Point_$type, -1, e, e);
            }
            if (this.ck.count > this.rn) {
                return new Tuple$3(Number_$type, Point_$type, Point_$type, -1, e, e);
            }
            let f = 1.7976931348623157E+308;
            let g = this.qt.cb;
            if (g == null) {
                return new Tuple$3(Number_$type, Point_$type, Point_$type, -1, e, e);
            }
            let h = this.qt.b2(b, false, !this.qy);
            if (h != null) {
                let i = RectUtil.l(h.d);
                let j = this.r1(b, h.a, this.qy);
                return new Tuple$3(Number_$type, Point_$type, Point_$type, h.b, j.d, i);
            }
            for (let k = 0; k < g.count; k++) {
                let l = g._inner[k].d;
                let m = RectUtil.g(l, b);
                let n = (l.width * l.width) + (l.height * l.height) + m;
                if (n <= f) {
                    f = n;
                }
            }
            let o = 1.7976931348623157E+308;
            let p = -1;
            for (let q = 0; q < g.count; q++) {
                let r = g._inner[q].d;
                let s = RectUtil.g(r, b);
                if (s < f) {
                    let t = this.r1(b, g._inner[q].a, this.qy);
                    if (t.c < o) {
                        o = t.c;
                        e = t.d;
                        p = q;
                    }
                }
            }
            if (p >= 0) {
                return new Tuple$3(Number_$type, Point_$type, Point_$type, g._inner[p].b, e, RectUtil.l(g._inner[p].d));
            }
            return new Tuple$3(Number_$type, Point_$type, Point_$type, -1, e, e);
        }
        get_qy() {
            return true;
        }
        get qy() {
            return this.get_qy();
        }
        r1(a, b, c) {
            let d = { $type: Point_$type, x: NaN, y: NaN };
            let e = 1.7976931348623157E+308;
            let f = { $type: Point_$type, x: NaN, y: NaN };
            let g = false;
            let h = -1;
            for (let i = 0; i < b.count; i++) {
                let j = b._inner[i];
                if (i >= 1) {
                    let k = GeometryUtil.d(a, d, j);
                    if (k < e) {
                        e = k;
                        g = true;
                        h = i;
                    }
                }
                d = j;
            }
            if (c) {
                let l = b._inner[0];
                let m = GeometryUtil.d(a, d, l);
                if (m < e) {
                    e = m;
                    let n = GeometryUtil.h(a, d, l);
                    f = { $type: Point_$type, x: d.x + (l.x - d.x) * n, y: d.y + (l.y - d.y) * n };
                    return new Tuple$2(Number_$type, Point_$type, e, f);
                }
            }
            if (g) {
                let o = b._inner[h - 1];
                let p = b._inner[h];
                let q = GeometryUtil.h(a, o, p);
                f = { $type: Point_$type, x: o.x + (p.x - o.x) * q, y: o.y + (p.y - o.y) * q };
            }
            return new Tuple$2(Number_$type, Point_$type, e, f);
        }
        ri(a) {
            return this.r2(a).c;
        }
        pm(a, b, c) {
            if (this.ql == null || this.qn == null || this.rd == null) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            switch (this.qp) {
                case 1:
                    let d = this.r3(a);
                    return d.d;
                case 2:
                    let e = this.r2(a);
                    return e.e;
                case 3:
                    let f = this.r2(a);
                    return f.d;
            }
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        ht(a) {
            let b = this.hd(a);
            if (this.ck != null && b >= 0 && b < this.ck.count) {
                return this.ck.item(b);
            }
            return null;
        }
        qf(a, b, c) {
            let d = new HighlightingInfo();
            d.b = this;
            d.h = 0;
            d.g = this.ck.count - 1;
            d.d = true;
            if (c != null && c.h == d.h && c.g == d.g) {
                return c;
            }
            return d;
        }
        aw(a, b, c) {
            if (this.c2 && this.ef(this.bk) && !c) {
                let d = this.qg(a, b, this.qi);
                this.qi = d;
                return d;
            }
            else {
                let e = this.qf(a, b, this.qi);
                this.qi = e;
                return e;
            }
        }
        ax(a, b, c) {
            if (this.ef(this.bk) && !c) {
                let d = this.qh(a, b, this.qj);
                this.qj = d;
                return d;
            }
            else {
                let e = this.qf(a, b, this.qj);
                e.e = true;
                this.qj = e;
                return e;
            }
        }
        rb() {
            return (this.assigningShapeStyle != null && this.qx) || (this.bk != 1);
        }
        ra() {
            return (this.assigningShapeMarkerStyle != null && this.qw) || (this.bk != 1);
        }
        get qv() {
            return this.qu;
        }
        set qv(a) {
            let b = this.qv != a;
            if (b) {
                let c = this.qv;
                this.qu = a;
                this.raisePropertyChanged("ShapeColumn", c, this.qv);
            }
        }
        q2(array_) {
            let a = (Array.isArray(array_));
            return a;
        }
        static q6(a) {
            if (a == null) {
                return true;
            }
            let val_ = a;
            return (val_ == undefined);
        }
        convertToListList(a) {
            if (a == null) {
                return null;
            }
            let b = new List$1(List$1.$.specialize(Point_$type), 0);
            let c;
            let curr_;
            let d;
            let e;
            let f = false;
            let g = false;
            for (let h = 0; h < a.length; h++) {
                c = a[h];
                if (c == null) {
                    continue;
                }
                let i = new List$1(Point_$type, 0);
                for (let j = 0; j < c.length; j++) {
                    curr_ = c[j];
                    if (f) {
                        d = (curr_.X);
                        e = (curr_.Y);
                    }
                    else {
                        d = (curr_.x);
                        e = (curr_.y);
                    }
                    if (!g) {
                        if ((isNaN_(d) || ShapeSeriesBase.q6(d)) && (isNaN_(e) || ShapeSeriesBase.q6(e))) {
                            d = (curr_.X);
                            e = (curr_.Y);
                            if (!isNaN_(d) && !ShapeSeriesBase.q6(d) && !isNaN_(e) && !ShapeSeriesBase.q6(e)) {
                                g = true;
                                f = true;
                            }
                        }
                        else {
                            g = true;
                        }
                    }
                    i.add({ $type: Point_$type, x: d, y: e });
                }
                b.add(i);
            }
            return b;
        }
        cj(a) {
            if (this.ck != null && this.q2(this.itemsSource) && a != null && a.split('!').length != 2) {
                if (this.coercionMethods == null) {
                    this.coercionMethods = {};
                }
                let methods_ = this.coercionMethods;
                methods_.convertToListList = this.convertToListList;
                a += "!convertToListList";
            }
            return super.cj(a);
        }
        l4(a, b, c, d) {
            super.l4(a, b, c, d);
            let e = false;
            let f = false;
            switch (b) {
                case ShapeSeriesBase.$$p[2]:
                    this.qp = this.qq();
                    break;
                case "FastItemsSource":
                    let g = typeCast(IFastItemsSource_$type, c);
                    if (g != null) {
                        g.deregisterColumn(this.qv);
                        this.qv = null;
                    }
                    let h = typeCast(IFastItemsSource_$type, d);
                    if (h != null) {
                        this.qv = this.cj(this.rx);
                    }
                    e = this.ql != null && !this.ql.c0();
                    f = this.qn != null && !this.qn.c0();
                    if (e || f) {
                        this.mi(false);
                    }
                    break;
                case ShapeSeriesBase.$$p[6]:
                    if (this.ck != null) {
                        this.ck.deregisterColumn(this.qv);
                        this.qv = this.cj(this.rx);
                    }
                    break;
                case "ShapeColumn":
                    this.sc();
                    e = this.ql != null && !this.ql.c0();
                    f = this.qn != null && !this.qn.c0();
                    if (e || f) {
                        this.mi(false);
                    }
                    this.lp();
                    break;
                case ShapeSeriesBase.$$p[7]:
                case ShapeSeriesBase.$$p[8]:
                    this.qk = this.ql;
                    this.qm = this.qn;
                    let i = c;
                    let j = d;
                    this.sd(i);
                    this.r5(j);
                    if ((j != null && !j.c0()) || (j == null && i != null)) {
                        this.mi(false);
                    }
                    this.lp();
                    break;
                case "ActualResolution":
                    this.rh = this.ft;
                    this.lp();
                    break;
                case "ActualBrush":
                    this.mi(false);
                    break;
                case ShapeSeriesBase.$$p[5]:
                    this.rk = this.rj;
                    this.mi(false);
                    this.lp();
                    break;
                case "ActualThickness":
                    this.mi(false);
                    this.lp();
                    break;
                case ShapeSeriesBase.$$p[1]:
                    this.qx = this.q9();
                    this.mi(false);
                    break;
                case ShapeSeriesBase.$$p[0]:
                    this.qw = this.q8();
                    this.mi(false);
                    break;
            }
        }
        q9() {
            return this.q5;
        }
        q8() {
            return this.q4;
        }
        q0(a) {
            if (typeCast(NumericYAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        qz(a) {
            if (typeCast(NumericXAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        sc() {
            this.rd = null;
            if (this.qv == null) {
                return;
            }
            this.rd = new List$1(Rect.$, 2, this.qv.count);
            for (let a = 0; a < this.qv.count; a++) {
                this.rd.add(PointCollectionUtil.j(this.qv.item(a)));
            }
        }
        sp(a) {
            if (typeCast(IEnumerable$1_$type.specialize(IEnumerable$1_$type.specialize(Point_$type)), a) !== null) {
                return PointCollectionUtil.h(a);
            }
            else if (typeCast(IEnumerable$1_$type.specialize(Point_$type), a) !== null) {
                return PointCollectionUtil.g(a);
            }
            return Rect.empty;
        }
        rf(a, b, c, d, e, f, g) {
            return this.rg(a, b, c, d, e, f, g);
            if (typeCast(List$1.$.specialize(List$1.$.specialize(Point_$type)), c) !== null) {
                return this.rg(a, b, c, d, e, f, g);
            }
            else if (typeCast(IEnumerable$1_$type.specialize(IEnumerable$1_$type.specialize(Point_$type)), c) !== null) {
                let h = c;
                let i = new List$1(FlattenedShape.$, 0);
                let j = null;
                for (let k of fromEnum(h)) {
                    j = this.qe(a, b, PointCollectionUtil.b(k), d, e, f, g);
                    if (j == null) {
                        continue;
                    }
                    i.add(j);
                }
                return i;
            }
            else if (typeCast(IEnumerable$1_$type.specialize(Point_$type), c) !== null) {
                let l = c;
                let m = this.qe(a, b, PointCollectionUtil.b(l), d, e, f, g);
                let n = new List$1(FlattenedShape.$, 0);
                if (m != null) {
                    n.add(m);
                }
                return n;
            }
            else {
                throw new InvalidOperationException(1, "Unrecognized data in ShapeColumn");
            }
        }
        get_q3() {
            return true;
        }
        get q3() {
            return this.get_q3();
        }
        rc() {
            return false;
        }
        mj(a) {
            this.sb(this.b0);
        }
        mh(a, b, c, d, e) {
            super.mh(a, b, c, d, e);
            let f = this.a6.a$h.item(d);
            let g = f;
            f.a1(c);
            if (this.cx(f)) {
                return;
            }
            this.sb(f);
        }
        sb(a) {
            if (this.cx(a)) {
                return;
            }
            let b;
            let c;
            let d = a;
            let e = a.getViewInfo(c, b);
            c = e.p0;
            b = e.p1;
            if (c.width < 1 || c.height < 1 || this.qv == null) {
                return;
            }
            let f = this.ql;
            let g = this.qn;
            let h = this.getEffectiveViewport1(a);
            let i = new ScalerParams(1, b, c, f.cg);
            i.c = h;
            let j = new ScalerParams(1, b, c, g.cg);
            j.c = h;
            if (!this.es) {
                d.cr();
                let k = new Rect(0, 0, 0, 0, 0);
                let l;
                let m;
                let n;
                let o;
                let p = this.qv.count;
                if (this.p7 == null || this.p7.length != p) {
                    this.p7 = new Array(p);
                    this.p5 = new Array(p);
                    this.p6 = new Array(p);
                    this.p4 = new Array(p);
                }
                let q = this.p7;
                let r = this.p5;
                let s = this.p6;
                let t = this.p4;
                let u;
                for (let v = 0; v < p; v++) {
                    u = this.rd._inner[v];
                    q[v] = u.top;
                    r[v] = u.left;
                    s[v] = u.right;
                    t[v] = u.bottom;
                }
                this.qk.hm(boxArray$1(r), 0, r.length, i);
                this.qk.hm(boxArray$1(s), 0, s.length, i);
                this.qm.hm(boxArray$1(q), 0, q.length, j);
                this.qm.hm(boxArray$1(t), 0, t.length, j);
                d.cs(r, q, s, t);
                let w = this.qv;
                let x = this.ck;
                this.se(d);
                let y = c.left;
                let z = c.right;
                let aa = c.top;
                let ab = c.bottom;
                let ac = null;
                if (this.so.isEmpty) {
                    ac = null;
                }
                else {
                    ac = new Clipper(1, this.so.left, this.so.bottom, this.so.right, this.so.top, this.q3);
                }
                let ad = this.rc();
                if (ad) {
                    d.b9.clear();
                }
                let ae = false;
                let af = true;
                let ag = 0;
                if (this.cd != null) {
                    if (this.cd.e3()) {
                        let ah = this.cd.ku(b, i);
                        ae = ah.c;
                        ag = ah.d;
                    }
                }
                let ai;
                for (let aj = 0; aj < p; aj++) {
                    n = r[aj];
                    l = q[aj];
                    m = t[aj];
                    o = s[aj];
                    k.x = Math.min(n, o);
                    k.y = Math.min(l, m);
                    k.width = Math.max(n, o) - k.x;
                    k.height = Math.max(l, m) - k.y;
                    if (k.intersectsWith(c)) {
                        if (k.x < y || k.y < aa || k.x > z || k.y > ab) {
                            ai = ac;
                        }
                        else {
                            ai = null;
                        }
                        let ak = this.rf(a, ai, w.item(aj), i, j, 0, ag);
                        if (ad) {
                            ShapeSeriesBase.sa(d, aj, ak);
                        }
                        d.cf(aj, x.item(aj), k, ak);
                    }
                    else if (ae) {
                        k.x = k.x + ag;
                        if (k.intersectsWith(c)) {
                            if (k.x < y || k.y < aa || k.x > z || k.y > ab) {
                                ai = ac;
                            }
                            else {
                                ai = null;
                            }
                            let al = this.rf(a, ai, w.item(aj), i, j, ag, ag);
                            if (ad) {
                                ShapeSeriesBase.sa(d, aj, al);
                            }
                            d.cf(aj, x.item(aj), k, al);
                        }
                    }
                }
                d.cq();
            }
            let am = this.rb();
            this.qs.ax(this, this.rb(), runOn(this, this.qa));
            let an = false;
            let ao = this.qs.b;
            if (ao != null) {
                an = true;
            }
            let ap = a.q;
            let aq = this.ee;
            let ar = d.b7;
            d.cm((as) => {
                let at = as.dataContext != null ? as.dataContext.item : null;
                let au = as.dataContext != null ? as.dataContext.c : -1;
                d.cj(as, at, am);
                if (an) {
                    this.r7(as, aq, au, this.qv.count, ap, ar);
                }
                else {
                    if (ar) {
                        {
                            this.qs.az(as, this.fr, ar);
                        }
                    }
                }
                {
                    this.qs.ad(as, false, false, false, false);
                }
            });
        }
        r7(a, b, c, d, e, f) {
            let g = this.bk != 1;
            this.qs.ay(this.qs.b, c, d, false);
            {
                this.qs.az(a, this.fr, f);
            }
            let h = this.qs.av;
            let i = null;
            let j = this.ck;
            if (g && this.cd != null) {
                i = this.cd.a3.getHighlightingInfo(this, j, h.o, h.n, false);
                h.b = i;
            }
            h.f = e;
            this.r9(h);
            this.qs.z(this, i, e, g, false);
        }
        r6(a, b, c) {
            let d = this.bk != 1;
            this.qs.ay(this.qs.d, a, b, true);
            this.qs.aa(this.fr);
            let e = this.qs.au;
            let f = null;
            let g = this.ck;
            let h = null;
            if (d && this.cd != null) {
                f = this.cd.a3.getHighlightingInfo(this, g, e.o, e.n, true);
                if (this.cd.a3.isCrossSeriesHighlight(this)) {
                    h = this.cd.a3.getHighlightingInfo(this, g, e.o, e.n, true);
                }
                e.b = f;
            }
            e.f = c;
            this.r8(e);
            this.qs.y(this, f, c, d, e.l, this.cd.a3.sumHighlightingProgress);
        }
        r9(a) {
            if (this.assigningShapeStyle != null && this.qx) {
                this.assigningShapeStyle(this, a);
            }
        }
        r8(a) {
            if (this.assigningShapeMarkerStyle != null && this.qw) {
                this.assigningShapeMarkerStyle(this, a);
            }
        }
        qa(a, b) {
            return this.qb(a, b);
        }
        qb(a, b) {
            if (b < a || a < 0 || a > this.qv.count || b < 0 || b > this.qv.count) {
                return null;
            }
            let c = new Array((b - a) + 1);
            for (let d = a; d <= b; d++) {
                let e = d;
                c[d - a] = this.ck.item(d);
            }
            return c;
        }
        static sa(a, b, c) {
            let d = 0;
            let e = null;
            for (let f = 0; f < c.count; f++) {
                let g = c._inner[f];
                let h = g.b.width * g.b.height;
                if (h > d) {
                    d = h;
                    e = g;
                }
            }
            a.b9.addItem(b, e);
        }
        lf() {
            super.lf();
            if (this.ql != null) {
                this.ql.h6();
            }
            if (this.qn != null) {
                this.qn.h6();
            }
        }
        m6(a, b) {
            this.mi(false);
        }
        m5(a, b) {
            this.mi(false);
        }
        k0(a, b, c, d) {
            super.k0(a, b, c, d);
            switch (a) {
                case 3:
                    if (d == this.rx) {
                        this.rd._inner[b] = this.sp(this.qv.item(b));
                    }
                    break;
                case 1:
                    for (let e = b; e < b + c; e++) {
                        this.rd.insert(e, this.sp(this.qv.item(e)));
                    }
                    break;
                case 0:
                    this.rd.v(b, c);
                    break;
                case 2:
                    for (let f = b; f < b + c; f++) {
                        this.rd._inner[f] = this.sp(this.qv.item(f));
                    }
                    break;
                case 4:
                    this.sc();
                    break;
            }
            this.mi(false);
        }
        e9(a, b, c) {
            let d = true;
            if (!super.e9(a, b, c) || (this.q7 && this.qv == null) || b.isEmpty || a.isEmpty || this.ql == null || this.qn == null || this.ql.bh == null || this.qn.bh == null || this.ql.lv == this.ql.lu || this.qn.lv == this.qn.lu || this.qv == null || this.qv.count == 0 || this.rd == null || this.rd.count == 0 || this.rd.count != this.qv.count) {
                d = false;
            }
            return d;
        }
        get_q7() {
            return true;
        }
        get q7() {
            return this.get_q7();
        }
        lz(a) {
            super.lz(a);
            this.qt = typeCast(ShapeSeriesViewBase.$, a);
        }
        rg(a, b, c, d, e, f, g) {
            let h = new List$1(FlattenedShape.$, 0);
            let i;
            let j = c.count;
            for (let k = 0; k < j; k++) {
                i = c._inner[k];
                let l = this.qe(a, b, i, d, e, f, g);
                if (l == null) {
                    continue;
                }
                h.add(l);
            }
            return h;
        }
        qe(a, b, c, d, e, f, g) {
            let h = this.r4(c, d, e);
            let i = h.c;
            let j = h.d;
            let k = i.length;
            let l = 1.7976931348623157E+308;
            let m = 1.7976931348623157E+308;
            let n = -1.7976931348623157E+308;
            let o = -1.7976931348623157E+308;
            let p;
            let q;
            if (f != 0) {
                for (let r = 0; r < k; r++) {
                    i[r] = i[r] + f;
                }
            }
            for (let s = 0; s < k; s++) {
                p = i[s];
                q = j[s];
                l = p < l ? p : l;
                m = q < m ? q : m;
                n = p > n ? p : n;
                o = q > o ? q : o;
            }
            let t = !(l > this.so.right || n < this.so.left || m > this.so.bottom || o < this.so.top);
            if (!t && f == 0 && g != 0) {
                if (g != 0) {
                    for (let u = 0; u < k; u++) {
                        i[u] = i[u] + g;
                    }
                }
                for (let v = 0; v < k; v++) {
                    p = i[v];
                    q = j[v];
                    l = p < l ? p : l;
                    m = q < m ? q : m;
                    n = p > n ? p : n;
                    o = q > o ? q : o;
                }
                t = !(l > this.so.right || n < this.so.left || m > this.so.bottom || o < this.so.top);
            }
            if (!t) {
                return null;
            }
            let w = b != null && (l < this.so.left || m < this.so.top || n > this.so.right || o > this.so.bottom);
            let x = new Rect(0, l, m, n - l, o - m);
            if (!a.b8(x)) {
                return null;
            }
            l = l < this.so.left ? this.so.left : l;
            n = n > this.so.right ? this.so.right : n;
            m = m < this.so.top ? this.so.top : m;
            o = o > this.so.bottom ? this.so.bottom : o;
            let y = PolySimplification.b(h, this.ft);
            let z = new DefaultFlattener().c(h.c, h.d, y, this.rh);
            let aa = z.count;
            if (w) {
                let ab = new List$1(Point_$type, 0);
                b.i = ab;
                for (let ac = 0; ac < aa; ac++) {
                    b.j(z._inner[ac]);
                }
                b.i = null;
                z = ab;
            }
            if (z == null || z.count == 0) {
                return null;
            }
            let ad = new FlattenedShape();
            ad.a = z;
            ad.b = new Rect(0, l, m, n - l, o - m);
            ad.c = x;
            return ad;
        }
        r4(a, b, c) {
            let d = this.qk;
            let e = this.qm;
            let f = a.count;
            let g = new Array(f);
            let h = new Array(f);
            for (let i = 0; i < f; i++) {
                g[i] = a._inner[i].x;
                h[i] = a._inner[i].y;
            }
            d.hm(boxArray$1(g), 0, g.length, b);
            e.hm(boxArray$1(h), 0, h.length, c);
            return new Tuple$2(Array_$type, Array_$type, g, h);
        }
        se(a) {
            a.cx();
        }
        kx(a, b) {
            super.kx(a, b);
            let c = b;
            c.ck();
        }
        r5(a) {
            if (a != null) {
                a.cs(this);
            }
        }
        sd(a) {
            if (a != null) {
                a.bz(this);
            }
        }
        at(a, b) {
            let c = this.qt.cz(a, b);
            let d = null;
            if (c != null) {
                d = c.dataContext;
            }
            if (d != null) {
                return d;
            }
            return super.at(a, b);
        }
        ro(a) {
            return this.ck.item(a);
        }
        get_e3() {
            return true;
        }
        set_e3(a) {
            super.set_e3(a);
        }
        ap(a) {
            if (typeCast(NumericXAxis.$, a) !== null && this.rd != null) {
                let b = 1.7976931348623157E+308;
                let c = -1.7976931348623157E+308;
                for (let d of fromEnum(this.rd)) {
                    b = Math.min(b, d.left);
                    c = Math.max(c, d.right);
                }
                return new AxisRange(b, c);
            }
            if (typeCast(NumericYAxis.$, a) !== null && this.rd != null) {
                let e = 1.7976931348623157E+308;
                let f = -1.7976931348623157E+308;
                for (let g of fromEnum(this.rd)) {
                    e = Math.min(e, g.top);
                    f = Math.max(f, g.bottom);
                }
                return new AxisRange(e, f);
            }
            return null;
        }
        get_ed() {
            return true;
        }
        get_d2() {
            return true;
        }
        get q1() {
            return this.styleShape != null;
        }
        sq(a, b, c) {
            if (this.styleShape != null) {
                if (this.qt.c6 != null && c == this.qt.c6) {
                    c = new Style();
                    let d = this.qt.c6;
                    c.fill = d.fill;
                    c.opacity = d.opacity;
                    c.stroke = d.stroke;
                    c.strokeThickness = d.strokeThickness;
                }
                else {
                    if (c != null) {
                        let e = new Style();
                        e.fill = c.fill;
                        e.opacity = c.opacity;
                        e.stroke = c.stroke;
                        e.strokeThickness = c.strokeThickness;
                        c = e;
                    }
                    else {
                        c = new Style();
                    }
                }
                let f = new StyleShapeEventArgs(a, b, c);
                this.styleShape(this, f);
                return f.d();
            }
            return c;
        }
    }
    ShapeSeriesBase.$t = markType(ShapeSeriesBase, 'ShapeSeriesBase', Series.$);
    ShapeSeriesBase.$$p = markDep(DependencyProperty, PropertyMetadata, ShapeSeriesBase, 'raisePropertyChanged', ['IsCustomShapeMarkerStyleAllowed:q4:sf', [0, false], 'IsCustomShapeStyleAllowed:q5:sg', [0, false], 'ItemSearchMode:qr:sh', [ShapeItemSearchMode_$type, enumGetBox(ShapeItemSearchMode_$type, 0)], 'ItemSearchPointsThreshold:rm:si', [1, 10000], 'ItemSearchThreshold:rn:sj', [1, 10000], 'ShapeFilterResolution:rj:sk', [1, 2], 'ShapeMemberPath:rx:sl', [2, null], 'XAxis:ql:sm', [NumericXAxis.$, null], 'YAxis:qn:sn', [NumericYAxis.$, null]]);
    return ShapeSeriesBase;
})();
/**
 * @hidden
 */
export let ShapeSeriesRenderManager = /*@__PURE__*/ (() => {
    class ShapeSeriesRenderManager extends SeriesRenderManager {
        constructor() {
            super(...arguments);
            this.au = null;
            this.av = null;
        }
        c() {
            this.au = new AssigningShapeMarkerStyleEventArgs();
            return this.au;
        }
        a() {
            this.av = new AssigningShapeStyleEventArgs();
            return this.av;
        }
        az(a, b, c) {
            this.ag = this.ak;
            this.ah = this.al;
            this.m = this.t;
            this.am = this.an;
            this.ao = this.ar;
            this.k = this.r;
            this.l = this.s;
            this.j = this.q;
            if (c) {
                if (a._fill != null) {
                    this.ag = a._fill;
                }
                if (a._stroke != null) {
                    this.ah = a._stroke;
                }
                if (!isNaN_(a.ac) && (a.y == null || !isNaN_(a.y.strokeThickness))) {
                    this.m = a.ac;
                }
            }
            let d = this.b;
            if (d != null) {
                d.p = this.ag;
                d.q = this.ah;
                d.t = this.m;
                d.u = this.am;
                d.v = this.ao;
                d.r = this.k;
                d.s = this.l;
                d.k = this.j;
                d.e = this.f;
                d.i = b;
                d.d = false;
            }
        }
        aw(a, b, c) {
            this.w(a, b, c);
        }
        ax(a, b, c) {
            this.x(a, b, c);
        }
        ay(a, b, c, d) {
            if (b == -1) {
                a.c = false;
                a.o = 0;
                a.n = c - 1;
            }
            else {
                if (d) {
                    a.o = b;
                    a.n = b;
                }
                else {
                    a.c = false;
                    a.o = b;
                    a.n = b;
                }
            }
        }
    }
    ShapeSeriesRenderManager.$t = markType(ShapeSeriesRenderManager, 'ShapeSeriesRenderManager', SeriesRenderManager.$);
    return ShapeSeriesRenderManager;
})();
/**
 * @hidden
 */
export let ShapeSeriesViewBase = /*@__PURE__*/ (() => {
    class ShapeSeriesViewBase extends SeriesView {
        constructor(a) {
            super(a);
            this.b9 = null;
            this.b3 = null;
            this.ca = new List$1(ShapeHitRegion.$, 0);
            this.ce = 0;
            this.cd = null;
            this.b6 = null;
            this.c4 = new Path();
            this.b4 = null;
            this.c5 = null;
            this.by = null;
            this.b0 = null;
            this.bz = null;
            this.bx = null;
            this.b3 = a;
            this.b6 = this.b5();
            this.cd = new List$1(Path.$, 0);
            this.b9 = new Dictionary$2(Number_$type, FlattenedShape.$, 0);
        }
        b1(a) {
            return null;
        }
        get cb() {
            return this.ca;
        }
        b5() {
            return ((() => {
                let $ret = new Pool$1(FrameworkElement.$);
                $ret.create = runOn(this, this.cy);
                $ret.activate = runOn(this, this.cn);
                $ret.disactivate = runOn(this, this.co);
                $ret.destroy = runOn(this, this.cp);
                return $ret;
            })());
        }
        b8(a) {
            return a.width >= this.b3.rk && a.height >= this.b3.rk;
        }
        static cc(a) {
            let b = new List$1(PointCollection.$, 0);
            let c;
            let d = a.count;
            for (let e = 0; e < d; e++) {
                c = a._inner[e];
                let f = new PointCollection(1, c.a);
                b.add(f);
            }
            return b;
        }
        get b7() {
            return this.c5 != null || this.b4 != null || this.b3.q1;
        }
        cf(a, b, c, d) {
            if (d != null && d.count > 0) {
                let e = ShapeSeriesViewBase.cc(d);
                c.intersect(this.bu);
                if (!this.b8(c)) {
                }
                else {
                    let f = this.c2(a, e);
                    if (f != null) {
                        let g = this.c1(this.ce, b);
                        for (let h = 0; h < d.count; h++) {
                            let i = new ShapeHitRegion();
                            i.d = d._inner[h].b;
                            i.a = d._inner[h].a;
                            i.b = a;
                            i.c = g;
                            this.ca.add(i);
                        }
                        this.ch(g, f);
                        this.ce = this.ce + 1;
                    }
                }
            }
        }
        c1(a, b) {
            let c = this.b6.item(this.ce);
            if (c.dataContext != null) {
                c.dataContext.item = b;
                c.dataContext.c = a;
            }
            return c;
        }
        static ci(a, b, c) {
            if (b._fill == null) {
                b._fill = a.e.oz;
            }
            if (b._stroke == null) {
                b._stroke = a.e.o2;
            }
            if (b.y == null) {
                b.ac = a.e.fu;
            }
        }
        cm(a) {
            for (let b = 0; b < this.b6.a.count; b++) {
                let c = this.b6.a._inner[b];
                a(c);
            }
        }
        cj(a, b, c) {
            if (a == null) {
                return;
            }
            this.cl(a, c);
            let d = false;
            if (this.b4 != null) {
                let e = this.b4.selectStyle(b, a);
                if (e != null) {
                    d = true;
                }
                if (a.y != e) {
                    a.y = e;
                    this.k.i(a, a.y);
                }
            }
            if (!d) {
                if (a.y != this.c5) {
                    a.y = this.c5;
                    this.k.i(a, a.y);
                }
            }
            let f = this.b3.sq(b, a, a.y);
            if (a.y != f) {
                a.y = f;
                this.k.i(a, a.y);
            }
        }
        cl(a, b) {
        }
        cg(a, b) {
            let c = truncate(Math.floor(a.left));
            let d = truncate(Math.ceil(a.right));
            let e = truncate(Math.floor(a.top));
            let f = truncate(Math.ceil(a.bottom));
            for (let g = c; g < d; g++) {
                for (let h = e; h < f; h++) {
                    this.cu(g, h, b);
                }
            }
        }
        cu(a, b, c) {
        }
        cr() {
            this.ce = 0;
        }
        cq() {
            this.b6.count = this.ce;
            this.aq();
        }
        ct(a, b) {
        }
        ck() {
            this.b6.count = 0;
            this.aq();
        }
        cy() {
            let a = this.b3;
            let b = ((() => {
                let $ret = new Path();
                $ret.dataContext = ((() => {
                    let $ret = new DataContext();
                    $ret.series = a;
                    return $ret;
                })());
                return $ret;
            })());
            this.cd.add(b);
            return b;
        }
        cn(a) {
            a._visibility = 0;
        }
        co(a) {
            a.dataContext.item = null;
            a._visibility = 1;
        }
        cp(a) {
            this.cd.remove(a);
        }
        c3(a, b, c) {
            if (b == null) {
                return null;
            }
            let d = new PathGeometry();
            let e;
            let f = b.count;
            for (let g = 0; g < f; g++) {
                e = b._inner[g];
                if (e.count < 1) {
                    continue;
                }
                let h = new PolyLineSegment();
                h._points = e;
                let i = new PathFigure();
                i._isFilled = c;
                i._isClosed = c;
                i._startPoint = e._inner[0];
                i._segments.add(h);
                d.c.add(i);
            }
            return d;
        }
        ac(a) {
            return this.cd._inner[a];
        }
        ab(a) {
            let b = this.cd._inner[a];
            this.c4._visibility = b._visibility;
            this.c4.ak = b.ak;
            let c = this.bp(a);
            this.c4._fill = c;
            this.c4._stroke = c;
            this.c4.ac = this.e.fu + 3;
            return this.c4;
        }
        a6(a, b) {
            super.a6(a, b);
            for (let c = 0; c < this.cd.count; c++) {
                let d = this.aa(c, b);
                if (d._visibility != 1) {
                    a.s(d);
                }
            }
        }
        get c6() {
            return this.c5;
        }
        cw(a) {
            this.b4 = a;
        }
        cv(a) {
            this.c5 = a;
        }
        cz(a, b) {
            return this.c0(a, b, false);
        }
        c0(a, b, c) {
            let d = this.b2(a, b, c);
            if (d == null) {
                return null;
            }
            return d.c;
        }
        b2(a, b, c) {
            if (this.ca.count == 0) {
                return null;
            }
            let d = a.x;
            let e = a.y;
            let f = this.ca.count;
            let g = this.ca;
            let h = null;
            for (let i = 0; i < f; i++) {
                h = g._inner[i];
                if (h.a == null || h.a.count == 0) {
                    continue;
                }
                if (d >= h.d.left && d <= h.d.right && e >= h.d.top && e <= h.d.bottom) {
                    if (c) {
                        let j = this.b3.fu / 2 + this.b3.f8(b);
                        if (GeometryUtil.b(a, h.a._inner[0], h.a, j)) {
                            return h;
                        }
                    }
                    else {
                        if (PolygonUtil.b(h.a, a)) {
                            return h;
                        }
                    }
                }
            }
            return null;
        }
        cs(a, b, c, d) {
            this.by = a;
            this.b0 = b;
            this.bz = c;
            this.bx = d;
            this.ca.clear();
        }
        cx() {
            let a = this.bu;
            let b = ((() => {
                let $ret = new Path();
                $ret.y = this.c5;
                return $ret;
            })());
            b.ac = 1;
            if (this.k != null) {
                this.k.i(b, b.y);
            }
            this.b3.so = RectUtil.r(a, b.ac);
        }
        al(a) {
            super.al(a);
            if (this.b6.a == null) {
                return;
            }
            for (let b = 0; b < this.b6.a.count; b++) {
                let c = typeCast(Path.$, this.b6.a._inner[b]);
                if (c._visibility != 1) {
                    this.e.a8.exportPathData(a, c, "shape" + b, ["Main "]);
                }
            }
        }
    }
    ShapeSeriesViewBase.$t = markType(ShapeSeriesViewBase, 'ShapeSeriesViewBase', SeriesView.$);
    return ShapeSeriesViewBase;
})();
