/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Series } from "./Series";
import { DependencyProperty } from "igniteui-angular-core";
import { Point_$type, Boolean_$type, runOn, delegateRemove, typeCast, delegateCombine, fromEnum, fromEn, markType, markDep } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { XamDataChart } from "./XamDataChart";
import { Tuple$2 } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
/**
 * @hidden
 */
var AnnotationLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnnotationLayer, _super);
    function AnnotationLayer() {
        var _this = _super.call(this) || this;
        _this.q7 = null;
        _this.p6 = null;
        _this.p5 = null;
        _this.p7 = null;
        _this.q5 = { $type: Point_$type, x: NaN, y: NaN };
        _this.p8 = false;
        _this.q7 = { $type: Point_$type, x: NaN, y: NaN };
        return _this;
    }
    AnnotationLayer.prototype.bx = function () {
        return new AnnotationLayerView(this);
    };
    AnnotationLayer.prototype.lz = function (a) {
        _super.prototype.lz.call(this, a);
        this.p4 = a;
    };
    AnnotationLayer.prototype.qc = function (a) {
        if (a == null) {
            return false;
        }
        if (a.dc) {
            return false;
        }
        if (a.isValueOverlay) {
            return false;
        }
        if (a == this) {
            return false;
        }
        return a.e9(a.b0.bu, a.b0.bv, a.b0);
    };
    AnnotationLayer.prototype.get_dj = function () {
        return this.p9;
    };
    AnnotationLayer.prototype.bp = function () {
        if (this.bq == 0) {
            return 1;
        }
        else {
            return _super.prototype.bp.call(this);
        }
    };
    AnnotationLayer.prototype.get_dy = function () {
        return this.qe || this.qf;
    };
    AnnotationLayer.prototype.get_isUsableInLegend = function () {
        return this.qf;
    };
    AnnotationLayer.prototype.l4 = function (a, b, c, d) {
        _super.prototype.l4.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                var e = c;
                var f = d;
                if (e != null) {
                    this.qy(e.series);
                    var g = e.series;
                    g.collectionChanged = delegateRemove(g.collectionChanged, runOn(this, this.qv));
                    if (typeCast(XamDataChart.$, e) !== null) {
                        var h = e;
                        this.qx(h.axes);
                        var i = h.axes;
                        i.collectionChanged = delegateRemove(i.collectionChanged, runOn(this, this.ql));
                    }
                }
                if (f != null) {
                    this.qt(f.series);
                    var j = f.series;
                    j.collectionChanged = delegateCombine(j.collectionChanged, runOn(this, this.qv));
                    if (typeCast(XamDataChart.$, f) !== null) {
                        var k = f;
                        this.qs(k.axes);
                        var l = k.axes;
                        l.collectionChanged = delegateCombine(l.collectionChanged, runOn(this, this.ql));
                    }
                }
                break;
            case AnnotationLayer.$$p[3]:
            case AnnotationLayer.$$p[2]:
                if (this.dy) {
                    if (this.index == -1) {
                        this.index = XamDataChart.u1(this);
                    }
                }
                else {
                    this.index = -1;
                    this.oz = null;
                    this.o2 = null;
                }
                if (this.cd != null) {
                    this.cd.mk();
                }
                this.mi(true);
                break;
            case "TransitionProgress":
                this.p7.c(this.g0, this.p6, this.p5);
                if (this.cx(this.b0)) {
                    return;
                }
                if (this.g0 == 1) {
                    this.qu(this.p5, this.b0);
                }
                else {
                    this.qu(this.p7, this.b0);
                }
                if (this.cd != null) {
                    this.cd.nn(this);
                }
                break;
            case AnnotationLayer.$$p[1]:
                if (this.cd != null) {
                    this.cd.mi();
                }
                break;
            case AnnotationLayer.$$p[0]:
                this.q7 = this.q6;
                this.lt(this.q6);
                break;
            case "ShouldRenderAsOverlay":
                if (this.cd != null) {
                    this.b0.ak(this.cd);
                    this.b0.ag(this.cd);
                }
                break;
        }
    };
    AnnotationLayer.prototype.qy = function (a) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                if (!(b == this)) {
                    b.renderRequested = delegateRemove(b.renderRequested, runOn(this, this.qw));
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        this.mi(true);
    };
    AnnotationLayer.prototype.qx = function (a) {
        var e_2, _a;
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                b.renderRequested = delegateRemove(b.renderRequested, runOn(this, this.qm));
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        this.mi(true);
    };
    AnnotationLayer.prototype.qt = function (a) {
        var e_3, _a;
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                if (!(b == this)) {
                    b.renderRequested = delegateCombine(b.renderRequested, runOn(this, this.qw));
                }
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        this.mi(true);
    };
    AnnotationLayer.prototype.qs = function (a) {
        var e_4, _a;
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                b.renderRequested = delegateCombine(b.renderRequested, runOn(this, this.qm));
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        this.mi(true);
    };
    AnnotationLayer.prototype.qa = function (a) {
        if (a == null) {
            return false;
        }
        return true;
    };
    AnnotationLayer.prototype.qm = function (a, b) {
        if (this.qa(a)) {
            this.qo(a, b.animate);
        }
    };
    AnnotationLayer.prototype.qb = function (a) {
        if (a == null) {
            return false;
        }
        if (a.dc) {
            return false;
        }
        return true;
    };
    AnnotationLayer.prototype.qw = function (a, b) {
        if (this.qb(a)) {
            this.qp(a, b.animate);
        }
    };
    AnnotationLayer.prototype.qo = function (a, b) {
    };
    AnnotationLayer.prototype.qp = function (a, b) {
    };
    AnnotationLayer.prototype.qv = function (a, b) {
        this.qq(b);
    };
    AnnotationLayer.prototype.ql = function (a, b) {
        this.qn(b);
    };
    AnnotationLayer.prototype.q3 = function () {
        if (this.oz != null) {
            return this.oz;
        }
        return this.o3;
    };
    AnnotationLayer.prototype.q4 = function () {
        if (this.o2 != null) {
            return this.o2;
        }
        return this.o8;
    };
    AnnotationLayer.prototype.qn = function (a) {
        var e_5, _a, e_6, _b;
        if (a.oldItems != null) {
            try {
                for (var _c = __values(fromEn(a.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var b = _d.value;
                    b.renderRequested = delegateRemove(b.renderRequested, runOn(this, this.qm));
                }
            }
            catch (e_5_1) {
                e_5 = { error: e_5_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_5)
                        throw e_5.error;
                }
            }
        }
        if (a.newItems != null) {
            try {
                for (var _e = __values(fromEn(a.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var c = _f.value;
                    c.renderRequested = delegateCombine(c.renderRequested, runOn(this, this.qm));
                }
            }
            catch (e_6_1) {
                e_6 = { error: e_6_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_6)
                        throw e_6.error;
                }
            }
        }
        this.mi(true);
    };
    AnnotationLayer.prototype.qq = function (a) {
        var e_7, _a, e_8, _b;
        if (a.oldItems != null) {
            try {
                for (var _c = __values(fromEn(a.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var b = _d.value;
                    b.renderRequested = delegateRemove(b.renderRequested, runOn(this, this.qw));
                }
            }
            catch (e_7_1) {
                e_7 = { error: e_7_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_7)
                        throw e_7.error;
                }
            }
        }
        if (a.newItems != null) {
            try {
                for (var _e = __values(fromEn(a.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var c = _f.value;
                    c.renderRequested = delegateCombine(c.renderRequested, runOn(this, this.qw));
                }
            }
            catch (e_8_1) {
                e_8 = { error: e_8_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_8)
                        throw e_8.error;
                }
            }
        }
        this.mi(true);
    };
    AnnotationLayer.prototype.m6 = function (a, b) {
        this.mi(false);
    };
    AnnotationLayer.prototype.m5 = function (a, b) {
        this.mi(true);
    };
    AnnotationLayer.prototype.mj = function (a) {
        _super.prototype.mj.call(this, a);
        if (this.cx(this.b0)) {
            return;
        }
        if (this.eo(a) && !this.es) {
            var b = this.p6;
            if (this.cv()) {
                if (this.ce.g) {
                    this.ce.t();
                }
                this.p6 = this.p7;
                this.p7 = b;
            }
            else {
                this.p6 = this.p5;
                this.p5 = b;
            }
            this.qr(this.p5, this.b0);
            this.mr();
        }
        else {
            if (!this.es) {
                this.qr(this.p5, this.b0);
            }
            this.qu(this.p5, this.b0);
        }
    };
    AnnotationLayer.prototype.get_dc = function () {
        return true;
    };
    AnnotationLayer.prototype.qr = function (a, b) {
    };
    AnnotationLayer.prototype.qu = function (a, b) {
        this.p4.b1();
    };
    AnnotationLayer.prototype.qk = function (a) {
        var b = { $type: Point_$type, x: this.q5.x, y: this.q5.y };
        if (a.isVertical) {
            if (isNaN_(this.q5.y)) {
                return new Tuple$2(Boolean_$type, Point_$type, false, b);
            }
            if (isNaN_(this.q5.x)) {
                b.x = 0;
                return new Tuple$2(Boolean_$type, Point_$type, true, b);
            }
        }
        else {
            if (isNaN_(this.q5.x)) {
                return new Tuple$2(Boolean_$type, Point_$type, false, b);
            }
            if (isNaN_(this.q5.y)) {
                b.y = 0;
                return new Tuple$2(Boolean_$type, Point_$type, true, b);
            }
        }
        return new Tuple$2(Boolean_$type, Point_$type, true, b);
    };
    AnnotationLayer.prototype.lt = function (a) {
        _super.prototype.lt.call(this, a);
        if (isNaN_(this.q7.x) && isNaN_(this.q7.y)) {
            if (isNaN_(a.x) && isNaN_(a.y)) {
                this.p4.b0();
                return;
            }
            else {
                this.p4.b2();
                this.q5 = a;
            }
        }
        else {
            this.p4.b2();
            this.q5 = this.q7;
        }
        this.mi(true);
    };
    AnnotationLayer.prototype.e9 = function (a, b, c) {
        var d = _super.prototype.e9.call(this, a, b, c);
        if (!this.b0.t()) {
            d = false;
            return d;
        }
        return d;
    };
    AnnotationLayer.prototype.get_e5 = function () {
        return this.qd;
    };
    Object.defineProperty(AnnotationLayer.prototype, "qd", {
        get: function () {
            return this.p8;
        },
        set: function (a) {
            var b = this.p8;
            this.p8 = a;
            this.raisePropertyChanged("ShouldRenderAsOverlay", b, this.p8);
        },
        enumerable: false,
        configurable: true
    });
    AnnotationLayer.$t = markType(AnnotationLayer, 'AnnotationLayer', Series.$);
    AnnotationLayer.$$p = markDep(DependencyProperty, PropertyMetadata, AnnotationLayer, 'raisePropertyChanged', ['CursorPosition:q6:qz', [Point_$type, { $type: Point_$type, x: NaN, y: NaN }], 'IsDefaultCrosshairDisabled:p9:q0', [0, true], 'UseIndex:qe:q1', [0, false], 'UseLegend:qf:q2', [0, false]]);
    return AnnotationLayer;
}(Series));
export { AnnotationLayer };
/**
 * @hidden
 */
var AnnotationLayerView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnnotationLayerView, _super);
    function AnnotationLayerView(a) {
        var _this = _super.call(this, a) || this;
        _this.bx = null;
        _this.by = false;
        _this.bz = -1;
        _this.bx = a;
        return _this;
    }
    AnnotationLayerView.prototype.b3 = function () {
        if (this.by) {
            this.by = false;
            this.bz = -1;
            this.bx.q5 = { $type: Point_$type, x: NaN, y: NaN };
            this.bx.mi(true);
        }
    };
    AnnotationLayerView.prototype.b0 = function () {
        this.by = true;
        if (this.e.g9 != null) {
            this.e.g9.setTimeout(runOn(this, this.b3), 300);
        }
        else {
            this.bz = window.setTimeout(runOn(this, this.b3), 300);
        }
    };
    AnnotationLayerView.prototype.b2 = function () {
        if (this.by == true) {
            this.by = false;
            if (this.bz != -1) {
                window.clearTimeout(this.bz);
                this.bz = -1;
            }
        }
    };
    AnnotationLayerView.prototype.b1 = function () {
        this.aq();
    };
    AnnotationLayerView.$t = markType(AnnotationLayerView, 'AnnotationLayerView', SeriesView.$);
    return AnnotationLayerView;
}(SeriesView));
export { AnnotationLayerView };
