/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { FinancialSeries } from "./FinancialSeries";
import { DependencyProperty } from "igniteui-angular-core";
import { ISortingAxis_$type } from "./ISortingAxis";
import { typeCast, markType, markDep } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { AxisRange } from "./AxisRange";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
/**
 * @hidden
 */
var FinancialOverlay = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialOverlay, _super);
    function FinancialOverlay() {
        var _this = _super.call(this) || this;
        _this.tm = false;
        _this.tm = false;
        return _this;
    }
    FinancialOverlay.prototype.get_dr = function () {
        return true;
    };
    FinancialOverlay.prototype.k0 = function (a, b, c, d) {
        _super.prototype.k0.call(this, a, b, c, d);
        if (this.qc != null && typeCast(ISortingAxis_$type, this.qc) !== null) {
            this.qc.i$i();
        }
        this.qt.bx.e(this.ft);
        this.tn();
        if (this.qy != null) {
            this.qy.c0();
        }
        this.mi(true);
    };
    FinancialOverlay.prototype.get_e8 = function () {
        return true;
    };
    FinancialOverlay.prototype.l4 = function (a, b, c, d) {
        switch (b) {
            case "FastItemsSource":
                this.tm = false;
                break;
            case FinancialOverlay.$$p[0]:
                this.tm = false;
                this.mi(false);
                this.lp();
                break;
            case "XAxis":
                this.tm = false;
                break;
        }
        _super.prototype.l4.call(this, a, b, c, d);
    };
    FinancialOverlay.prototype.bp = function () {
        if (this.bq == 0) {
            return 1;
        }
        else {
            return _super.prototype.bp.call(this);
        }
    };
    FinancialOverlay.prototype.ev = function (a, b) {
        if (this.eu(a, b)) {
            return true;
        }
        return false;
    };
    FinancialOverlay.prototype.ac = function () {
        _super.prototype.ac.call(this);
        this.mi(false);
    };
    FinancialOverlay.prototype.en = function (a) {
        var b = this.ck != null ? this.ck.indexOf(a) : -1;
        var c = this.b0.bv;
        c = c.copy();
        var d = this.b0.bu;
        var e = new Rect(0, 0, 0, 1, 1);
        var f = this.pt(this.b0);
        var g = new ScalerParams(0, e, e, this.qc.cg, f);
        var h = new ScalerParams(0, e, e, this.qy.cg, f);
        h.b = this.gc();
        if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
            if (this.qc != null) {
                var i = this.qc.ei(b, g);
                if (i < c.left + 0.1 * c.width) {
                    i = i + 0.4 * c.width;
                }
                if (i > c.right - 0.1 * c.width) {
                    i = i - 0.4 * c.width;
                }
                c.x = i - 0.5 * c.width;
            }
            if (this.qy != null && this.q7 != null && this.q6 != null && b < this.q7.count && b < this.q6.count) {
                var j = this.qy.ei(this.q7.item(b), h);
                var k = this.qy.ei(this.q6.item(b), h);
                if (!isNaN_(j) && !isNaN_(k)) {
                    var l = Math.abs(j - k);
                    if (c.height < l) {
                        c.height = l;
                        c.y = Math.min(j, k);
                    }
                    else {
                        if (j < c.top + 0.1 * c.height) {
                            j = j + 0.4 * c.height;
                        }
                        if (j > c.bottom - 0.1 * c.height) {
                            j = j - 0.4 * c.height;
                        }
                        c.y = j - 0.5 * c.height;
                    }
                }
            }
            this.b8.au(this.cd, c, true);
        }
        return b >= 0;
    };
    FinancialOverlay.prototype.ap = function (a) {
        if (a != null && a == this.qy && this.q7 != null && this.q6 != null) {
            return new AxisRange(this.q7.minimum, this.q6.maximum);
        }
        return null;
    };
    FinancialOverlay.$t = markType(FinancialOverlay, 'FinancialOverlay', FinancialSeries.$);
    FinancialOverlay.$$p = markDep(DependencyProperty, PropertyMetadata, FinancialOverlay, 'raisePropertyChanged', ['IgnoreFirst:to:tq', [1, 0]]);
    return FinancialOverlay;
}(FinancialSeries));
export { FinancialOverlay };
