/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { MarkerSeries } from "./MarkerSeries";
import { Base, runOn, Number_$type, enumGetBox, Point_$type, typeCast, fromEnum, markType, markDep } from "igniteui-angular-core";
import { PolarAxisInfoCache } from "./PolarAxisInfoCache";
import { SeriesRenderer$2 } from "./SeriesRenderer$2";
import { PolarFrame } from "./PolarFrame";
import { DependencyProperty } from "igniteui-angular-core";
import { NumericAngleAxis } from "./NumericAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { TrendLineType_$type } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap_$type } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { ScatterItemSearchMode_$type } from "./ScatterItemSearchMode";
import { HighlightingInfo } from "./HighlightingInfo";
import { List$1 } from "igniteui-angular-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-angular-core";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { PolarAxes } from "./PolarAxes";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { SeriesRenderingArguments } from "./SeriesRenderingArguments";
import { AxisRange } from "./AxisRange";
import { Dictionary$2 } from "igniteui-angular-core";
import { OwnedPoint } from "./OwnedPoint";
import { GeometryUtil } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { HashPool$2 } from "igniteui-angular-core";
import { Clipper } from "igniteui-angular-core";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { PolarTrendLineManager } from "./PolarTrendLineManager";
import { AssigningPolarStyleEventArgs } from "./AssigningPolarStyleEventArgs";
import { AssigningPolarMarkerStyleEventArgs } from "./AssigningPolarMarkerStyleEventArgs";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { DataLegendSeriesValueInfo } from "igniteui-angular-core";
import { DataLegendSeriesContext } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { truncate, isNaN_, isInfinity } from "igniteui-angular-core";
import { Defaults } from "./Defaults";
import { NumericMarkerManager } from "./NumericMarkerManager";
import { GeometryGroup } from "igniteui-angular-core";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
/**
 * @hidden
 */
var PolarBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolarBase, _super);
    function PolarBase() {
        var _this = _super.call(this) || this;
        _this.rz = null;
        _this.rl = null;
        _this.rx = null;
        _this.u1 = null;
        _this.u0 = null;
        _this.sb = null;
        _this.sd = null;
        _this.se = null;
        _this.r3 = new PolarFrame();
        _this.r5 = new PolarFrame();
        _this.r1 = new PolarFrame();
        _this.rw = null;
        _this.sv = null;
        _this.r7 = 1;
        _this.si = false;
        _this.sh = false;
        _this.rs = null;
        _this.rt = null;
        _this.assigningPolarStyle = null;
        _this.assigningPolarMarkerStyle = null;
        _this.r6 = null;
        _this.r4 = null;
        _this.r0 = null;
        _this.r6 = new PolarSeriesRenderManager();
        _this.r8 = _this.r9();
        _this.r4 = new PolarFrame();
        _this.r5.x = runOn(_this, _this.uz);
        _this.r3.x = runOn(_this, _this.uz);
        _this.r1.x = runOn(_this, _this.uz);
        _this.sb = new SeriesRenderer$2(PolarFrame.$, PolarBaseView.$, 0, runOn(_this, _this.t2), runOn(_this, _this.t6), runOn(_this, _this.cv), runOn(_this, _this.mr), runOn(_this, _this.tx));
        return _this;
    }
    PolarBase.prototype.bx = function () {
        return new PolarBaseView(this);
    };
    PolarBase.prototype.lz = function (a) {
        _super.prototype.lz.call(this, a);
        this.ry = a;
    };
    PolarBase.prototype.ku = function () {
        _super.prototype.ku.call(this);
        this.ru = null;
        this.rv = null;
    };
    PolarBase.prototype.get_d6 = function () {
        return true;
    };
    PolarBase.prototype.c1 = function (a, b, c, d) {
        var _this = this;
        if (!this.hasMarkers) {
            return false;
        }
        var e = this.ru;
        var f = new ScalerParams(1, this.cd.sf, this.pz, e.cg);
        f.c = this.getEffectiveViewport1(this.b0);
        var g = this.rv;
        var h = new ScalerParams(1, this.cd.sf, this.pz, g.cg);
        h.c = this.getEffectiveViewport1(this.b0);
        a.clear();
        this.qc.cf(function (i) {
            if (i._visibility == 0) {
                var j = new SeriesPointOfInterest();
                var k = i.n;
                var l = i.o;
                if (k < _this.pz.left || k > _this.pz.right || l < _this.pz.top || l > _this.pz.bottom) {
                    return;
                }
                var m = void 0;
                var n = void 0;
                var o = _this.rw.f(k, l, _this.b0.bv, _this.b0.bu, m, n);
                m = o.p4;
                n = o.p5;
                j.b = m;
                j.c = n;
                j.a = i.content;
                a.add(j);
            }
        });
        return true;
    };
    PolarBase.prototype.tx = function () {
        if (this.ce.g) {
            this.ce.t();
        }
    };
    PolarBase.prototype.tz = function () {
        this.rw.e(this.rz.w, this.sf, this.sg, this.u1, this.u0, function (a, b) { return Math.cos(b); }, function (a, b) { return Math.sin(b); }, true);
    };
    Object.defineProperty(PolarBase.prototype, "sf", {
        get: function () {
            return this.sd;
        },
        set: function (a) {
            if (this.sd != a) {
                var b = this.sf;
                this.sd = a;
                this.raisePropertyChanged("AngleColumn", b, this.sf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PolarBase.prototype, "sg", {
        get: function () {
            return this.se;
        },
        set: function (a) {
            if (this.se != a) {
                var b = this.sg;
                this.se = a;
                this.raisePropertyChanged("RadiusColumn", b, this.sg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PolarBase.prototype, "uu", {
        get: function () {
            return this.c(PolarBase.t7);
        },
        set: function (a) {
            this.h(PolarBase.t7, a);
        },
        enumerable: false,
        configurable: true
    });
    PolarBase.prototype.r2 = function () {
        var a = this.r1;
        if (this.cv()) {
            if (this.ce.g) {
                this.ce.t();
            }
            a = this.r5;
        }
        return a;
    };
    PolarBase.prototype.lf = function () {
        _super.prototype.lf.call(this);
        if (this.rv != null) {
            this.rv.h7(false);
        }
        if (this.ru != null) {
            this.ru.h7(false);
        }
    };
    PolarBase.prototype.k0 = function (a, b, c, d) {
        var e = false;
        this.ry.cv.g$e(a, b, c, d);
        if (this.ru != null && !this.ru.c0()) {
            e = true;
        }
        if (this.rv != null && !this.rv.c0()) {
            e = true;
        }
        if (e) {
            this.mi(true);
        }
    };
    PolarBase.prototype.m5 = function (a, b) {
        this.mi(false);
    };
    PolarBase.prototype.m6 = function (a, b) {
        this.mi(false);
    };
    PolarBase.prototype.e9 = function (a, b, c) {
        var d = true;
        if (!_super.prototype.e9.call(this, a, b, c) || !c.o() || b.isEmpty || a.isEmpty || this.ru == null || this.rv == null || this.sf == null || this.sg == null || this.sf.count == 0 || this.sg.count == 0 || this.ck == null || this.ck.count != this.sf.count || this.ck.count != this.sg.count || this.rw == null || this.ru.bh == null || this.rv.bh == null || this.ru.lv == this.ru.lu || this.rv.lv == this.rv.lu) {
            d = false;
        }
        return d;
    };
    PolarBase.prototype.mj = function (a) {
        var b;
        var c;
        var d = this.getViewInfo(c, b);
        c = d.p0;
        b = d.p1;
        if (!this.e9(c, b, this.b0)) {
            this.kx(true, this.b0);
            return;
        }
        this.u1 = b;
        this.u0 = c;
        this.rx = new PolarAxisInfoCache(this.ru, this.rv, this.ck);
        var e = new SeriesRenderingArguments(this, c, b, a, this.es);
        var f = this.sb.g(e, this.r3, this.r1, this.r5, this.ry);
        this.r3 = f.p1;
        this.r1 = f.p2;
        this.r5 = f.p3;
    };
    PolarBase.prototype.uz = function (a) {
        var b = this.rw.h(a.x, a.y, this.u1, this.u0, this.rx.e, this.rx.d, this.rx.g, this.rx.f, this.rx.i, this.rx.h);
        return b;
    };
    PolarBase.prototype.ap = function (a) {
        if (a != null && a == this.ru && this.sf != null) {
            return new AxisRange(this.sf.minimum, this.sf.maximum);
        }
        if (a != null && a == this.rv && this.sg != null) {
            return new AxisRange(this.sg.minimum, this.sg.maximum);
        }
        return null;
    };
    PolarBase.prototype.en = function (a) {
        var b = this.b0.bv;
        b = b.copy();
        var c = this.b0.bu;
        var d = !b.isEmpty && !c.isEmpty && this.ck != null ? this.ck.indexOf(a) : -1;
        if (this.ru == null || this.sf == null || this.rv == null || this.sg == null) {
            return false;
        }
        if (d < 0 || d > this.sf.count - 1 || d > this.sg.count - 1) {
            return false;
        }
        var e = this.ru.getScaledAngle(this.sf.item(d));
        var f = this.rv.ns(this.sg.item(d));
        var g = 0.5 + (Math.cos(e) * f);
        var h = 0.5 + (Math.sin(e) * f);
        if (!isNaN_(g)) {
            if (g < b.left + 0.1 * b.width) {
                g = g + 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
            if (g > b.right - 0.1 * b.width) {
                g = g - 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
        }
        if (!isNaN_(h)) {
            if (h < b.top + 0.1 * b.height) {
                h = h + 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
            if (h > b.bottom - 0.1 * b.height) {
                h = h - 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
        }
        if (this.b8 != null) {
            this.b8.au(this.cd, b, true);
        }
        return d >= 0;
    };
    PolarBase.prototype.ht = function (a) {
        var b = this.hd(a);
        if (this.ck != null && b >= 0 && b < this.ck.count) {
            return this.ck.item(b);
        }
        return null;
    };
    PolarBase.prototype.hd = function (a) {
        var b = truncate(Math.round(this.f5(a)));
        return b;
    };
    PolarBase.prototype.f5 = function (a) {
        switch (this.r8) {
            case 1: return this.sz(a);
            case 3: return this.s0(a);
            case 2: return this.sx(a);
            case 4: return this.sy(a);
        }
        return -1;
    };
    PolarBase.prototype.sy = function (a) {
        return this.s1(a, false);
    };
    PolarBase.prototype.sx = function (a) {
        var b = this.ph(a);
        var c = b.x;
        var d = b.y;
        if (this.ck == null || this.ru == null || this.rv == null || this.sf == null || this.sg == null) {
            return -1;
        }
        if (this.ck.count > this.s3) {
            return -1;
        }
        if (!this.sm()) {
            return -1;
        }
        var e = this.sv;
        var f = 1.7976931348623157E+308;
        var g = -1;
        for (var h = 0; h < this.sf.count; h++) {
            var i = e._inner[h].x;
            var j = e._inner[h].y;
            var k = (c - i) * (c - i) + (d - j) * (d - j);
            if (k < f) {
                f = k;
                g = h;
            }
        }
        return g;
    };
    PolarBase.prototype.sm = function () {
        var a = this.r1;
        if (this.cv()) {
            a = this.r5;
        }
        if (a == null || a.w.count == 0) {
            return false;
        }
        this.sv = a.w;
        return true;
    };
    PolarBase.prototype.s1 = function (a, b) {
        if (!this.sp) {
            return -1;
        }
        var c = { $type: Point_$type, x: 0, y: 0 };
        var d = true;
        var e = this.r1;
        if (this.cv()) {
            e = this.r5;
        }
        if (e == null) {
            return -1;
        }
        if (e.m == null) {
            return -1;
        }
        if (this.ck == null || this.ck.count > this.s3) {
            return -1;
        }
        if (!this.sm()) {
            return -1;
        }
        var f = this.sv;
        var g = this.ph(a);
        var h = 1.7976931348623157E+308;
        var i = -1;
        for (var j = 0; j < f.count; j++) {
            var k = f._inner[j];
            if (j > 0) {
                if (isNaN_(k.x) || isNaN_(k.y) || isNaN_(c.x) || isNaN_(c.y)) {
                    c = k;
                    continue;
                }
                if (!b || e.j.containsKey(this.ck.item(j)) || e.j.containsKey(this.ck.item(j - 1))) {
                    var l = GeometryUtil.d(g, c, k);
                    if (l < h) {
                        h = l;
                        i = j;
                    }
                }
            }
            c = k;
        }
        if (i >= 0) {
            var m = f._inner[i];
            var n = f._inner[i - 1];
            if (!b || (e.j.containsKey(this.ck.item(i)) && e.j.containsKey(this.ck.item(i - 1)))) {
                var o = GeometryUtil.h(g, n, m);
                return (i - 1) + o;
            }
            else if (e.j.containsKey(this.ck.item(i))) {
                return i;
            }
            else {
                return i - 1;
            }
        }
        return -1;
    };
    PolarBase.prototype.s0 = function (a) {
        return this.s1(a, true);
    };
    PolarBase.prototype.sz = function (a) {
        var _this = this;
        var b = null;
        var c = 1.7976931348623157E+308;
        var d = this.ph(a);
        var e = d.x;
        var f = d.y;
        if (this.ry.cw.e > this.s3) {
            return -1;
        }
        this.ry.cz(function (g) {
            if (g._visibility == 0) {
                var h = _this.ry.cp(g);
                var i = h.left + h.width / 2;
                var j = h.top + h.height / 2;
                var k = (e - i) * (e - i) + (f - j) * (f - j);
                if (k < c) {
                    c = k;
                    b = g;
                }
            }
        });
        if (b != null) {
            return b.ak;
        }
        return -1;
    };
    PolarBase.prototype.pm = function (a, b, c) {
        var _this = this;
        if (this.ru == null || this.rv == null || this.sf == null || this.sg == null) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        var d = this.b0.bv;
        var e = this.b0.bu;
        var f = this.getEffectiveViewport();
        var g = new ScalerParams(0, d, e, this.ru.cg, f);
        var h = ((function () {
            var $ret = new ScalerParams(0, d, e, _this.rv.cg, f);
            $ret.b = _this.gc();
            return $ret;
        })());
        if (b) {
            var i = this.f5(a);
            if (i == -1) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            var j = truncate(Math.floor(i));
            var k = truncate(Math.ceil(i));
            if (j < 0) {
                j = 0;
            }
            if (k < 0) {
                k = 0;
            }
            if (k > this.ck.count - 1) {
                k = this.ck.count - 1;
            }
            if (j > this.ck.count - 1) {
                j = this.ck.count - 1;
            }
            if (k == j) {
                return this.rw.h(this.sf.item(j), this.sg.item(j), d, e, this.rx.e, this.rx.d, this.rx.g, this.rx.f, this.rx.i, this.rx.h);
            }
            var l = i - Math.floor(i);
            var m = this.rw.h(this.sf.item(j), this.sg.item(j), d, e, this.rx.e, this.rx.d, this.rx.g, this.rx.f, this.rx.i, this.rx.h);
            var n = this.rw.h(this.sf.item(k), this.sg.item(k), d, e, this.rx.e, this.rx.d, this.rx.g, this.rx.f, this.rx.i, this.rx.h);
            var o = m.x;
            var p = m.y;
            var q = n.x;
            var r = n.y;
            var s = q - o;
            var t = r - p;
            return { $type: Point_$type, x: o + s * l, y: p + t * l };
        }
        else {
            var u = this.hd(a);
            if (u == -1) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            return this.rw.h(this.sf.item(u), this.sg.item(u), d, e, this.rx.e, this.rx.d, this.rx.g, this.rx.f, this.rx.i, this.rx.h);
        }
    };
    PolarBase.prototype.ag = function () {
        return [this.ru, this.rv];
    };
    PolarBase.prototype.hw = function (a, b) {
        var c = this.jq(b);
        if (c == PolarBase.$$p[3]) {
            return this.hx(a, b, this.te);
        }
        if (c == PolarBase.$$p[13]) {
            return this.hx(a, b, this.ts);
        }
        return _super.prototype.hw.call(this, a, b);
    };
    PolarBase.prototype.l4 = function (a, b, c, d) {
        _super.prototype.l4.call(this, a, b, c, d);
        if (this.ry.cv.g$b(a, b, c, d)) {
            this.mi(false);
            this.lp();
        }
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.sf);
                    c.deregisterColumn(this.sg);
                    this.sf = null;
                    this.sg = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.sf = this.ch(this.te);
                    this.sg = this.ch(this.ts);
                }
                if ((this.rv != null && !this.rv.c0()) || (this.ru != null && !this.ru.c0())) {
                    this.mi(false);
                }
                break;
            case PolarBase.$$p[0]:
                if (this.ru != null && this.rv != null) {
                    this.rw = new PolarAxes(this.rv, this.ru);
                }
                if (c != null) {
                    c.bz(this);
                }
                if (d != null) {
                    d.cs(this);
                }
                if (this.ru != null && !this.ru.c0()) {
                    this.mi(false);
                }
                else if (c != null && d == null) {
                    this.kx(true, this.b0);
                }
                break;
            case PolarBase.$$p[10]:
                if (this.ru != null && this.rv != null) {
                    this.rw = new PolarAxes(this.rv, this.ru);
                }
                if (c != null) {
                    c.bz(this);
                }
                if (d != null) {
                    d.cs(this);
                }
                if (this.rv != null && !this.rv.c0()) {
                    this.mi(false);
                }
                else if (c != null && d == null) {
                    this.kx(true, this.b0);
                }
                if (this.ru != null && !this.ru.c0()) {
                    this.ru.h3();
                }
                break;
            case PolarBase.$$p[3]:
                if (this.ck != null) {
                    this.ck.deregisterColumn(this.sf);
                    this.sf = this.ch(this.te);
                }
                break;
            case "AngleColumn":
                this.ry.cv.g$i();
                if (this.ru != null && !this.ru.c0()) {
                    this.mi(false);
                }
                break;
            case PolarBase.$$p[13]:
                if (this.ck != null) {
                    this.ck.deregisterColumn(this.sg);
                    this.sg = this.ch(this.ts);
                }
                break;
            case "RadiusColumn":
                this.ry.cv.g$i();
                if (this.rv != null && !this.rv.c0()) {
                    this.mi(false);
                }
                break;
            case PolarBase.$$p[14]:
                this.mi(false);
                this.lp();
                break;
            case PolarBase.$$p[9]:
                this.mi(false);
                this.lp();
                break;
            case "TransitionProgress":
                this.rx = new PolarAxisInfoCache(this.ru, this.rv, this.ck);
                this.u1 = this.b0.bv;
                this.u0 = this.b0.bu;
                this.r5.v = this.su;
                this.r5.c(this.g0, this.r3, this.r1);
                if (this.cx(this.b0)) {
                    return;
                }
                if (this.g0 == 1) {
                    this.t6(this.r1, this.ry);
                }
                else {
                    this.t6(this.r5, this.ry);
                }
                if (this.cd != null) {
                    this.cd.nn(this);
                }
                break;
            case "TrendLineBrush":
                this.mw();
                break;
            case PolarBase.$$p[4]:
                this.mi(false);
                this.lp();
                break;
            case "TrendLineType":
                this.lp();
                break;
            case PolarBase.$$p[6]:
                this.si = this.sr();
                this.mi(false);
                break;
            case PolarBase.$$p[5]:
                this.sh = this.sq();
                this.mi(false);
                break;
            case PolarBase.$$p[7]:
                this.r8 = this.r9();
                break;
        }
    };
    Object.defineProperty(PolarBase.prototype, "r8", {
        get: function () {
            return this.r7;
        },
        set: function (a) {
            var b = this.r7;
            this.r7 = a;
            if (b != this.r7) {
                this.raisePropertyChanged("ActualItemSearchMode", enumGetBox(ScatterItemSearchMode_$type, b), enumGetBox(ScatterItemSearchMode_$type, this.r7));
            }
        },
        enumerable: false,
        configurable: true
    });
    PolarBase.prototype.r9 = function () {
        if (this.sa != 0) {
            return this.sa;
        }
        return this.sp ? 4 : 1;
    };
    PolarBase.prototype.get_sp = function () {
        return false;
    };
    Object.defineProperty(PolarBase.prototype, "sp", {
        get: function () {
            return this.get_sp();
        },
        enumerable: false,
        configurable: true
    });
    PolarBase.prototype.sr = function () {
        return this.so;
    };
    PolarBase.prototype.sq = function () {
        return this.sn;
    };
    PolarBase.prototype.sk = function (a) {
        if (typeCast(NumericRadiusAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    PolarBase.prototype.sj = function (a) {
        if (typeCast(NumericAngleAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    PolarBase.prototype.kx = function (a, b) {
        _super.prototype.kx.call(this, a, b);
        var c = b;
        if (a) {
            c.cw.clear();
        }
        c.cv.g$d();
    };
    PolarBase.prototype.rm = function (a, b) {
        var c = a.top - 10;
        var d = a.bottom + 10;
        var e = a.left - 10;
        var f = a.right + 10;
        var g = ((function () {
            var $ret = new Clipper(1, e, d, f, c, false);
            $ret.i = b;
            return $ret;
        })());
        return g;
    };
    PolarBase.prototype.tw = function (a, b, c, d) {
        a.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, b);
        var e = this.ck;
        var _loop_1 = function (f) {
            var g = a.w._inner[f];
            if (!isInfinity(g.x) && !isInfinity(g.y)) {
                var h_1 = { $type: Point_$type, x: this_1.sf.item(f), y: this_1.sg.item(f) };
                var i_1 = { $type: Point_$type, x: g.x, y: g.y };
                a.g.addItem(e.item(f), ((function () {
                    var $ret = new OwnedPoint();
                    $ret.a = e.item(f);
                    $ret.b = h_1;
                    $ret.c = i_1;
                    return $ret;
                })()));
            }
        };
        var this_1 = this;
        for (var f = 0; f < b; f++) {
            _loop_1(f);
        }
    };
    PolarBase.prototype.t2 = function (a, b) {
        var _this = this;
        var c = b.bv;
        var d = b.bu;
        a.j.clear();
        a.n.clear();
        var e = Math.min(this.sf != null ? this.sf.count : 0, this.sg != null ? this.sg.count : 0);
        if (e < 1) {
            return;
        }
        this.rx = new PolarAxisInfoCache(this.ru, this.rv, this.ck);
        this.rz = a;
        this.u0 = d;
        this.u1 = c;
        b.ct.l(a.j, this.s4, c, d, this.ft);
        if (e <= this.s4) {
            this.tw(a, e, c, d);
        }
        var f = this.rm(d, a.n);
        var g = Math.min(this.ru.lv, this.ru.lu);
        var h = Math.max(this.ru.lu, this.ru.lv);
        b.cv.i = this.su;
        b.cv.h = 0;
        b.cv.k = this.rv.nm;
        b.cv.j = this.rv.nl;
        b.cv.l = function (i, j) { return _this.rw.c(i, j, c, d, Math.cos); };
        b.cv.m = function (i, j) { return _this.rw.d(i, j, c, d, Math.sin); };
        var i = new List$1(Number_$type, 0);
        for (var j = 0; j < this.sf.count; j++) {
            if (this.sf.item(j) >= g && this.sf.item(j) <= h) {
                i.add(this.sf.item(j));
            }
        }
        var k = this.sg;
        if (i.count != this.sf.count) {
            k = new List$1(Number_$type, 0);
            for (var l = 0; l < this.sf.count; l++) {
                if (this.sf.item(l) >= g && this.sf.item(l) <= h) {
                    k.add(this.sg.item(l));
                }
            }
        }
        b.cv.n(a.n, this.sc, i, k, this.s5, runOn(this.ru, this.ru.getScaledAngle), runOn(this.rv, this.rv.ns), ((function () {
            var $ret = new TrendResolutionParams();
            $ret.b = _this.ft;
            $ret.f = d;
            $ret.g = c;
            return $ret;
        })()), f, g, h);
    };
    PolarBase.prototype.get_dx = function () {
        return true;
    };
    PolarBase.prototype.rq = function (a, b, c) {
        return null;
    };
    PolarBase.prototype.rr = function (a, b, c) {
        var d = this.r2();
        var e = this.ry.by(this.ph(b));
        var f = -1;
        if (e == null) {
            if (a != null) {
                f = this.ck.indexOf(a);
            }
            else {
                return null;
            }
        }
        else {
            f = e.ak;
        }
        if (f == -1) {
            return null;
        }
        var g = new HighlightingInfo();
        g.b = this;
        g.h = f;
        g.g = f;
        g.d = false;
        g.e = true;
        if (c != null && c.h == g.h && c.g == g.g) {
            return c;
        }
        return g;
    };
    PolarBase.prototype.rp = function (a, b, c) {
        var d = new HighlightingInfo();
        d.b = this;
        d.h = 0;
        d.g = this.ck.count - 1;
        d.d = true;
        if (c != null && c.h == d.h && c.g == d.g) {
            return c;
        }
        return d;
    };
    PolarBase.prototype.aw = function (a, b, c) {
        if (this.c2 && this.ef(this.bk) && !c) {
            var d = this.rq(a, b, this.rs);
            this.rs = d;
            return d;
        }
        else {
            var e = this.rp(a, b, this.rs);
            this.rs = e;
            return e;
        }
    };
    PolarBase.prototype.ax = function (a, b, c) {
        if (this.ef(this.bk) && !c) {
            var d = this.rr(a, b, this.rt);
            this.rt = d;
            return d;
        }
        else {
            var e = this.rp(a, b, this.rt);
            e.e = true;
            this.rt = e;
            return e;
        }
    };
    PolarBase.prototype.st = function () {
        return (this.assigningPolarStyle != null && this.si) || (this.bk != 1);
    };
    PolarBase.prototype.ss = function () {
        return (this.assigningPolarMarkerStyle != null && this.sh) || (this.bk != 1);
    };
    PolarBase.prototype.t6 = function (a, b) {
        var c = b.bv;
        var d = b.bu;
        var e = this.getEffectiveViewport1(b);
        var f = this.pr(b);
        this.rx = new PolarAxisInfoCache(this.ru, this.rv, this.ck);
        if (this.qf()) {
            b.ct.j(a.j, this.qh);
            if (this.ss()) {
                this.ty(b, a);
            }
        }
        b.cm();
        var g = this.rm(d, b.cv.g$j.ak);
        b.cv.g$h(a.n, g);
        this.tv(d, c, e, f, b);
    };
    PolarBase.prototype.rj = function (a, b) {
        return this.rk(a, b);
    };
    PolarBase.prototype.rk = function (a, b) {
        if (b < a || a < 0 || a > this.sf.count || b < 0 || b > this.sf.count) {
            return null;
        }
        var c = new Array((b - a) + 1);
        for (var d = a; d <= b; d++) {
            var e = d;
            c[d - a] = this.ck.item(d);
        }
        return c;
    };
    PolarBase.prototype.ty = function (a, b) {
        var _this = this;
        a.b3 = true;
        this.r6.aw(this, this.ss(), runOn(this, this.rj));
        var c = this.r6.d;
        var d = c != null;
        var e = this.getEffectiveViewport1(a);
        var f = this.ck == null ? 0 : this.ck.count;
        this.ry.cf(function (g) {
            if (g._visibility == 0) {
                var h = g.ak;
                var i = g.content;
                if (i == null) {
                    i = new DataContext();
                    g.content = i;
                }
                if (d) {
                    _this.t0(h, f, a.q);
                }
                _this.r6.ac(g, i);
            }
        });
    };
    PolarBase.prototype.t1 = function (a, b, c) {
        var d = this.bk != 1;
        this.r6.ay(this.r6.b, a, b, false);
        this.r6.ab(this.fr);
        var e = this.r6.av;
        var f = null;
        var g = this.ck;
        if (d && this.cd != null) {
            f = this.cd.a3.getHighlightingInfo(this, g, e.o, e.n, false);
            e.b = f;
        }
        e.f = c;
        this.t4(e);
        this.r6.z(this, f, c, d, a < 0);
    };
    PolarBase.prototype.t0 = function (a, b, c) {
        var d = this.bk != 1;
        this.r6.ay(this.r6.d, a, b, true);
        this.r6.aa(this.fr);
        var e = this.r6.au;
        var f = null;
        var g = this.ck;
        var h = null;
        if (d && this.cd != null) {
            f = this.cd.a3.getHighlightingInfo(this, g, e.o, e.n, true);
            if (this.cd.a3.isCrossSeriesHighlight(this)) {
                h = this.cd.a3.getHighlightingInfo(this, g, e.o, e.n, true);
            }
            e.b = f;
        }
        e.f = c;
        this.t3(e);
        this.r6.y(this, f, c, d, e.l, this.cd.a3.sumHighlightingProgress);
    };
    PolarBase.prototype.t4 = function (a) {
        if (this.assigningPolarStyle != null && this.si) {
            this.assigningPolarStyle(this, a);
        }
    };
    PolarBase.prototype.t3 = function (a) {
        if (this.assigningPolarMarkerStyle != null && this.sh) {
            this.assigningPolarMarkerStyle(this, a);
        }
    };
    PolarBase.prototype.tv = function (a, b, c, d, e) {
        e.cy(a, b, c, d);
    };
    PolarBase.prototype.mw = function () {
        _super.prototype.mw.call(this);
        if (this.index < 0) {
            return;
        }
        this.ry.c1();
    };
    PolarBase.prototype.mk = function (a, b) {
        _super.prototype.mk.call(this, a, b);
        if (!this.ez) {
            this.b0.a2(b);
            return;
        }
        this.b0.a2(b);
        if (this.cx(this.bz)) {
            return;
        }
        var c = this.bz;
        if (!this.et) {
            this.r4 = new PolarFrame();
            this.t2(this.r4, c);
        }
        this.et = false;
        this.t6(this.r4, c);
        this.ez = false;
    };
    PolarBase.prototype.mh = function (a, b, c, d, e) {
        _super.prototype.mh.call(this, a, b, c, d, e);
        var f = this.a6.a$h.item(d);
        var g = f;
        f.a1(c);
        if (this.cx(g)) {
            return;
        }
        if (this.r0 == null) {
            this.r0 = new PolarFrame();
        }
        this.t2(this.r0, g);
        this.t6(this.r0, g);
    };
    PolarBase.prototype.t5 = function (a, b) {
        var e_1, _a, e_2, _b;
        var c = new List$1(Base.$, 0);
        try {
            for (var _c = __values(fromEnum(b.c)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var d = _d.value;
                if (!a.containsKey(d)) {
                    c.add1(d);
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var e = _f.value;
                b.h(e);
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    PolarBase.prototype.ri = function (a, b, c) {
        this.tz();
        return this.rz.w.toArray();
    };
    PolarBase.prototype.sw = function (a) {
        var e_3, _a;
        var b = new List$1(Number_$type, 0);
        var c = this.ck;
        try {
            for (var _b = __values(fromEnum(this.ry.cw.c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                b.add(c.indexOf(d));
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        return b;
    };
    PolarBase.prototype.uy = function (a) {
        return { $type: Point_$type, x: this.sf.item(a), y: this.sg.item(a) };
    };
    PolarBase.prototype.k7 = function (a) {
        _super.prototype.k7.call(this, a);
        this.a8.exportTrendlineData(this, a, this.ry.cv.g$j);
    };
    PolarBase.prototype.getDataLegendSeriesContextAt = function (a, b) {
        var c = { $type: Point_$type, x: a, y: b };
        var d = this.ht(c);
        var e = d == null ? NaN : this.gb(d, "RadiusMemberPath");
        var f = d == null ? NaN : this.gb(d, "AngleMemberPath");
        var g = new DataLegendSeriesValueInfo();
        g.l = e;
        g.a = 11;
        g.p = this.ts != null ? this.ts : "Radius";
        g.q = this.to != null ? this.to : "R:";
        g.r = this.tq != null ? this.tq : "";
        var h = new DataLegendSeriesValueInfo();
        h.l = f;
        h.a = 10;
        h.p = this.te != null ? this.te : "Angle";
        h.q = this.ta != null ? this.ta : "A:";
        h.r = this.tc != null ? this.tc : "";
        var i = new DataLegendSeriesContext();
        i.f = ((function () {
            var $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
            $ret.add(g);
            $ret.add(h);
            return $ret;
        })());
        i.b = this.av();
        return i;
    };
    PolarBase.$t = markType(PolarBase, 'PolarBase', MarkerSeries.$);
    PolarBase.t7 = DependencyProperty.i("ActualTrendLineBrush", Brush.$, PolarBase.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    PolarBase.$$p = markDep(DependencyProperty, PropertyMetadata, PolarBase, 'raisePropertyChanged', ['AngleAxis:ru:t8', [NumericAngleAxis.$, null], 'AngleMemberAsLegendLabel:ta:t9', [2, null], 'AngleMemberAsLegendUnit:tc:ua', [2, null], 'AngleMemberPath:te:ub', [2], 'ClipSeriesToBounds:sl:uc', [0, false], 'IsCustomPolarMarkerStyleAllowed:sn:ud', [0, false], 'IsCustomPolarStyleAllowed:so:ue', [0, false], 'ItemSearchMode:sa:uf', [ScatterItemSearchMode_$type, enumGetBox(ScatterItemSearchMode_$type, 0)], 'ItemSearchThreshold:s3:ug', [1, 10000], 'MaximumMarkers:s4:uh', [1, 400], 'RadiusAxis:rv:ui', [NumericRadiusAxis.$, null], 'RadiusMemberAsLegendLabel:to:uj', [2, null], 'RadiusMemberAsLegendUnit:tq:uk', [2, null], 'RadiusMemberPath:ts:ul', [2], 'UseCartesianInterpolation:su:ut', [0, true], 'TrendLineType:sc:ur', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness:s2:uq', [1, 1.5], 'TrendLinePeriod:s5:up', [1, 7], 'TrendLineZIndex:s6:us', [1, 1], 'TrendLineBrush:uv:um', [Brush.$, null], 'TrendLineDashArray:uw:un', [DoubleCollection.$], 'TrendLineDashCap:ux:uo', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return PolarBase;
}(MarkerSeries));
export { PolarBase };
/**
 * @hidden
 */
var PolarSeriesRenderManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolarSeriesRenderManager, _super);
    function PolarSeriesRenderManager() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.au = null;
        _this.av = null;
        return _this;
    }
    PolarSeriesRenderManager.prototype.c = function () {
        this.au = new AssigningPolarMarkerStyleEventArgs();
        return this.au;
    };
    PolarSeriesRenderManager.prototype.a = function () {
        this.av = new AssigningPolarStyleEventArgs();
        return this.av;
    };
    PolarSeriesRenderManager.prototype.aw = function (a, b, c) {
        this.w(a, b, c);
    };
    PolarSeriesRenderManager.prototype.ax = function (a, b, c) {
        this.x(a, b, c);
    };
    PolarSeriesRenderManager.prototype.ay = function (a, b, c, d) {
        if (b == -1) {
            a.c = false;
            a.o = 0;
            a.n = c - 1;
        }
        else {
            if (d) {
                a.o = b;
                a.n = b;
            }
            else {
                a.c = false;
                a.o = b;
                a.n = b;
            }
        }
    };
    PolarSeriesRenderManager.$t = markType(PolarSeriesRenderManager, 'PolarSeriesRenderManager', SeriesRenderManager.$);
    return PolarSeriesRenderManager;
}(SeriesRenderManager));
export { PolarSeriesRenderManager };
/**
 * @hidden
 */
var PolarBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolarBaseView, _super);
    function PolarBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.cu = null;
        _this.ct = null;
        _this.cv = null;
        _this.cw = null;
        _this.cu = a;
        _this.cw = new HashPool$2(Base.$, Marker.$);
        _this.ch(_this.cw);
        _this.cv = new PolarTrendLineManager();
        return _this;
    }
    PolarBaseView.prototype.as = function () {
        _super.prototype.as.call(this);
        this.ct = this.cs();
        if (!this.q) {
            this.cu.s4 = 1000;
            this.b1.qd = Defaults.e;
        }
    };
    PolarBaseView.prototype.cz = function (a) {
        this.cw.g(a);
    };
    PolarBaseView.prototype.cs = function () {
        var _this = this;
        var a = new NumericMarkerManager(0, function (b) { return _this.cw.item(b); }, function (b) { return _this.cu.rx.c.item(b); }, runOn(this, this.c0), runOn(this, this.cr), runOn(this, this.cx));
        a.n = true;
        a.p = runOn(this.cu, this.cu.uy);
        return a;
    };
    PolarBaseView.prototype.c0 = function (a) {
        this.cu.t5(a, this.cw);
    };
    PolarBaseView.prototype.cr = function () {
        return this.cu.ri(this.cw, this.bv, this.bu);
    };
    PolarBaseView.prototype.cx = function () {
        return this.cu.sw(this.cw);
    };
    PolarBaseView.prototype.cy = function (a, b, c, d) {
        if (this.cu.sl) {
            var e = new GeometryGroup();
            this.cu.rv.n0(e, a, b, c, d);
        }
        else {
        }
    };
    PolarBaseView.prototype.c1 = function () {
        if (this.cu.uv != null) {
            this.cu.uu = this.cu.uv;
        }
        else {
            this.cu.uu = this.cu.oz;
        }
    };
    PolarBaseView.prototype.cf = function (a) {
        this.cw.f(a);
    };
    PolarBaseView.prototype.a5 = function (a, b) {
        if (a.d) {
            if (this.cu.sc != 0 && !b) {
                var c = this.cv.g$j;
                c.ac = this.cu.s2;
                c._stroke = this.cu.uu;
                c.ad = this.cu.ux;
                c.ai = this.cu.uw;
                a.u(c);
            }
        }
        _super.prototype.a5.call(this, a, b);
    };
    PolarBaseView.prototype.c2 = function () {
        return Rect.empty;
    };
    PolarBaseView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'><span>" + "${item." + this.cu.te + "}" + "</span><br/><span";
        var b = this.e.a6.a$r(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.cu.title + ": </span><span class='ui-priority-primary'>" + "${item." + this.cu.ts + "}</span></div>";
        return a;
    };
    PolarBaseView.$t = markType(PolarBaseView, 'PolarBaseView', MarkerSeriesView.$);
    return PolarBaseView;
}(MarkerSeriesView));
export { PolarBaseView };
