import { Series } from "./Series";
import { Point, Type } from "igniteui-angular-core";
import { Frame } from "./Frame";
import { SeriesView } from "./SeriesView";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { NotifyCollectionChangedEventArgs } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { Brush } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { Tuple$2 } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class AnnotationLayer extends Series {
    static $t: Type;
    constructor();
    protected bx(): SeriesView;
    lz(a: SeriesView): void;
    protected qc(a: Series): boolean;
    protected p4: AnnotationLayerView;
    qe: boolean;
    qf: boolean;
    q6: Point;
    p9: boolean;
    protected get_dj(): boolean;
    protected bp(): SeriesHitTestMode;
    protected get_dy(): boolean;
    protected get_isUsableInLegend(): boolean;
    protected l4(a: any, b: string, c: any, d: any): void;
    protected q7: Point;
    private qy;
    private qx;
    private qt;
    private qs;
    protected qa(a: Axis): boolean;
    private qm;
    protected qb(a: Series): boolean;
    private qw;
    protected qo(a: Axis, b: boolean): void;
    protected qp(a: Series, b: boolean): void;
    private qv;
    private ql;
    protected q3(): Brush;
    protected q4(): Brush;
    protected qn(a: NotifyCollectionChangedEventArgs): void;
    protected qq(a: NotifyCollectionChangedEventArgs): void;
    protected p6: Frame;
    protected p5: Frame;
    protected p7: Frame;
    protected m6(a: Rect, b: Rect): void;
    protected m5(a: Rect, b: Rect): void;
    mj(a: boolean): void;
    protected get_dc(): boolean;
    protected qr(a: Frame, b: SeriesView): void;
    protected qu(a: Frame, b: SeriesView): void;
    protected qk(a: Series): Tuple$2<boolean, Point>;
    protected lt(a: Point): void;
    q5: Point;
    e9(a: Rect, b: Rect, c: SeriesView): boolean;
    protected get_e5(): boolean;
    private p8;
    get qd(): boolean;
    set qd(a: boolean);
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AnnotationLayerView extends SeriesView {
    static $t: Type;
    constructor(a: AnnotationLayer);
    protected bx: AnnotationLayer;
    private by;
    private bz;
    private b3;
    b0(): void;
    b2(): void;
    b1(): void;
}
