import { AnnotationLayer } from "./AnnotationLayer";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "igniteui-angular-core";
import { CategoryHighlightLayerFrame } from "./CategoryHighlightLayerFrame";
import { Type } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { Frame } from "./Frame";
import { CategoryHighlightFrameRect } from "./CategoryHighlightFrameRect";
import { List$1 } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { Rectangle } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { Brush } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class CategoryHighlightLayer extends AnnotationLayer {
    static $t: Type;
    protected get_db(): boolean;
    constructor();
    protected bx(): SeriesView;
    lz(a: SeriesView): void;
    protected q9: CategoryHighlightLayerView;
    q8: CategoryAxisBase;
    rb: boolean;
    get rc(): number;
    set rc(a: number);
    static readonly rj: DependencyProperty;
    protected qo(a: Axis, b: boolean): void;
    private ra;
    protected qr(a: Frame, b: SeriesView): void;
    private rh;
    rg(a: Rect, b: CategoryHighlightLayerFrame, c: Axis): void;
    protected qu(a: Frame, b: SeriesView): void;
    protected em(): boolean;
    ri(a: CategoryHighlightFrameRect, b: Rectangle): void;
    protected l4(a: any, b: string, c: any, d: any): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CategoryHighlightLayerView extends AnnotationLayerView {
    static $t: Type;
    constructor(a: CategoryHighlightLayer);
    protected b4: CategoryHighlightLayer;
    b5: Pool$1<Rectangle>;
    as(): void;
    protected b6: List$1<Rectangle>;
    private cd;
    private b8;
    private ca;
    private b9;
    cb(a: Brush): Brush;
    cc(a: Brush): Brush;
    b7(a: Rectangle, b: number, c: number, d: number, e: number): void;
    protected a6(a: RenderingContext, b: boolean): void;
    al(a: any): void;
}
