import { AnnotationLayer } from "./AnnotationLayer";
import { Series } from "./Series";
import { CategoryItemHighlightType } from "./CategoryItemHighlightType";
import { MarkerType } from "./MarkerType";
import { Brush } from "igniteui-angular-core";
import { DataTemplate } from "igniteui-angular-core";
import { CategoryItemHighlightLayerFrame } from "./CategoryItemHighlightLayerFrame";
import { Type, Point } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { Frame } from "./Frame";
import { ItemHighlightFrameRect } from "./ItemHighlightFrameRect";
import { List$1 } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { Rectangle } from "igniteui-angular-core";
import { ContentControl } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class CategoryItemHighlightLayer extends AnnotationLayer {
    static $t: Type;
    protected get_db(): boolean;
    constructor();
    protected bx(): SeriesView;
    lz(a: SeriesView): void;
    protected q8: CategoryItemHighlightLayerView;
    rc: Series;
    rq: string;
    rg: boolean;
    q9: CategoryItemHighlightType;
    rb: MarkerType;
    sa: Brush;
    sb: Brush;
    rz: DataTemplate;
    ri: number;
    rf: boolean;
    protected qp(a: Series, b: boolean): void;
    protected qc(a: Series): boolean;
    protected qr(a: Frame, b: SeriesView): void;
    private re;
    private rd;
    protected l4(a: any, b: string, c: any, d: any): void;
    private rh;
    private rw;
    ru(a: Point, b: CategoryItemHighlightLayerFrame, c: Series): void;
    private ra;
    rv(a: Rect, b: CategoryItemHighlightLayerFrame, c: Series): void;
    protected qu(a: Frame, b: SeriesView): void;
    rx(a: ItemHighlightFrameRect, b: ContentControl): void;
    ry(a: ItemHighlightFrameRect, b: Rectangle): void;
    protected em(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CategoryItemHighlightLayerView extends AnnotationLayerView {
    static $t: Type;
    constructor(a: CategoryItemHighlightLayer);
    protected b4: CategoryItemHighlightLayer;
    b6: Pool$1<Rectangle>;
    b5: Pool$1<ContentControl>;
    as(): void;
    protected b7: List$1<ContentControl>;
    protected b8: List$1<Rectangle>;
    private ck;
    private ce;
    private cg;
    private cf;
    private ch;
    private b9;
    private cb;
    private ca;
    ci(a: Brush): Brush;
    cj(a: Brush): Brush;
    cd(a: Rectangle, b: number, c: number, d: number, e: number): void;
    cc(a: ContentControl, b: number, c: number): void;
    protected bh(a: any, b: number): void;
    protected a6(a: RenderingContext, b: boolean): void;
    al(a: any): void;
}
