import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IndicatorCalculationStrategy } from "./IndicatorCalculationStrategy";
import { Type } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class FullStochasticOscillatorIndicator extends StrategyBasedIndicator {
    static $t: Type;
    constructor();
    protected get_uh(): IndicatorCalculationStrategy;
    protected get uh(): IndicatorCalculationStrategy;
    protected get_uu(): Type;
    protected get uu(): Type;
    get u2(): number;
    set u2(a: number);
    static readonly u7: DependencyProperty;
    protected un(): number;
    uw(a: number): void;
    get smoothingPeriod(): number;
    set smoothingPeriod(a: number);
    static readonly u8: DependencyProperty;
    protected up(): number;
    get u4(): number;
    set u4(a: number);
    static readonly u9: DependencyProperty;
    protected um(): number;
    protected tx(): number;
}
