import { Series } from "./Series";
import { NumericXAxis } from "./NumericXAxis";
import { NumericYAxis } from "./NumericYAxis";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { Color } from "igniteui-angular-core";
import { Type, Point } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { SeriesView } from "./SeriesView";
import { ProgressiveLoadStatusEventArgs } from "./ProgressiveLoadStatusEventArgs";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { RenderSurface } from "./RenderSurface";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class HighDensityScatterSeries extends Series {
    static $t: Type;
    protected get_d5(): boolean;
    protected gu(): number;
    constructor();
    protected get_ec(): boolean;
    qb: NumericXAxis;
    qd: NumericYAxis;
    se: string;
    protected get qi(): IFastItemColumn$1<number>;
    protected set qi(a: IFastItemColumn$1<number>);
    private qh;
    sa: string;
    si: string;
    sc: string;
    sk: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    hw(a: any, b: string): any;
    sm: string;
    protected get qk(): IFastItemColumn$1<number>;
    protected set qk(a: IFastItemColumn$1<number>);
    private qj;
    qr: boolean;
    qq: boolean;
    rm: number;
    rl: number;
    tk: Color;
    tj: Color;
    ry: number;
    private s1;
    protected l4(a: any, b: string, c: any, d: any): void;
    private sv;
    qp(a: any): boolean;
    qo(a: any): boolean;
    private sr;
    private rs;
    private ql;
    private q7;
    private q6;
    private q5;
    private q4;
    private q3;
    private q2;
    private q1;
    private q0;
    private get rb();
    private get ra();
    private get q9();
    private get q8();
    private p9;
    private qe;
    private qf;
    private qa;
    private qc;
    private qn;
    e9(a: Rect, b: Rect, c: SeriesView): boolean;
    private rt;
    get rz(): number;
    set rz(a: number);
    mj(a: boolean): void;
    private st;
    private rv;
    private rp;
    private ro;
    protected k0(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    private sq;
    private sw;
    private su;
    progressiveLoadStatusChanged: (sender: any, e: ProgressiveLoadStatusEventArgs) => void;
    private so;
    private ss;
    private qs;
    private s3;
    private qy;
    private qx;
    private qz;
    private re;
    private rc;
    private rd;
    private rf;
    private rh;
    private rj;
    private ri;
    private rg;
    private qu;
    private qv;
    private qw;
    private qt;
    private sy;
    en(a: any): boolean;
    private s0;
    private rw;
    private rx;
    private rk;
    private sz;
    private sx;
    private rr;
    private rq;
    private p6;
    private ru;
    private sp;
    protected bx(): SeriesView;
    lz(a: SeriesView): void;
    protected p8: HighDensityScatterSeriesView;
    ap(a: Axis): AxisRange;
    private qm;
    protected m5(a: Rect, b: Rect): void;
    protected m6(a: Rect, b: Rect): void;
    private _itemIndexes;
    private p7;
    private p4;
    ht(a: Point): any;
    private r0;
    s2(a: number[], b: number, c: number): void;
    protected get_e3(): boolean;
    protected set_e3(a: boolean): void;
    kx(a: boolean, b: SeriesView): void;
    mk(a: Rect, b: RenderSurface): void;
    private qg;
    mh(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    ku(): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class HighDensityScatterSeriesView extends SeriesView {
    static $t: Type;
    constructor(a: HighDensityScatterSeries);
    as(): void;
    ca(): void;
    protected bz: HighDensityScatterSeries;
    private bx;
    private b5;
    private b4;
    private b2;
    private b3;
    private b0;
    b6(): void;
    by(): number[];
    b9(): void;
    b8(a: () => void): void;
    protected a6(a: RenderingContext, b: boolean): void;
    b1(a: Color, b: Color): boolean;
    b7(): void;
    al(a: any): void;
}
