import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IShortPeriodLongPeriod } from "./IShortPeriodLongPeriod";
import { IndicatorDisplayType } from "./IndicatorDisplayType";
import { IndicatorCalculationStrategy } from "./IndicatorCalculationStrategy";
import { Type } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class MovingAverageConvergenceDivergenceIndicator extends StrategyBasedIndicator implements IShortPeriodLongPeriod {
    static $t: Type;
    protected get_to(): IndicatorDisplayType;
    constructor();
    protected get_uh(): IndicatorCalculationStrategy;
    protected get uh(): IndicatorCalculationStrategy;
    protected get_uu(): Type;
    protected get uu(): Type;
    get shortPeriod(): number;
    set shortPeriod(a: number);
    static readonly u5: DependencyProperty;
    protected up(): number;
    get longPeriod(): number;
    set longPeriod(a: number);
    static readonly u4: DependencyProperty;
    protected um(): number;
    get signalPeriod(): number;
    set signalPeriod(a: number);
    static readonly u6: DependencyProperty;
    protected tx(): number;
}
