import { ScatterTriangulationSeries } from "./ScatterTriangulationSeries";
import { ColorScale } from "./ColorScale";
import { Type, Point } from "igniteui-angular-core";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { RenderSurface } from "./RenderSurface";
import { SeriesView } from "./SeriesView";
import { WriteableBitmap } from "igniteui-angular-core";
import { TriangleRasterizer } from "./TriangleRasterizer";
import { ScalerParams } from "./ScalerParams";
import { ObservableColorCollection } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class ScatterAreaSeries extends ScatterTriangulationSeries {
    static $t: Type;
    protected get_dd(): boolean;
    constructor();
    private rz;
    get r1(): ColorScale;
    set r1(a: ColorScale);
    private si;
    hw(a: any, b: string): any;
    sd: string;
    private r4;
    private get r5();
    private set r5(value);
    protected get_e3(): boolean;
    protected set_e3(a: boolean): void;
    protected l4(a: any, b: string, c: any, d: any): void;
    mj(a: boolean): void;
    mh(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    protected sj(a: SeriesView): void;
    private sg;
    ht(a: Point): any;
    protected rx: number[];
    protected ry: number[];
    r3(a: SeriesView, b: ScalerParams, c: ScalerParams): TriangleRasterizer;
    protected r6(): ObservableColorCollection;
    r0: ColorScale;
    sk(): void;
    protected mw(): void;
    kx(a: boolean, b: SeriesView): void;
    protected bx(): SeriesView;
    lz(a: SeriesView): void;
    r2: ScatterAreaSeriesView;
    sh(a: any): void;
    r9: string;
    sb: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ScatterAreaSeriesView extends SeriesView {
    static $t: Type;
    private b1;
    private bx;
    get b0(): number[];
    set b0(a: number[]);
    constructor(a: ScatterAreaSeries);
    ca(a: number, b: number): void;
    b6(a: any): void;
    private b5;
    private b4;
    private b3;
    by(): number[];
    bz(a: boolean): number[];
    private b9;
    b2(a: Rect, b: ColorScale, c: IFastItemColumn$1<number>): TriangleRasterizer;
    b8(a: TriangleRasterizer): void;
    b7(): void;
    protected a6(a: RenderingContext, b: boolean): void;
    cb(a: WriteableBitmap): void;
    al(a: any): void;
    getDefaultTooltipTemplate(): string;
}
