import { Series } from "./Series";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { IEnumerable, Type } from "igniteui-angular-core";
import { NumericXAxis } from "./NumericXAxis";
import { NumericYAxis } from "./NumericYAxis";
import { IFastItemsSource } from "igniteui-angular-core";
import { TriangulationStatusEventArgs } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { Rect } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
/**
 * @hidden
 */
export declare abstract class ScatterTriangulationSeries extends Series {
    static $t: Type;
    ku(): void;
    q6: string;
    hw(a: any, b: string): any;
    re: string;
    private qb;
    protected get qh(): IFastItemColumn$1<number>;
    protected set qh(a: IFastItemColumn$1<number>);
    private qc;
    protected get qi(): IFastItemColumn$1<number>;
    protected set qi(a: IFastItemColumn$1<number>);
    p4: NumericXAxis;
    p5: NumericYAxis;
    private qk;
    mj(a: boolean): void;
    private ri;
    private rg;
    private p7;
    triangulationStatusChanged: (sender: any, args: TriangulationStatusEventArgs) => void;
    private rj;
    protected qd(a: IFastItemsSource, b: string): IFastItemColumn$1<number>;
    protected l4(a: any, b: string, c: any, d: any): void;
    qm(a: any): boolean;
    ql(a: any): boolean;
    e9(a: Rect, b: Rect, c: SeriesView): boolean;
    private rh;
    private qn;
    lf(): void;
    protected k0(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    ap(a: Axis): AxisRange;
    protected m6(a: Rect, b: Rect): void;
    protected m5(a: Rect, b: Rect): void;
    trianglesSource: IEnumerable;
    qj: IFastItemsSource;
    qu: string;
    qw: string;
    qy: string;
    private p8;
    protected get qe(): IFastItemColumn$1<number>;
    protected set qe(a: IFastItemColumn$1<number>);
    private p9;
    protected get qf(): IFastItemColumn$1<number>;
    protected set qf(a: IFastItemColumn$1<number>);
    private qa;
    protected get qg(): IFastItemColumn$1<number>;
    protected set qg(a: IFastItemColumn$1<number>);
    protected get_ed(): boolean;
    protected get_d2(): boolean;
    q2: string;
    ra: string;
    q4: string;
    rc: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    static $$p: string[];
}
