import { Series } from "./Series";
import { DependencyObject } from "igniteui-angular-core";
import { HighlightingInfo } from "./HighlightingInfo";
import { ShapeItemSearchMode } from "./ShapeItemSearchMode";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { Point, Type } from "igniteui-angular-core";
import { NumericXAxis } from "./NumericXAxis";
import { NumericYAxis } from "./NumericYAxis";
import { List$1 } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { StyleShapeEventArgs } from "./StyleShapeEventArgs";
import { Axis } from "./Axis";
import { FrameworkElement } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { Marker } from "./Marker";
import { Tuple$2 } from "igniteui-angular-core";
import { ShapeHitRegion } from "./ShapeHitRegion";
import { AssigningShapeStyleEventArgs } from "./AssigningShapeStyleEventArgs";
import { AssigningShapeMarkerStyleEventArgs } from "./AssigningShapeMarkerStyleEventArgs";
import { FlattenedShape } from "./FlattenedShape";
import { SeriesView } from "./SeriesView";
import { RenderSurface } from "./RenderSurface";
import { Dictionary$2 } from "igniteui-angular-core";
import { AssigningSeriesShapeStyleEventArgsBase } from "./AssigningSeriesShapeStyleEventArgsBase";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { Shape } from "igniteui-angular-core";
import { AssigningSeriesStyleEventArgsBase } from "./AssigningSeriesStyleEventArgsBase";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { Style } from "igniteui-angular-core";
import { StyleSelector } from "./StyleSelector";
import { Path } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { PointCollection } from "igniteui-angular-core";
import { PathGeometry } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class ShapeSeriesBase extends Series {
    static $t: Type;
    constructor();
    ku(): void;
    ag(): Axis[];
    hw(a: any, b: string): any;
    q5: boolean;
    q4: boolean;
    protected qx: boolean;
    protected qw: boolean;
    protected get_dx(): boolean;
    private qi;
    private qj;
    protected get_c2(): boolean;
    protected qg(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected qh(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    private qo;
    get qp(): ShapeItemSearchMode;
    set qp(a: ShapeItemSearchMode);
    protected qq(): ShapeItemSearchMode;
    qr: ShapeItemSearchMode;
    rn: number;
    rm: number;
    f5(a: Point): number;
    private p8;
    private p9;
    protected r3(a: Point): Tuple$2<number, Point>;
    private r2;
    protected get_qy(): boolean;
    protected get qy(): boolean;
    private r1;
    protected ri(a: Point): number;
    pm(a: Point, b: boolean, c: boolean): Point;
    ht(a: Point): any;
    protected qf(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    aw(a: any, b: Point, c: boolean): HighlightingInfo;
    ax(a: any, b: Point, c: boolean): HighlightingInfo;
    assigningShapeStyle: (sender: any, args: AssigningShapeStyleEventArgs) => void;
    assigningShapeMarkerStyle: (sender: any, args: AssigningShapeMarkerStyleEventArgs) => void;
    protected rb(): boolean;
    protected ra(): boolean;
    protected qs: ShapeSeriesRenderManager;
    rx: string;
    private qu;
    get qv(): IFastItemColumn$1<any>;
    set qv(a: IFastItemColumn$1<any>);
    ql: NumericXAxis;
    qn: NumericYAxis;
    private q2;
    private static q6;
    private convertToListList;
    protected cj(a: string): IFastItemColumn$1<any>;
    protected l4(a: any, b: string, c: any, d: any): void;
    protected q9(): boolean;
    protected q8(): boolean;
    q0(a: any): boolean;
    qz(a: any): boolean;
    private qk;
    private qm;
    private rh;
    rd: List$1<Rect>;
    private sc;
    private sp;
    private rf;
    private p5;
    private p7;
    private p6;
    private p4;
    protected get_q3(): boolean;
    protected get q3(): boolean;
    protected rc(): boolean;
    mj(a: boolean): void;
    mh(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    protected sb(a: SeriesView): void;
    protected r7(a: FrameworkElement, b: boolean, c: number, d: number, e: boolean, f: boolean): void;
    protected r6(a: number, b: number, c: boolean): void;
    protected r9(a: AssigningShapeStyleEventArgs): void;
    protected r8(a: AssigningShapeMarkerStyleEventArgs): void;
    qa(a: number, b: number): any[];
    protected qb(a: number, b: number): any[];
    private static sa;
    lf(): void;
    protected m6(a: Rect, b: Rect): void;
    protected m5(a: Rect, b: Rect): void;
    protected k0(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    e9(a: Rect, b: Rect, c: SeriesView): boolean;
    protected get_q7(): boolean;
    protected get q7(): boolean;
    lz(a: SeriesView): void;
    private qt;
    private rg;
    private qe;
    private r4;
    so: Rect;
    private se;
    kx(a: boolean, b: SeriesView): void;
    private r5;
    private sd;
    at(a: Point, b: boolean): DataContext;
    ro(a: number): any;
    protected get_e3(): boolean;
    protected set_e3(a: boolean): void;
    rj: number;
    rk: number;
    ap(a: Axis): AxisRange;
    protected get_ed(): boolean;
    protected get_d2(): boolean;
    get q1(): boolean;
    sq(a: any, b: DependencyObject, c: Style): Style;
    styleShape: (sender: any, e: StyleShapeEventArgs) => void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ShapeSeriesRenderManager extends SeriesRenderManager {
    static $t: Type;
    protected c(): AssigningSeriesStyleEventArgsBase;
    protected a(): AssigningSeriesShapeStyleEventArgsBase;
    au: AssigningShapeMarkerStyleEventArgs;
    av: AssigningShapeStyleEventArgs;
    az(a: Shape, b: number, c: boolean): void;
    aw(a: ShapeSeriesBase, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    ax(a: Series, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    ay(a: AssigningSeriesStyleEventArgsBase, b: number, c: number, d: boolean): void;
}
/**
 * @hidden
 */
export declare abstract class ShapeSeriesViewBase extends SeriesView {
    static $t: Type;
    constructor(a: ShapeSeriesBase);
    b9: Dictionary$2<number, FlattenedShape>;
    b1(a: Point): Marker;
    get cb(): List$1<ShapeHitRegion>;
    protected b5(): Pool$1<FrameworkElement>;
    b8(a: Rect): boolean;
    static cc(a: List$1<FlattenedShape>): List$1<PointCollection>;
    get b7(): boolean;
    protected b3: ShapeSeriesBase;
    private ca;
    cf(a: number, b: any, c: Rect, d: List$1<FlattenedShape>): void;
    protected c1(a: number, b: any): FrameworkElement;
    protected abstract ch(a: FrameworkElement, b: PathGeometry): void;
    static ci(a: ShapeSeriesViewBase, b: Path, c: any): void;
    cm(a: (arg1: FrameworkElement) => void): void;
    cj(a: FrameworkElement, b: any, c: boolean): void;
    protected cl(a: FrameworkElement, b: boolean): void;
    private cg;
    private cu;
    protected abstract c2(a: number, b: List$1<PointCollection>): PathGeometry;
    cr(): void;
    cq(): void;
    private ce;
    ct(a: number, b: number): void;
    ck(): void;
    protected cd: List$1<Path>;
    cy(): FrameworkElement;
    cn(a: FrameworkElement): void;
    co(a: FrameworkElement): void;
    cp(a: FrameworkElement): void;
    protected b6: Pool$1<FrameworkElement>;
    c3(a: number, b: List$1<PointCollection>, c: boolean): PathGeometry;
    protected ac(a: number): any;
    private c4;
    protected ab(a: number): any;
    protected a6(a: RenderingContext, b: boolean): void;
    private b4;
    private c5;
    get c6(): Style;
    cw(a: StyleSelector): void;
    cv(a: Style): void;
    cz(a: Point, b: boolean): FrameworkElement;
    c0(a: Point, b: boolean, c: boolean): FrameworkElement;
    b2(a: Point, b: boolean, c: boolean): ShapeHitRegion;
    private by;
    private b0;
    private bz;
    private bx;
    cs(a: number[], b: number[], c: number[], d: number[]): void;
    cx(): void;
    al(a: any): void;
}
