import { AnchoredCategorySeries } from "./AnchoredCategorySeries";
import { NumericXAxis } from "./NumericXAxis";
import { CategoryYAxis } from "./CategoryYAxis";
import { IVerticalAnchoredCategorySeriesInteractionManager } from "./IVerticalAnchoredCategorySeriesInteractionManager";
import { Type, Point } from "igniteui-angular-core";
import { SeriesPlotAreaMarginHorizontalMode } from "./SeriesPlotAreaMarginHorizontalMode";
import { Axis } from "./Axis";
import { SeriesPlotAreaMarginVerticalMode } from "./SeriesPlotAreaMarginVerticalMode";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericAxisBase } from "./NumericAxisBase";
import { ScalerParams } from "./ScalerParams";
import { AxisRange } from "./AxisRange";
import { Rect } from "igniteui-angular-core";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
/**
 * @hidden
 */
export declare abstract class VerticalAnchoredCategorySeries extends AnchoredCategorySeries {
    static $t: Type;
    xAxis: NumericXAxis;
    yAxis: CategoryYAxis;
    bv(): SeriesPlotAreaMarginHorizontalMode;
    bw(): SeriesPlotAreaMarginVerticalMode;
    ku(): void;
    private up;
    get uq(): IVerticalAnchoredCategorySeriesInteractionManager;
    protected get_isVertical(): boolean;
    ro(): CategoryAxisBase;
    r9(): NumericAxisBase;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    hh(a: Point, b: boolean): number;
    hj(a: Point, b: boolean): number;
    f3(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    aq(a: Rect): AxisRange;
    protected bp(): SeriesHitTestMode;
    px(a: Point): Rect;
    private uy;
    ev(a: Point, b: boolean): boolean;
    gj(a: Point, b: boolean, c: boolean): number;
    pm(a: Point, b: boolean, c: boolean): Point;
    fetchXAxis(): Axis;
    fetchYAxis(): Axis;
    t4(a: Axis): void;
    t5(a: Axis): void;
    sj(): boolean;
    ri(a: number, b: number): any[];
    f5(a: Point): number;
    sn(a: Point): number;
    hd(a: Point): number;
    ht(a: Point): any;
    protected l4(a: any, b: string, c: any, d: any): void;
    ut(a: any): boolean;
    us(a: any): boolean;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
